package u8c.ui.mm.action;
import nc.ui.hr.frame.action.QueryAction;
import nc.ui.hr.global.Global;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.bs.pub.billcodemanage.BillcodeGenerater;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.itf.uap.pf.IplatFormEntry;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.md.data.access.NCObject;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.UIDialog;
import nc.vo.DemandUAPBVO;
import nc.vo.OnhandunmUAPVO;
import nc.vo.OperationBalanceVO;
import nc.vo.OperationDemandVO;
import nc.vo.OperationMainVO;
import nc.vo.OperationPurchaseVO;
import nc.vo.OperationSupplyVO;
import nc.vo.OperationTransferVO;
import nc.vo.OrderIssueUAPVO;
import nc.vo.ic.pub.bill.SpecialBillHeaderVO;
import nc.vo.ic.pub.bill.SpecialBillItemVO;
import nc.vo.ic.pub.bill.SpecialBillVO;
import nc.vo.pr.pray.PraybillHeaderVO;
import nc.vo.pr.pray.PraybillItemVO;
import nc.vo.pr.pray.PraybillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.ISuperVO;
import nc.vo.pub.ValidationException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
import u8c.ui.mm.panel.OperationTestUI;

/**
 * MRP运算清单-运算按钮
 *@Author: ZTH
 *@Date:2023年11月14日 下午3:19:50
 *@Version: V1.0
 */

public class YsAction extends YsQuseryAction{
	private static final ResultSetProcessor MapListProcessor = null;
	private OperationTestUI operframui=null;
	private IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private IVOPersistence ivo = NCLocator.getInstance().lookup(IVOPersistence.class);
	private IplatFormEntry iIplatFormEntry = (IplatFormEntry)NCLocator.getInstance().lookup(IplatFormEntry.class.getName());
	public YsAction(FrameUI frameUI1) {
		super(frameUI1);
		this.operframui = (OperationTestUI) frameUI1;
	}

	public void execute() throws Exception {
	    //查询数据弹框
		Boolean iscancel=Boolean.FALSE;
		MRPDialogdura dialog = new MRPDialogdura(ClientEnvironment.getInstance().getUser().getPrimaryKey(),
				 ClientEnvironment.getInstance().getCorporation().getPk_corp(),iscancel);
		dialog.show();
		
	   
		if(dialog.dg_iscancel) {
			String butype = dialog.getButype();//业务类型下拉--- 家装\工装
			String xmname = dialog.getXmname();//项目主键
			List<OperationSupplyVO> supplyvos=new ArrayList<OperationSupplyVO>();
			
			/**
			 * 
			 * 查询生产总订单和材料采购单数据生成
			 * 
			 * 需求页签
			 * 
			 */
			String pk_operation="";//单据主键
			if("工装".equals(butype)) {
				//查询生产总订单材料明细不是委外的数据
				String sqlmmpac="select a.dbilldate demanddate ,b.* from  mmpac_order_issue b "
						+ "inner join mmpac_order_main a on  a.pk_order=b.pk_order "
						+ "and isnull(a.dr,0)=0 and isnull(b.dr,0)=0 and isnull(b.bdef3,'N')='N' "
						+ "and a.projectid='" + xmname + "' and a.busitype='" + butype + "' and a.billstatus='1' ";
				
				List<OrderIssueUAPVO> lisvos= (List<OrderIssueUAPVO>) iuap.executeQuery(sqlmmpac, new BeanListProcessor(OrderIssueUAPVO.class));
				
				//查询材料采购单的数据
				String sqlxc="select  a.dbilldate demanddate,b.* from  po_demand_b b "
						+ "inner join po_demand a on  a.pk_demand=b.pk_demand "
						+ "and isnull(a.dr,0)=0 and isnull(b.dr,0)=0  "
						+ "and a.projectid='" + xmname + "' and a.vdef30='" + butype + "' and a.billstatus='1' and a.billstatus<>'9' ";
				
				List<DemandUAPBVO> lisdemvos= (List<DemandUAPBVO>) iuap.executeQuery(sqlxc, new BeanListProcessor(DemandUAPBVO.class));
				String vbillcode=new BillcodeGenerater().getBillCode("MM01", PubEnv.getPk_corp(), null, null);
				List<OperationDemandVO> demandvos=new ArrayList<OperationDemandVO>();
				
				if((null!=lisvos && lisvos.size()>0) || (null!=lisdemvos && lisdemvos.size()>0)) {
					OperationMainVO opmainvo=new OperationMainVO();
					opmainvo.setBillmaker(ClientEnvironment.getInstance().getUser().getPrimaryKey());
					opmainvo.setDbilldate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
					opmainvo.setBusitype(butype);
					opmainvo.setBillstatus(8);
					opmainvo.setPk_corp(PubEnv.getCorpCode());
					opmainvo.setProjectid(xmname);
					opmainvo.setVbillcode(vbillcode);
					pk_operation=ivo.insertVO(opmainvo);
					
					/********************************生成【需求】页签数据-begin*********************************************/

				try{	
					if(null!=lisvos && lisvos.size()>0) {
						for(OrderIssueUAPVO vo : lisvos) {
							OperationDemandVO demandvo=new OperationDemandVO();
							for (String name : demandvo.getAttributeNames()) {
								if("ts".equals(name)||"execnum".equals(name)) {
									continue;
								}else if("pk_operation".equals(name)) {
									demandvo.setAttributeValue(name, pk_operation);
								}else if("demandtyoe".equals(name)) {
									demandvo.setAttributeValue(name, "生产总订单");
								}else {
									demandvo.setAttributeValue(name, vo.getAttributeValue(name));
								}
								
							}
							demandvos.add(demandvo);
						}
					}
			
					if(null!=lisdemvos && lisdemvos.size()>0) {
						for(DemandUAPBVO vo:lisdemvos) {
							OperationDemandVO demandvo=new OperationDemandVO();
							for (String name : demandvo.getAttributeNames()) {
								if("ts".equals(name)||"execnum".equals(name)) {
									continue;
								}else if("pk_operation".equals(name)) {
									demandvo.setAttributeValue(name, pk_operation);
								}else if("demandtyoe".equals(name)) {
									demandvo.setAttributeValue(name, "材料采购单");
								}else {
									demandvo.setAttributeValue(name, vo.getAttributeValue(name));
								}
							}
							demandvos.add(demandvo);
						}
						
					}
				
						ivo.insertVOList(demandvos);
					}catch(Exception e) {
						ivo.deleteByPK(OperationMainVO.class,pk_operation);
						throw new  ValidationException(e.getMessage());
					}
					/********************************生成【需求】页签数据-end*********************************************/	
				
					
				}else {
					throw new ValidationException("生产总订单和材料采购单没有符合条件的数据!");
				}
				
			
				
				/**
				 * 供应页签
				 * 
				 */
			try{
				//查询需求页签的物料
				List<String> liswlcodes=new ArrayList<String>();
				for(OperationDemandVO vo:demandvos) {
					liswlcodes.add(vo.getCmaterialcode());
				}
				List<String> pkwls=getInvbasdocValue2(liswlcodes);//物料主键集合
				
				//工装：1.先查询工装库：项目=批次号
				SqlBuilder sqlbuildWL=new SqlBuilder();
				
				String sqlic_onhandnum="select  vlot,cwarehouseid,cinventoryid,cinvbasid,vfree1,vfree2,vfree3,vfree4,nonhandnum "
						+ "from  ic_onhandnum where "
					//	+ "vlot =(select jobcode from  bd_jobbasfil where pk_jobbasfil='" + xmname + "' ) and "
						+ "cwarehouseid= (select pk_stordoc  from  bd_stordoc "
						+ "where storcode='GZ001') and  nonhandnum>0  and ";
				
				sqlbuildWL.append(sqlic_onhandnum);
				sqlbuildWL.append("cinvbasid", pkwls.toArray(new String[pkwls.size()]));
				
				
				List<OnhandunmUAPVO> lisonhandnums= (List<OnhandunmUAPVO>) iuap.executeQuery(sqlbuildWL.toString(), new BeanListProcessor(OnhandunmUAPVO.class));
				for(OnhandunmUAPVO vo:lisonhandnums) {
					OperationSupplyVO opernsupplyvo=new  OperationSupplyVO();
					opernsupplyvo.setSupplytype("库存量_工装库");//供应类型
					opernsupplyvo.setPrjcode(demandvos.get(0).getPrjcode());//项目主键
					opernsupplyvo.setPrjname(demandvos.get(0).getPrjname());//项目名称
					opernsupplyvo.setPrjtypecode((demandvos.get(0).getPrjtypecode()));//项目分类
					opernsupplyvo.setPrjtypename(demandvos.get(0).getPrjtypename());//项目分类名称
					opernsupplyvo.setVbatchcode(vo.getVlot());//批次
					opernsupplyvo.setCmaterialcode(getInvbasdocValue(vo.getCinvbasid(),"invcode"));//物料主键
					opernsupplyvo.setCmaterialname(getInvbasdocValue(vo.getCinvbasid(),"invname"));//物料名称
					opernsupplyvo.setSpec(getInvbasdocValue(vo.getCinvbasid(),"invspec"));//规格
					opernsupplyvo.setModel(getInvbasdocValue(vo.getCinvbasid(),"invtype"));//型号
					opernsupplyvo.setColor(vo.getVfree1());//颜色
					opernsupplyvo.setSizing(vo.getVfree3());//定尺
					opernsupplyvo.setAlloy(vo.getVfree2());//合金
					opernsupplyvo.setStandard(vo.getVfree4());//标准
					opernsupplyvo.setNum(new UFDouble(vo.getNonhandnum()));//数量
					opernsupplyvo.setVdef1(getStordocValue(vo.getCwarehouseid(),"storname"));//仓库名称
					opernsupplyvo.setPk_operation(pk_operation);//主表主键
					supplyvos.add(opernsupplyvo);
				//	liswlpls.add(vo.getCinvbasid());
				}
					
				//工装：2.公共库查询：没有项目的，根据物料去查询
				
				SqlBuilder sqlbuild=new SqlBuilder();
				String sqlonhandnum="select  vlot,cwarehouseid,cinventoryid,cinvbasid,vfree1,vfree2,vfree3,vfree4,nonhandnum "
						+ "from  ic_onhandnum  where cwarehouseid= (select pk_stordoc  from  bd_stordoc "
						+ "where storcode='GG003') and  nonhandnum>0 and  ";
				sqlbuild.append(sqlonhandnum);
				sqlbuild.append("cinvbasid", pkwls.toArray(new String[pkwls.size()]));
				
				List<OnhandunmUAPVO> lisonhandnums_gg= (List<OnhandunmUAPVO>) iuap.executeQuery(sqlbuild.toString(), new BeanListProcessor(OnhandunmUAPVO.class));
				
				for(OnhandunmUAPVO vo:lisonhandnums_gg) {
					OperationSupplyVO opernsupplyvo=new  OperationSupplyVO();
					opernsupplyvo.setSupplytype("库存量_公共库");//供应类型
//					opernsupplyvo.setPrjcode(demandvos.get(0).getPrjcode());//项目主键
//					opernsupplyvo.setPrjname(demandvos.get(0).getPrjname());//项目名称
//					opernsupplyvo.setPrjtypecode((demandvos.get(0).getPrjtypecode()));//项目分类
//					opernsupplyvo.setPrjtypename(demandvos.get(0).getPrjtypename());//项目分类名称
					opernsupplyvo.setVbatchcode(vo.getVlot());//批次
					opernsupplyvo.setCmaterialcode(getInvbasdocValue(vo.getCinvbasid(),"invcode"));//物料编码
					opernsupplyvo.setCmaterialname(getInvbasdocValue(vo.getCinvbasid(),"invname"));//物料名称
					opernsupplyvo.setSpec(getInvbasdocValue(vo.getCinvbasid(),"invspec"));//规格
					opernsupplyvo.setModel(getInvbasdocValue(vo.getCinvbasid(),"invtype"));//型号
					opernsupplyvo.setColor(vo.getVfree1());//颜色
					opernsupplyvo.setSizing(vo.getVfree3());//定尺
					opernsupplyvo.setAlloy(vo.getVfree2());//合金
					opernsupplyvo.setStandard(vo.getVfree4());//标准
					opernsupplyvo.setNum(new UFDouble(vo.getNonhandnum()));//数量
					opernsupplyvo.setVdef1(getStordocValue(vo.getCwarehouseid(),"storname"));//仓库名称
					opernsupplyvo.setPk_operation(pk_operation);//主表主键
					supplyvos.add(opernsupplyvo);
				}
					ivo.insertVOList(supplyvos);
					
			}catch(Exception e) {
				ivo.deleteByPK(OperationMainVO.class,pk_operation);
				ivo.deleteVOList(demandvos);
				throw new  ValidationException(e.getMessage());
			}
					
					
			/**
			 * 
			 * 供需平衡结果
			 * 
			 */
			List<OperationBalanceVO> bancevos=new ArrayList<OperationBalanceVO>();
			List<OperationBalanceVO> bancevoscgdd=new ArrayList<OperationBalanceVO>();
			List<OperationBalanceVO> bancevosdbdd=new ArrayList<OperationBalanceVO>();
			try {
				//查询需求页签数据
			    String sqlxq="select * from mm_operation_demand where pk_operation='"+pk_operation+"' and isnull(dr,0)=0 ";
				List<OperationDemandVO> lisopens=(List<OperationDemandVO>) iuap.executeQuery(sqlxq, new BeanListProcessor(OperationDemandVO.class));
				for(OperationDemandVO vo:lisopens) {
					OperationBalanceVO bancevo=new OperationBalanceVO();
					for(String name : bancevo.getAttributeNames()) {
						if("ts".equals(name)) {
							continue;
						}else if("demandtype".equals(name)) {
							bancevo.setDemandtype(vo.getDemandtyoe());//需求类型
						}else {
							bancevo.setAttributeValue(name, vo.getAttributeValue(name));
						}
						
					}
					
					bancevos.add(bancevo);
					
					//供应数据--查询供应页签数据库数据
					String gysqlw="select * from mm_operation_supply where pk_operation='"+pk_operation+"' and isnull(dr,0)=0 and cmaterialcode='"+bancevo.getCmaterialcode()+"' ";
					List<OperationSupplyVO> lissupplyvos=(List<OperationSupplyVO>) iuap.executeQuery(gysqlw, new BeanListProcessor(OperationSupplyVO.class));
					if(null!=lissupplyvos && lissupplyvos.size()>0) {
						OperationBalanceVO bancevo113=new OperationBalanceVO();//公共库VO
						OperationBalanceVO bancevo11=new OperationBalanceVO();//工装库VO
						OperationBalanceVO bancevo1144=new OperationBalanceVO();//公共库VO_还需采购
						//判断存货公共库和工装库是否都有
						Map<String,List<OperationSupplyVO>> map=new HashMap<String,List<OperationSupplyVO>>();
						for(OperationSupplyVO opersuplyvo:lissupplyvos) {
							if(null!=map.get(opersuplyvo.getSupplytype())&&map.get(opersuplyvo.getSupplytype()).size()>0) {
								List<OperationSupplyVO> oldmaplisvo=map.get(opersuplyvo.getSupplytype());
								oldmaplisvo.add(opersuplyvo);
								map.put(opersuplyvo.getSupplytype()/*供应类型*/,oldmaplisvo);
							}else {
								List<OperationSupplyVO> maplisvo=new ArrayList<OperationSupplyVO>();
								maplisvo.add(opersuplyvo);
								map.put(opersuplyvo.getSupplytype()/*供应类型*/, maplisvo);
							}
						}
						
						if(null!=map&&map.size()<2) {
							//说明只有一个库有此存货
							if("库存量_工装库".equals(lissupplyvos.get(0).getSupplytype())) {
								bancevo11.setSupplytype("库存量_工装库");//供应类型
								bancevo11.setWarehouse("工装库");//仓库
								UFDouble gysx=UFDouble.ZERO_DBL;
								List<OperationSupplyVO> lisgzvos=map.get("库存量_工装库");
								for(OperationSupplyVO gzvo:lisgzvos) {
									gysx=gysx.add(gzvo.getNum());//供应数量
								}
								bancevo11.setNum(gysx);//主数量
								if (bancevo.getNum().sub(gysx).compareTo(UFDouble.ZERO_DBL)<0) {
									//需求数量-供应数量<0
									bancevo11.setProexecutenum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo11.setMatchnum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo11.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								}else {
									//需求数量-供应数量>0
									bancevo1144=(OperationBalanceVO) bancevo11.clone();
									bancevo11.setProexecutenum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo11.setMatchnum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo11.setSurdenum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevoscgdd.add(bancevo11);
									//需要采购物料
									bancevo1144.setProexecute("采购");//建议执行
									bancevo1144.setProexecutenum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo1144.setMatchnum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo1144.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo1144.setPk_operation(pk_operation);
									
								}
								bancevo11.setPk_operation(pk_operation);
								bancevo113=(OperationBalanceVO) bancevo11.clone();
								bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
								bancevo11.setPrjname(bancevo.getPrjname());//项目名称
								bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
								bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
								bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
								bancevo11.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
								bancevo11.setCmaterialname(bancevo.getCmaterialname());//存货名称
								bancevo11.setSpec(bancevo.getSpec());//规格
								bancevo11.setModel(bancevo.getModel());//型号
								bancevo11.setColor(bancevo.getColor());//颜色
								bancevo11.setSizing(bancevo.getSizing());//定尺
								bancevo11.setAlloy(bancevo.getAlloy());//合金
								bancevo11.setStandard(bancevo.getStandard());//标准
								bancevo11.setWeight(bancevo.getWeight());//米重
								bancevo11.setUnitid(bancevo.getUnitid());//计量单位
								bancevo113.setSupplytype("库存量_公共库");//供应类型
								bancevo113.setWarehouse("公共库");//仓库
								bancevo113.setNum(UFDouble.ZERO_DBL);//主数量
								bancevo113.setProexecutenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
								bancevo113.setMatchnum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
								bancevo113.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								bancevos.add(bancevo11);	
								bancevos.add(bancevo1144);
								bancevos.add(bancevo113);
							}else {
								bancevo113.setSupplytype("库存量_公共库");//供应类型	
								bancevo113.setWarehouse("公共库");//仓库
//								bancevo113.setPrjcode(bancevo.getPrjcode());//项目编码
//								bancevo113.setPrjname(bancevo.getPrjname());//项目名称
//								bancevo113.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
//								bancevo113.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
//								bancevo113.setVbatchcode(bancevo.getVbatchcode());//批次
						
								UFDouble gysx=UFDouble.ZERO_DBL;
								List<OperationSupplyVO> lisggvos=map.get("库存量_公共库");
								for(OperationSupplyVO ggvo:lisggvos) {
									gysx=gysx.add(ggvo.getNmny());//供应数量
								}
								bancevo113.setNum(gysx);//主数量
								if (bancevo.getNum().sub(gysx).compareTo(UFDouble.ZERO_DBL)<0) {
									//需求数量-供应数量<0
									bancevo113.setProexecutenum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo113.setMatchnum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo113.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo113.setPk_operation(pk_operation);
									bancevo113.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
									bancevo113.setCmaterialname(bancevo.getCmaterialname());//存货名称
									bancevo11=(OperationBalanceVO) bancevo113.clone();
									bancevo113.setSpec(bancevo.getSpec());//规格
									bancevo113.setModel(bancevo.getModel());//型号
									bancevo113.setColor(bancevo.getColor());//颜色
									bancevo113.setSizing(bancevo.getSizing());//定尺
									bancevo113.setAlloy(bancevo.getAlloy());//合金
									bancevo113.setStandard(bancevo.getStandard());//标准
									bancevo113.setWeight(bancevo.getWeight());//米重
									bancevo113.setUnitid(bancevo.getUnitid());//计量单位
									bancevo113.setProexecute("转库");//建议执行
									bancevosdbdd.add(bancevo113);
									bancevo11.setSupplytype("库存量_工装库");//供应类型
									bancevo11.setWarehouse("工装库");//仓库
									bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
									bancevo11.setPrjname(bancevo.getPrjname());//项目名称
									bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
									bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
									bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
									bancevo11.setNum(UFDouble.ZERO_DBL);//主数量
									bancevo11.setProexecutenum(null);//建议执行数量
									bancevo11.setMatchnum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo11.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								}else {
									//需求数量-供应数量>0
									bancevo113.setProexecutenum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo113.setMatchnum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo113.setSurdenum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo113.setPk_operation(pk_operation);
									bancevo113.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
									bancevo113.setCmaterialname(bancevo.getCmaterialname());//存货名称
									bancevo113.setSpec(bancevo.getSpec());//规格
									bancevo113.setModel(bancevo.getModel());//型号
									bancevo113.setColor(bancevo.getColor());//颜色
									bancevo113.setSizing(bancevo.getSizing());//定尺
									bancevo113.setAlloy(bancevo.getAlloy());//合金
									bancevo113.setStandard(bancevo.getStandard());//标准
									bancevo113.setWeight(bancevo.getWeight());//米重
									bancevo113.setUnitid(bancevo.getUnitid());//计量单位
									bancevo11=(OperationBalanceVO) bancevo113.clone();
									bancevo113.setProexecute("转库");//建议执行
									bancevosdbdd.add(bancevo113);
									bancevo11.setSupplytype("库存量_工装库");//供应类型
									bancevo11.setWarehouse("工装库");//仓库
									bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
									bancevo11.setPrjname(bancevo.getPrjname());//项目名称
									bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
									bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
									bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
									bancevo11.setNum(UFDouble.ZERO_DBL);//主数量
									bancevo11.setProexecutenum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo11.setMatchnum(bancevo.getNum().sub(gysx).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo11.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo11.setProexecute("采购");//建议执行
									bancevoscgdd.add(bancevo11);
								}
								bancevos.add(bancevo113);	
								bancevos.add(bancevo11);	
							}
							
						}else {
							//公共库和工装库都有此存货
							/*********先查询用工装库*************/
							List<OperationSupplyVO> supplylisvos=map.get("库存量_工装库");
							bancevo11.setWarehouse("工装库");//仓库
							UFDouble gysx=UFDouble.ZERO_DBL;
							for(OperationSupplyVO supplylisvo :supplylisvos) {
								gysx=gysx.add(supplylisvo.getNum());//供应数量
							}
							bancevo11.setNum(gysx);//主数量
							if (bancevo.getNum().sub(gysx).compareTo(UFDouble.ZERO_DBL)<0) {
								//需求数量-供应数量<0
								bancevo11.setProexecutenum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
								bancevo11.setMatchnum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
								bancevo11.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								bancevo11.setPk_operation(pk_operation);
							//	bancevo113=(OperationBalanceVO) bancevo11.clone();
								bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
								bancevo11.setPrjname(bancevo.getPrjname());//项目名称
								bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
								bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
								bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
								bancevo11.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
								bancevo11.setCmaterialname(bancevo.getCmaterialname());//存货名称
								bancevo11.setSpec(bancevo.getSpec());//规格
								bancevo11.setModel(bancevo.getModel());//型号
								bancevo11.setColor(bancevo.getColor());//颜色
								bancevo11.setSizing(bancevo.getSizing());//定尺
								bancevo11.setAlloy(bancevo.getAlloy());//合金
								bancevo11.setStandard(bancevo.getStandard());//标准
								bancevo11.setWeight(bancevo.getWeight());//米重
								bancevo11.setUnitid(bancevo.getUnitid());//计量单位
//								bancevo113.setSupplytype("库存量_公共库");//供应类型
//								bancevo113.setWarehouse("公共库");//仓库
//								bancevo113.setNum(UFDouble.ZERO_DBL);//主数量
//								bancevo113.setProexecutenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
//								bancevo113.setMatchnum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
//								bancevo113.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								bancevos.add(bancevo11);
								
							}else {
								//需求数量-供应数量>0
								bancevo11.setPk_operation(pk_operation);
								bancevo11.setProexecutenum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
								bancevo11.setMatchnum(gysx.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
								UFDouble xyznum=bancevo.getNum().sub(gysx);//剩余需求主数量
								bancevo11.setSurdenum(xyznum.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
								bancevo11.setPrjcode(bancevo.getPrjcode());//项目编码
								bancevo11.setPrjname(bancevo.getPrjname());//项目名称
								bancevo11.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
								bancevo11.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
								bancevo11.setVbatchcode(bancevo.getVbatchcode());//批次
								bancevo11.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
								bancevo11.setCmaterialname(bancevo.getCmaterialname());//存货名称
								bancevo11.setSpec(bancevo.getSpec());//规格
								bancevo11.setModel(bancevo.getModel());//型号
								bancevo11.setColor(bancevo.getColor());//颜色
								bancevo11.setSizing(bancevo.getSizing());//定尺
								bancevo11.setAlloy(bancevo.getAlloy());//合金
								bancevo11.setStandard(bancevo.getStandard());//标准
								bancevo11.setWeight(bancevo.getWeight());//米重
								bancevo11.setUnitid(bancevo.getUnitid());//计量单位
								bancevo11.setSupplytype("库存量_工装库");//供应类型
								List<OperationSupplyVO> supplyvoggs=map.get("库存量_公共库");
								UFDouble gysxgg=UFDouble.ZERO_DBL;
								for(OperationSupplyVO supplyvogg :supplyvoggs) {
									 gysxgg=gysxgg.add(supplyvogg.getNum());//供应数量
								}
								
								if(gysxgg.sub(xyznum).compareTo(UFDouble.ZERO_DBL)>0) {
									bancevo113.setNum(gysxgg);//主数量
									bancevo113.setProexecutenum(xyznum.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo113.setMatchnum(xyznum.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo113.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo113.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
									bancevo113.setCmaterialname(bancevo.getCmaterialname());//存货名称
									bancevo113.setSpec(bancevo.getSpec());//规格
									bancevo113.setModel(bancevo.getModel());//型号
									bancevo113.setColor(bancevo.getColor());//颜色
									bancevo113.setSizing(bancevo.getSizing());//定尺
									bancevo113.setAlloy(bancevo.getAlloy());//合金
									bancevo113.setStandard(bancevo.getStandard());//标准
									bancevo113.setWeight(bancevo.getWeight());//米重
									bancevo113.setUnitid(bancevo.getUnitid());//计量单位
									bancevo113.setProexecute("转库");//建议执行
									bancevosdbdd.add(bancevo113);
									bancevo113.setSupplytype("库存量_公共库");//供应类型
									bancevo113.setWarehouse("公共库");//仓库
									bancevo113.setPk_operation(pk_operation);
									bancevos.add(bancevo11);
									bancevos.add(bancevo113);
									
								}else {
									bancevo113.setProexecutenum(gysxgg.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo113.setMatchnum(gysxgg.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo113.setSurdenum(xyznum.sub(gysxgg).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevo113.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
									bancevo113.setCmaterialname(bancevo.getCmaterialname());//存货名称
									bancevo113.setSpec(bancevo.getSpec());//规格
									bancevo113.setModel(bancevo.getModel());//型号
									bancevo113.setColor(bancevo.getColor());//颜色
									bancevo113.setSizing(bancevo.getSizing());//定尺
									bancevo113.setAlloy(bancevo.getAlloy());//合金
									bancevo113.setStandard(bancevo.getStandard());//标准
									bancevo113.setWeight(bancevo.getWeight());//米重
									bancevo113.setUnitid(bancevo.getUnitid());//计量单位
									bancevo113.setProexecute("转库");//建议执行
									bancevosdbdd.add(bancevo113);
									bancevo113.setSupplytype("库存量_公共库");//供应类型
									bancevo113.setWarehouse("公共库");//仓库
									bancevo113.setNum(gysxgg);//主数量
									bancevo113.setPk_operation(pk_operation);
									OperationBalanceVO bancevo114=(OperationBalanceVO) bancevo11.clone();
									bancevo114.setPk_operation(pk_operation);
									bancevo114.setNum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ));
									bancevo114.setProexecute("采购");//建议执行
									bancevoscgdd.add(bancevo114);
									bancevo114.setProexecutenum(xyznum.sub(gysxgg).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//建议执行数量
									bancevo114.setMatchnum(xyznum.sub(gysxgg).setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
									bancevo114.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
									bancevos.add(bancevo11);
									bancevos.add(bancevo113);
									bancevos.add(bancevo114);
								}
							    
								
							}
						}
						
						
					}else {
						OperationBalanceVO bancevo2=new OperationBalanceVO();
						bancevo2.setSupplytype("库存量_工装库");//供应类型
						bancevo2.setProexecute("采购");//建议执行
						bancevoscgdd.add(bancevo2);
						bancevo2.setPrjcode(bancevo.getPrjcode());//项目编码
						bancevo2.setPrjname(bancevo.getPrjname());//项目名称
						bancevo2.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
						bancevo2.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
						bancevo2.setVbatchcode(bancevo.getVbatchcode());//批次
						bancevo2.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
						bancevo2.setCmaterialname(bancevo.getCmaterialname());//存货名称
						bancevo2.setSpec(bancevo.getSpec());//规格
						bancevo2.setModel(bancevo.getModel());//型号
						bancevo2.setColor(bancevo.getColor());//颜色
						bancevo2.setSizing(bancevo.getSizing());//定尺
						bancevo2.setAlloy(bancevo.getAlloy());//合金
						bancevo2.setStandard(bancevo.getStandard());//标准
						bancevo2.setWeight(bancevo.getWeight());//米重
						bancevo2.setUnitid(bancevo.getUnitid());//计量单位
						bancevo2.setProexecutenum(bancevo.getNum().toString());//建议执行数量
						bancevo2.setWarehouse("工装库");//仓库
						bancevo2.setNum(UFDouble.ZERO_DBL);//主数量
						bancevo2.setMatchnum(bancevo.getNum().setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
						bancevo2.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
						bancevo2.setPk_operation(pk_operation);
						bancevos.add(bancevo2);	
						
						OperationBalanceVO bancevo3=new OperationBalanceVO();
						bancevo3.setSupplytype("库存量_公共库");//供应类型
//						bancevo3.setProexecute("采购");//建议执行
//						bancevo3.setPrjcode(bancevo.getPrjcode());//项目编码
//						bancevo3.setPrjname(bancevo.getPrjname());//项目名称
//						bancevo3.setPrjtypecode(bancevo.getPrjtypecode());//项目分类编码
//						bancevo3.setPrjtypename(bancevo.getPrjtypename());//项目分类名称
//						bancevo3.setVbatchcode(bancevo.getVbatchcode());//批次
//						bancevo3.setCmaterialcode(bancevo.getCmaterialcode());//存货编码
//						bancevo3.setCmaterialname(bancevo.getCmaterialname());//存货名称
//						bancevo3.setSpec(bancevo.getSpec());//规格
//						bancevo3.setModel(bancevo.getModel());//型号
//						bancevo3.setColor(bancevo.getColor());//颜色
//						bancevo3.setSizing(bancevo.getSizing());//定尺
//						bancevo3.setAlloy(bancevo.getAlloy());//合金
//						bancevo3.setStandard(bancevo.getStandard());//标准
//						bancevo3.setWeight(bancevo.getWeight());//米重
//						bancevo3.setUnitid(bancevo.getUnitid());//计量单位
//						bancevo3.setProexecutenum(bancevo.getNum().toString());//建议执行数量
						bancevo3.setWarehouse("公共库");//仓库
						bancevo3.setNum(UFDouble.ZERO_DBL);//主数量
						bancevo3.setMatchnum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//已匹配主数量
						bancevo3.setSurdenum(UFDouble.ZERO_DBL.setScale(2,UFDouble.ROUND_HALF_UP ).toString());//剩余需求主数量
						bancevo3.setPk_operation(pk_operation);
						bancevos.add(bancevo3);	
					}
				}
				
				ivo.insertVOList(bancevos);
			}catch(Exception e) {
				ivo.deleteByPK(OperationMainVO.class,pk_operation);
				ivo.deleteVOList(demandvos);
				ivo.deleteVOList(supplyvos);
				throw new  ValidationException(e.getMessage());
			}	
				/**
				 * 
				 * 采购需求  bancevoscgdd
				 * 生成请购单
				 * 
				 */
			
			try {
				if(null!=bancevoscgdd && bancevoscgdd.size()>0) {
					OperationPurchaseVO[] purchasevos=new OperationPurchaseVO[bancevoscgdd.size()];
					int flg=0;
					for(OperationBalanceVO cgdd : bancevoscgdd) {
						OperationPurchaseVO vo=new OperationPurchaseVO();
						vo.setPrjcode(cgdd.getPrjcode());
						vo.setPrjname(cgdd.getPrjname());
						vo.setPrjtypecode(cgdd.getPrjtypecode());
						vo.setPrjtypename(cgdd.getPrjtypename());
						vo.setVbatchcode(cgdd.getVbatchcode());
						vo.setWarehouse(cgdd.getWarehouse());
						vo.setCmaterialcode(cgdd.getCmaterialcode());
						vo.setCmaterialname(cgdd.getCmaterialname());
						vo.setSpec(cgdd.getSpec());
						vo.setModel(cgdd.getModel());
						vo.setColor(cgdd.getColor());
						vo.setSizing(cgdd.getSizing());
						vo.setAlloy(cgdd.getAlloy());
						vo.setStandard(cgdd.getStandard());
						vo.setWeight(cgdd.getWeight());
						vo.setNum(new UFDouble(cgdd.getProexecutenum()));
						vo.setNprice(cgdd.getNprice());
						vo.setNmny(cgdd.getNmny());
						vo.setPk_operation(pk_operation);
						purchasevos[flg]=vo;
						flg+=1;
					}
					
					PraybillHeaderVO header = new PraybillHeaderVO();
					PraybillItemVO[] items = new PraybillItemVO[bancevoscgdd.size()];
					// 表头赋值
					header.setPk_corp(PubEnv.getCorpCode());//公司
					header.setCoperator(ClientEnvironment.getInstance().getUser().getPrimaryKey());//制单人
					header.setDpraydate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));//请购日期-->制单日期
					header.setIbillstatus(0);//单据状态
//					header.setCpraypsn("1001V510000000000292");//请购人id-->业务员
//					header.setCdeptid("1001V510000000000276");//请购部门id-->计划部门
					header.setVmemo(vbillcode);//备注
					header.setDr(0);
					header.setCaccountyear(String.valueOf(new UFDate().getYear()));//年份
					header.setIpraysource(5);//请购来源
					header.setIpraytype(2);//请购类型
					int fg=0;
					for(OperationBalanceVO cgdd : bancevoscgdd) {
						PraybillItemVO praybillItemVO = new PraybillItemVO();
						praybillItemVO.setPk_corp(PubEnv.getCorpCode()); // 公司
						// 表体赋值
						praybillItemVO.setCmangid(getCmangchid(getCmangid(cgdd.getCmaterialcode()))); //存货编码
						praybillItemVO.setCbaseid(getCmangid(cgdd.getCmaterialcode())); //存货基础ID 
						praybillItemVO.setNpraynum(new UFDouble(cgdd.getMatchnum())); //数量
						String cprojectid = "";//项目id
						if(cgdd.getPrjcode().startsWith("1001")) {
							cprojectid = cgdd.getPrjcode();
						}
						else {
							cprojectid = getprojectid(cgdd.getPrjcode());
						}
						praybillItemVO.setCprojectid(cprojectid);
//						praybillItemVO.setCassistunit(demandBVO.getCastunitid());//辅助计量单位
//						praybillItemVO.setNassistnum(new UFDouble(demandBVO.getNastnum()));//辅计量数量
//						praybillItemVO.setVproducenum(cgdd.getVbatchcode());//批次号
						praybillItemVO.setDdemanddate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
						praybillItemVO.setDsuggestdate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
//						praybillItemVO.setPk_purcorp(PubEnv.getCorpCode());
						praybillItemVO.setPk_reqcorp(PubEnv.getCorpCode());
						
						items[fg] = praybillItemVO;
						fg+=1;
					}
					
					PraybillVO vo = new PraybillVO();
					vo.setParentVO(header);
					vo.setChildrenVO(items);
					iIplatFormEntry.processAction("SAVEBASE", "20", vo.getHeadVO().getDpraydate().toString(), null, vo, null, null);
					ivo.insertVOArray(purchasevos);
					
					
				}
				
			}catch(Exception e) {
				ivo.deleteByPK(OperationMainVO.class,pk_operation);
				ivo.deleteVOList(demandvos);
				ivo.deleteVOList(supplyvos);
				ivo.deleteVOList(bancevos);
				throw new  ValidationException(e.getMessage());
			}	

				/**
				 * 
				 * 委外需求--不做
				 * 
				 */
				
				/**
				 * 
				 * 转库需求
				 * bancevosdbdd
				 * 生成转库单--ic_special_h 
				 */
			try {
				if(null!=bancevosdbdd &&  bancevosdbdd.size()>0) {
					OperationTransferVO[] purchasevos_zk=new OperationTransferVO[bancevosdbdd.size()];
					int flgzk=0;
					for(OperationBalanceVO cgdd : bancevosdbdd) {
						OperationTransferVO vozk=new OperationTransferVO();
						vozk.setOutprjcode(cgdd.getPrjcode());
						vozk.setOutprjname(cgdd.getPrjname());
						vozk.setOutprjtypecode(cgdd.getPrjtypecode());
						vozk.setOutprjtypename(cgdd.getPrjtypename());
						vozk.setOutvbatchcode(cgdd.getVbatchcode());
						vozk.setCmaterialcode(cgdd.getCmaterialcode());
						vozk.setCmaterialname(cgdd.getCmaterialname());
						vozk.setOutwarehouse("公共库");//转出仓库
						vozk.setInwarehouse("工装库");//转入仓库
						vozk.setSpec(cgdd.getSpec());
						vozk.setModel(cgdd.getModel());
						vozk.setColor(cgdd.getColor());
						vozk.setSizing(cgdd.getSizing());
						vozk.setAlloy(cgdd.getAlloy());
						vozk.setStandard(cgdd.getStandard());
						vozk.setWeight(cgdd.getWeight());
						vozk.setNum(new UFDouble(cgdd.getProexecutenum()));
						vozk.setNprice(cgdd.getNprice());
						vozk.setNmny(cgdd.getNmny());
						vozk.setPk_operation(pk_operation);
						purchasevos_zk[flgzk]=vozk;
						flgzk+=1;
					}
					
					
					SpecialBillVO aggvo=new  SpecialBillVO();
					SpecialBillHeaderVO headvo=new SpecialBillHeaderVO();
					headvo.setCbilltypecode("4K");
					headvo.setCinwarehouseid("1001V51000000000039Z");//入库仓库ID  工装
					headvo.setCoperatorid(ClientEnvironment.getInstance().getUser().getPrimaryKey());
					headvo.setCoutwarehouseid("1001V5100000000003A1");//出库仓库ID  家装
					headvo.setCshlddiliverdate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
					headvo.setDbilldate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
					headvo.setFbillflag(2);
					headvo.setIcheckmode(4);
					headvo.setIPrintCount(0);
					headvo.setPk_corp(PubEnv.getCorpCode());
					headvo.setVshldarrivedate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString())); 
					SpecialBillItemVO[] billitems =new SpecialBillItemVO[bancevosdbdd.size()];
					for(int i=0 ; i< bancevosdbdd.size() ;i++) {
						OperationBalanceVO vo=bancevosdbdd.get(i);
						SpecialBillItemVO billitem =new SpecialBillItemVO();
						billitem.setCinventoryid(getCmangchid(getCmangid(vo.getCmaterialcode())));
						billitem.setDshldtransnum(new UFDouble(vo.getMatchnum()));
						billitems[i]=billitem;
					}
					aggvo.setParentVO(headvo);
					aggvo.setChildrenVO(billitems);
					iIplatFormEntry.processAction( "WRITE", "4K",null, null, aggvo, null, null);
					ivo.insertVOArray(purchasevos_zk);
				}
			}catch(Exception e) {
				ivo.deleteByPK(OperationMainVO.class,pk_operation);
				ivo.deleteVOList(demandvos);
				ivo.deleteVOList(supplyvos);
				ivo.deleteVOList(bancevos);
				throw new  ValidationException(e.getMessage());
			}	
	
			}else {
				
				//家装
				
				
			}
			
			
			getDataModel().setExtraCondition(" and pk_corp = '" + Global.getCorpPK() + "'"+" and pk_operation=  '" + pk_operation + "'"   );
			
			super.execute();
			
		}
		
	}
	
	
	//项目id
    public  String getprojectid(String prjcode) throws Exception {
        String sql = "select pk_jobbasfil from bd_jobbasfil where jobcode ='"+prjcode+"' and isnull(dr,0) = 0";
        String pk_jobbasfil = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_jobbasfil == null) {
            return "";
        }
        return pk_jobbasfil;
    }
	
    /**
	 * 根据物料code查询主键
	 * @param code
	 * @return
	 * @throws BusinessException
	 */
	public String getCmangid(String code) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invbasdoc from bd_invbasdoc" + " where invcode  ='" + code + "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + code);
		}
		return cmangid;
	}

	 /**
		 * 存货管理档案
		 * @param code
		 * @return
		 * @throws BusinessException
		 */
	public String getCmangchid(String pk_invbasdoc) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invmandoc from bd_invmandoc" + " where pk_invbasdoc  ='" + pk_invbasdoc + "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + pk_invbasdoc);
		}
		return cmangid;
	}
	
	
	
    //物料
    public  String getInvbasdocValue(String pk_invbasdoc,String param) throws Exception {
        String sql = "select invcode,invname,invspec,invtype from bd_invbasdoc where pk_invbasdoc='"+pk_invbasdoc +"' and isnull(dr,0) = 0";
        String jobname = (String) iuap.executeQuery(sql, new ColumnProcessor(param));
        if (jobname == null) {
            return "";
        }
        return jobname;
    }
    
    //物料2-编码查询主键
    public  List<String> getInvbasdocValue2(List<String> liswlcodes) throws Exception {
    	SqlBuilder build=new SqlBuilder();
        String sql = "select pk_invbasdoc from bd_invbasdoc where isnull(dr,0) = 0 and ";
        build.append(sql);
        build.append("invcode", liswlcodes.toArray(new String[liswlcodes.size()])); 
        
        List<String> jobname = (List<String>) iuap.executeQuery(build.toString(), new ColumnListProcessor());
        if (jobname == null) {
            return null;
        }
        return jobname;
    }
    

    //仓库
    public  String getStordocValue(String pk_stordoc,String param) throws Exception {
        String sql = "select storcode,storname from bd_stordoc where pk_stordoc='"+pk_stordoc +"' and isnull(dr,0) = 0";
        String jobname = (String) iuap.executeQuery(sql, new ColumnProcessor(param));
        if (jobname == null) {
            return "";
        }
        return jobname;
    }
    
    
    
    
	
  }
