package u8c.ui.mm.datamodel;

import nc.bs.framework.common.NCLocator;
import nc.ui.hr.frame.bill.manage.ManageDataModel;
import nc.ui.hr.frame.persistence.PersitenceDelegator;
import nc.vo.OperationBalanceVO;
import nc.vo.OperationDemandVO;
import nc.vo.OperationMainVO;
import nc.vo.OperationOutsourceVO;
import nc.vo.OperationPurchaseVO;
import nc.vo.OperationSupplyVO;
import nc.vo.OperationTransferVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.pub.BusinessException;
import u8c.itf.mm.IOperationInfo;


public class OperationDataModel extends ManageDataModel{
	public OperationDataModel(){
		super();
		
		
		setHeadPk(new OperationMainVO().getPKFieldName());
		setHeadVOClass(OperationMainVO.class); 
		
		
		this.setBodyVOClassArray(new Class[] {OperationDemandVO.class, OperationSupplyVO.class, OperationBalanceVO.class, OperationPurchaseVO.class, OperationOutsourceVO.class, OperationTransferVO.class});
		
		this.setBodyTableNames(new String[] {new OperationDemandVO().getTableName(), new OperationSupplyVO().getTableName(), new OperationBalanceVO().getTableName(), 
				new OperationPurchaseVO().getTableName(), new OperationOutsourceVO().getTableName(), new OperationTransferVO().getTableName()});
		
		this.setBodyTableCodeArray(new String[] { new OperationDemandVO().getTableName(),new OperationSupplyVO().getTableName(),new OperationBalanceVO().getTableName(),
				new OperationPurchaseVO().getTableName(),new OperationOutsourceVO().getTableName(),new OperationTransferVO().getTableName()});
		
		this.setBodyPkArray(new String[] {OperationDemandVO.PK_OPERATION_DEMAND, OperationSupplyVO.PK_OPERATION_SUPPLY, OperationBalanceVO.PK_OPERATION_BALANCE, 
				OperationPurchaseVO.PK_OPERATION_PURCHASE, OperationOutsourceVO.PK_OPERATION_OUTSOURCE, OperationTransferVO.PK_OPERATION_TRANSFER});
		
		this.setBodyFkArray(new String[] {OperationDemandVO.PK_OPERATION, OperationSupplyVO.PK_OPERATION, OperationBalanceVO.PK_OPERATION, OperationPurchaseVO.PK_OPERATION, OperationOutsourceVO.PK_OPERATION, OperationTransferVO.PK_OPERATION});
	}
	
	@Override
	public String getBillTempletBusiType() {
		return null;
	}

	@Override
	public String getBillTempletCode() { 
		return "MM01";
	}

	@Override
	public String getNormalQueryTemplateCode() {
		return null;
	}

	public boolean UpdateStatus(HRAggVO aggvo,int status) throws BusinessException{
		return getIOrderTotalInfo().UpdateStatus(aggvo,status);
	}
	
	public boolean execApprove(HRAggVO aggvo) throws BusinessException{
		return getIOrderTotalInfo().execApprove(aggvo);
	}
	
	
	static IOperationInfo ipti = null;
	
	public static IOperationInfo getIOrderTotalInfo() {
		if (ipti == null) {
			ipti = (IOperationInfo) NCLocator.getInstance().lookup(IOperationInfo.class);
		}
		return ipti;
	}
	
	public Object onSave(Object data, String checkClassMethodName, String lockClassName) throws Exception
    {
        if (data instanceof HRAggVO)
        {
            return PersitenceDelegator.saveAggVO((HRAggVO) data, checkClassMethodName, lockClassName);
        }
        else if (data instanceof HRAggVO[])
        {
            return PersitenceDelegator.saveAggVOArray((HRAggVO[]) data, checkClassMethodName, lockClassName);
        }
        
        return null;
    }
}
