package u8c.ui.mm.panel;

import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.MainPanel;
import nc.ui.hr.frame.TopPanel;
import nc.ui.hr.frame.action.AddLineAction;
import nc.ui.hr.frame.action.CancelAction;
import nc.ui.hr.frame.action.DeleteLineAction;
import nc.ui.hr.frame.action.EditLineAction;
import nc.ui.hr.frame.action.RefreshAction;
import nc.ui.hr.frame.action.ReturnFromCardToListAction;
import nc.ui.hr.frame.bill.manage.ManageDataModel;
import nc.ui.hr.frame.button.AbstractBtnReg;
import nc.ui.hr.frame.button.BtnStateReg;
import nc.ui.pub.bill.BillCardPanel;
import u8c.ui.mm.action.OperationAddAction;
import u8c.ui.mm.action.OperationApproveAction;
import u8c.ui.mm.action.OperationDeleteAction;
import u8c.ui.mm.action.OperationEditAction;
import u8c.ui.mm.action.OperationExportAction;
import u8c.ui.mm.action.OperationQueryAction;
import u8c.ui.mm.action.OperationReturnFromCardToListAction;
import u8c.ui.mm.action.OperationSaveAction;
import u8c.ui.mm.action.OperationUnApproveAction;
import u8c.ui.mm.action.YsAction;
import u8c.ui.mm.datamodel.OperationDataModel;
import u8c.ui.mytest.button.MymmBtnStateReg;


public class OperationTestUI extends FrameUI{

	
	protected void initialize(){
		super.initialize();
	}

	@Override
	protected void initButtons() {
		
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_ADD);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EDIT);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_DELETE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_QUERY);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_REFRESH);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_SAVE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_CANCEL);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_ADD_LINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_DEL_LINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EDIT_LINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_RETURN);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EXAMINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_CANCELEXAMINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EXPORT);
		getBtnManager().addButtonByID(AbstractBtnReg.USERBTN_YS);
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_ADD, new OperationAddAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EDIT, new OperationEditAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_DELETE, new OperationDeleteAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_QUERY, new OperationQueryAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_REFRESH, new RefreshAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_SAVE, new OperationSaveAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_CANCEL, new CancelAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_ADD_LINE, new AddLineAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EDIT_LINE, new EditLineAction(this));		
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_DEL_LINE, new DeleteLineAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_RETURN, new OperationReturnFromCardToListAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EXAMINE, new OperationApproveAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_CANCELEXAMINE, new OperationUnApproveAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EXPORT, new OperationExportAction(this));
		getBtnManager().regCmd(AbstractBtnReg.USERBTN_YS, new YsAction(this));
		
		getBtnManager().adjustButtonOrder(new int[] {
				AbstractBtnReg.SYSBTN_ADD,
				AbstractBtnReg.SYSBTN_EDIT,
				AbstractBtnReg.SYSBTN_DELETE,
				AbstractBtnReg.SYSBTN_ADD_LINE,
				AbstractBtnReg.SYSBTN_EDIT_LINE,
				AbstractBtnReg.SYSBTN_DEL_LINE,
				AbstractBtnReg.SYSBTN_QUERY,
				AbstractBtnReg.SYSBTN_REFRESH, 
				AbstractBtnReg.SYSBTN_SAVE,
				AbstractBtnReg.SYSBTN_CANCEL,
				AbstractBtnReg.SYSBTN_RETURN,
				AbstractBtnReg.SYSBTN_EXAMINE,
				AbstractBtnReg.SYSBTN_CANCELEXAMINE,
				AbstractBtnReg.SYSBTN_EXPORT,
				AbstractBtnReg.USERBTN_YS
				}
				);
	}
	
	@Override
	protected MainPanel createMainPanel() { 
		ManageDataModel model = (ManageDataModel) getDataModel();
		return new OperationMainPanel(this,  model.getBillTempletCode(), model.getBillTempletBusiType());
	}

	@Override
	protected TopPanel createTopPanel() { 
		return new OperationTopPanel(this);
	}
	
	@Override
	protected OperationDataModel createDataModel() { 
		return new OperationDataModel();
	}

	@Override
	public boolean needLeftPanel() { 
		return false;
	}

	@Override
	protected BtnStateReg createButtonStateRegister() { // 按钮状态注册类
		return  new MymmBtnStateReg(getDataModel().getState());
	}
	
	
	@Override
	public boolean needTopPanel() { 
		return true;
	}
	
	@Override
	public String getQueryNodeKey() {
		return "40H203";
	}
	
	@Override
	public String getModuleCode() { 
		return "40H203";
	}
	
	public BillCardPanel getBillCardPanel() {
		this.getBtnManager().setButtonEnabled(AbstractBtnReg.SYSBTN_RETURN, true);
		this.getBtnManager().setButtonEnabled(AbstractBtnReg.SYSBTN_EXAMINE, false);
		this.getBtnManager().setButtonVisiable(AbstractBtnReg.SYSBTN_EXAMINE, false);
		
		return ((OperationMainPanel) (this.getMainPanel())).getBillCardPanel();
	}


}
