package u8c.ui.mmpac.action;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.GeneralBillHeaderVO;
import nc.vo.ic.pub.bill.GeneralBillItemVO;
import nc.vo.ic.pub.bill.GeneralBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.ValidationException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.pubitf.ic.in.IOtherInMaintainAPI;
import u8c.ui.mmpac.panel.OrderMainPanel;
import u8c.ui.mmpac.panel.OrderTestUI;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import u8c.vo.OrderOtherinVO;
import u8c.vo.OrderOtheroutVO;

public class PushOtherInAction extends AbstractAction{
	private  OrderTestUI frameUI = null;
	private  IOtherInMaintainAPI iotherin = NCLocator.getInstance().lookup(IOtherInMaintainAPI.class);
	private  IVOPersistence ivo = NCLocator.getInstance().lookup(IVOPersistence.class);
	private  IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	public PushOtherInAction(FrameUI frameUI1) {
		super(frameUI1);
		this.frameUI = (OrderTestUI) frameUI1;
	}

	@Override
	public void execute() throws Exception {
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		int selectedRow = ((OrderMainPanel) getMainPanel()).getSelectedRow();
		HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();
		if (null != s && s != null){
			OrderMainVO headvo = (OrderMainVO) s.getParentVO();
			int billstatus = headvo.getBillstatus();
			if(billstatus != 1) {
				throw new ValidationException("非审批态单据不允许生成其他入库单");
			}
			
			String pk_corp = headvo.getPk_corp();
			String pk_order = headvo.getPk_order();
			String prjcode = headvo.getProjectid();//项目主键
			OrderOtherinVO[] invos = getInVOs(s);
			//业务类型
			String billtype=headvo.getBusitype();
			if(invos.length != 0) {
				GeneralBillVO[] aggvos = new GeneralBillVO[1];
				GeneralBillVO aggvo = new GeneralBillVO();
				GeneralBillHeaderVO icheadvo = new GeneralBillHeaderVO();
				icheadvo.setPk_corp(pk_corp);
				icheadvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
				icheadvo.setDbilldate(PubEnv.getServerDate());
				icheadvo.setCoperatorid(PubEnv.getPk_user());
				//收发类别
				icheadvo.setCdispatcherid(getpkrdcl("06"));
				//仓库ID
				if("工装".equals(billtype)) {
					icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("GZ001"));//仓库必填
				}else if("家装".equals(billtype)) {
					icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("JZ002"));//仓库必填
				}
				icheadvo.setBoutretflag(UFBoolean.FALSE);//是否退回 
				icheadvo.setBsalecooppur(UFBoolean.FALSE); // 销售出是否已协同生成采购入 
				icheadvo.setVnote("来源生产总订单");//备注
				icheadvo.setBassetcard(UFBoolean.FALSE);
				icheadvo.setCbilltypecode("4A");
				icheadvo.setFbillflag(2);
				icheadvo.setFreplenishflag(UFBoolean.FALSE);
				icheadvo.setCoperatoridnow(PubEnv.getPk_user());
				//项目编码 pk_defdoc9
				icheadvo.setAttributeValue("pk_defdoc9", prjcode);
				//项目名称pk_defdoc10
				icheadvo.setAttributeValue("pk_defdoc10", prjcode);
				//加工单号pk_defdoc1
				icheadvo.setAttributeValue("pk_defdoc2", headvo.getDef1());
				//收发类别
				icheadvo.setCdispatcherid(getpkrdcl("06"));
				aggvo.setParentVO(icheadvo);
				GeneralBillItemVO[] itemvos = new GeneralBillItemVO[invos.length];
//				List<GeneralBillItemVO> lisbillvos=new ArrayList<GeneralBillItemVO>();
				for(int i = 0;i < invos.length;i++) {
					OrderOtherinVO invo = invos[i];
					//校验已执行数量等于主数量不让再执行生单操作
					UFDouble exenumvo=invo.getExecnum()==null?UFDouble.ZERO_DBL: new UFDouble (invo.getExecnum());//已执行数量
					if(new UFDouble (invo.getNum()).sub(exenumvo).compareTo(UFDouble.ZERO_DBL)<=0) {
						MessageDialog.showErrorDlg(frameUI, "失败", "已经生成其他入库单，不允许重复生成！");
						return;
					}
					
					GeneralBillItemVO itemvo = new GeneralBillItemVO();
					String cmaterialcode = invo.getCmaterialcode();
					String pk_invbasdoc = "";//存货pk
					if(cmaterialcode.startsWith("0001")) {
						pk_invbasdoc = cmaterialcode;
					}
					else {
						InvbasdocVO invbasvo  = GetBaseDAOUtil.getInvVO(cmaterialcode);
						pk_invbasdoc = invbasvo.getPrimaryKey();
					}
					
//					String prjcode = invo.getPrjcode();
//					String cprojectid = "";
//					if(prjcode.startsWith("1001")) {
//						cprojectid = prjcode;
//					}
//					else {
//						 cprojectid =getprojectid(prjcode);
//					}
					String cprojectid=prjcode;
					InvmandocVO invmanvo = GetBaseDAOUtil.getInvmanVO(pk_invbasdoc);
					String pk_invmandoc = invmanvo.getPrimaryKey();
					itemvo.setCprojectid(cprojectid);
					itemvo.setBbarcodeclose(UFBoolean.FALSE);
					itemvo.setAttributeValue("bonroadflag", "N");
					itemvo.setBreturnprofit(UFBoolean.FALSE);
					itemvo.setBsafeprice(UFBoolean.FALSE);
					itemvo.setBsourcelargess(UFBoolean.FALSE);
					itemvo.setAttributeValue("btoinzgflag", "N");
					itemvo.setAttributeValue("btoouttoiaflag", "N");
					itemvo.setBtou8rm(UFBoolean.FALSE);
					itemvo.setBtransasset(UFBoolean.FALSE);
					itemvo.setBzgflag(UFBoolean.FALSE);
					itemvo.setCbodybilltypecode("4A");
		//			itemvo.setCbodywarehouseid("1001V5100000000003A1");
					//仓库ID
					if("工装".equals(billtype)) {
						icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("GZ001"));//仓库必填
					}else if("家装".equals(billtype)) {
						icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("JZ002"));//仓库必填
					}
					itemvo.setCfirstbillhid(pk_order);
					itemvo.setCfirstbillbid(invo.getPrimaryKey());
					itemvo.setCfirsttype("55A2");
					itemvo.setCinvbasid(pk_invbasdoc);
					itemvo.setCinventoryid(pk_invmandoc);
					icheadvo.setCinventoryid(pk_invmandoc);
					itemvo.setCrowno(Integer.toString((i+1)*10));
					itemvo.setCsourcebillhid(pk_order);
					itemvo.setCsourcebillbid(invo.getPrimaryKey());
					itemvo.setCsourcetype("55A2");
					itemvo.setDbizdate(PubEnv.getServerDate());
					itemvo.setFassertcardflag(UFBoolean.FALSE);
					itemvo.setFchecked(0);
					itemvo.setFlargess(UFBoolean.FALSE);
					itemvo.setIsok(UFBoolean.FALSE);
					itemvo.setNbarcodenum(new UFDouble(0));
					itemvo.setNinnum(invo.getNum());//实入数量
					itemvo.setNinassistnum (invo.getNastnum());//实入辅数量
					itemvo.setNshouldinnum(invo.getNum());//应入数量
					itemvo.setNneedinassistnum(invo.getNastnum());//应入辅数量
					String pkdw=getpkmeasdoc(invo.getCastunitid());
					itemvo.setCastunitid(pkdw);//辅计量单位ID 
					itemvo.setHsl(new UFDouble(invo.getBdef6()));//换算率
					itemvo.setAttributeValue("processcost", invo.getNmny());
					itemvo.setPk_calbody(icheadvo.getPk_calbody());
					String vbatcode=invo.getVbatchcode()==null?"":invo.getVbatchcode();
					itemvo.setVbatchcode(vbatcode);
					itemvo.setVfirstbillcode(headvo.getVbillno());
					itemvo.setVfree1(invo.getColor());//颜色
					itemvo.setVfree2(invo.getAlloy());//合金
					itemvo.setVfree3(invo.getSizing());//定尺
					itemvo.setVfree4(invo.getStandard());//标准
					itemvo.setVsourcebillcode(headvo.getVbillno());
					itemvo.setAttributeValue("pk_defdoc1", invo.getBdef11());//楼号楼层
					itemvo.setAttributeValue("pk_defdoc2", invo.getBdef12());//樘数（数量）
					itemvo.setAttributeValue("pk_defdoc3", invo.getBdef13());//框统计
					itemvo.setAttributeValue("pk_defdoc4", invo.getBdef14());//扇统计
					itemvo.setAttributeValue("pk_defdoc5", invo.getBdef15());//半成品分类
					itemvo.setAttributeValue("pk_defdoc6", invo.getBdef16());//面积
					itemvo.setAttributeValue("pk_defdoc7", invo.getBdef17());//切割长度
					itemvo.setAttributeValue("pk_defdoc8", invo.getBdef18());//切割角度左下
					itemvo.setAttributeValue("pk_defdoc9", invo.getBdef19());//切割角度右上
					itemvo.setAttributeValue("pk_defdoc10", invo.getBdef2());//备注
					itemvo.setAttributeValue("pk_defdoc11", invo.getWidth());//宽度
					itemvo.setAttributeValue("pk_defdoc12", invo.getHeight());//高度
					itemvo.setAttributeValue("pk_defdoc13", invo.getBdef20());//系列
					itemvo.setAttributeValue("pk_defdoc14", invo.getBdef3());//玻璃编号
					itemvos[i] = itemvo;
//					lisbillvos.add(itemvo);
				}
//				if(null!=lisbillvos && lisbillvos.size()>0) {
					aggvo.setChildrenVO(itemvos);
					aggvos[0] = aggvo;
					GeneralBillVO[] res = iotherin.insertOtherIns(aggvos);
					GeneralBillVO resvo = res[0];
					//入库修改颜色，生单后，回写颜色到领料的入库颜色字段
					UpdateIssue(invos);
					//回写已执行数量
					UpdateExecnum(invos);
					MessageDialog.showHintDlg(frameUI, "成功", "其他入库单"+resvo.getVBillCode()+"新增成功");
//				}else {
//					
//					MessageDialog.showErrorDlg(frameUI, "失败", "已经生成其他入库单，不允许重复生成！");
//				}
				
			}
			else {
				MessageDialog.showHintDlg(frameUI, "提示", "该生产订单没有其他入库数据，不能生成其他入库单");
				return;
			}
		}
	}
	
	

	private void UpdateExecnum(OrderOtherinVO[] invos) throws Exception {
		for(OrderOtherinVO invo : invos) {
			invo.setExecnum(invo.getNum());
			invo.setExecnastnum(invo.getNastnum());
		}
			ivo.updateVOArray(invos);
			this.frameUI.getBillCardPanel().getBillModel().setBodyDataVO(invos);
	}
	
	
	private void UpdateIssue(OrderOtherinVO[] invos) throws Exception {
		List<OrderIssueVO> issuevos = new ArrayList<>();
		for(OrderOtherinVO invo : invos) {
			Object pk_order_issue = invo.getBdef1();
			String color = invo.getColor() == null ? "" : invo.getColor();
			if(pk_order_issue != null) {
				OrderIssueVO issuevo = GetBaseDAOUtil.getissuevo(pk_order_issue.toString());
				if(issuevo != null) {
					issuevo.setBdef4(color);
					issuevos.add(issuevo);
				}
			}
		}
		if(issuevos.size() != 0) {
			ivo.updateVOList(issuevos);
		}
	}
	

	//获取其他入库数据
	private OrderOtherinVO[] getInVOs(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		List<OrderOtherinVO> invos = new ArrayList();
		for(CircularlyAccessibleValueObject vo : vos) {
			if(vo instanceof OrderOtherinVO) {
				invos.add((OrderOtherinVO)vo);
			}
		}
		Object[] objArrays = invos.toArray();
		OrderOtherinVO[] inArrays = new OrderOtherinVO[objArrays.length];
		for(int i = 0;i < objArrays.length;i++) {
			inArrays[i] = (OrderOtherinVO) objArrays[i];
		}
		return inArrays;
	}
	
	 public  String getprojectid(String prjcode) throws Exception {
	        String sql = "select * from  bd_jobmngfil where pk_jobbasfil "
	        		+ " =(select pk_jobbasfil from bd_jobbasfil where jobcode ='"+prjcode+"' and isnull(dr,0) = 0) and isnull(dr,0) = 0 ";
	        String pk_jobbasfil = (String) iuap.executeQuery(sql, new ColumnProcessor());
	        if (pk_jobbasfil == null) {
	            return "";
	        }
	        return pk_jobbasfil;
	    }
	 
	 //收发类别
	 private String getpkrdcl(String rdcode ) throws BusinessException {
	  String sql="select pk_rdcl from bd_rdcl where rdcode='"+rdcode+"'  ";
	  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	  
	  String pk_rdcl = (String) iuap.executeQuery(sql, new ColumnProcessor());
      if (pk_rdcl == null) {
          return "";
      }
      return pk_rdcl;
		
	}
	 
	 //计量单位
	 private String getpkmeasdoc(String measname ) throws BusinessException {
	    String sql="select pk_measdoc from bd_measdoc where measname='"+measname+"'  ";
	    IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	    String pk_measdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_measdoc == null) {
          return "";
        }
        return pk_measdoc;
		
	}
		
}
