package u8c.ui.mmpac.action;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.GeneralBillHeaderVO;
import nc.vo.ic.pub.bill.GeneralBillItemVO;
import nc.vo.ic.pub.bill.GeneralBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.ValidationException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.pubitf.ic.out.IOtherOutMaintainAPI;
import u8c.ui.mmpac.panel.OrderMainPanel;
import u8c.ui.mmpac.panel.OrderTestUI;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import u8c.vo.OrderOtherinVO;
import u8c.vo.OrderOtheroutVO;

public class PushOtherOutAction extends AbstractAction{
	OrderTestUI frameUI = null;
	private  IOtherOutMaintainAPI iotherout = NCLocator.getInstance().lookup(IOtherOutMaintainAPI.class);
	private  IVOPersistence ivo = NCLocator.getInstance().lookup(IVOPersistence.class);
	public PushOtherOutAction(FrameUI frameUI1) {
		super(frameUI1);
		this.frameUI = (OrderTestUI) frameUI1;
	}

	@Override
	public void execute() throws Exception {
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		int selectedRow = ((OrderMainPanel) getMainPanel()).getSelectedRow();
		HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();
		if (null != s && s != null){
			OrderMainVO headvo = (OrderMainVO) s.getParentVO();
			int billstatus = headvo.getBillstatus();
			if(billstatus != 1) {
				throw new ValidationException("非审批态单据不允许生成其他出库单");
			}
			String pk_corp = headvo.getPk_corp();
			String pk_order = headvo.getPk_order();
			String prjcode = headvo.getProjectid();//项目主键
			//业务类型
			String billtype=headvo.getBusitype();
			OrderOtheroutVO[] outvos = getOutVOs(s);
			if(outvos.length != 0) {
				GeneralBillVO[] aggvos = new GeneralBillVO[1];
				GeneralBillVO aggvo = new GeneralBillVO();
				GeneralBillHeaderVO icheadvo = new GeneralBillHeaderVO();
				icheadvo.setPk_corp(pk_corp);
				icheadvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
				icheadvo.setDbilldate(PubEnv.getServerDate());
				icheadvo.setCoperatorid(PubEnv.getPk_user());
	//			icheadvo.setCwarehouseid("1001V5100000000003A1");//仓库必填
				//收发类别
				icheadvo.setCdispatcherid(getpkrdcl("07"));
				//仓库ID
				if("工装".equals(billtype)) {
					icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("GZ001"));//仓库必填
				}else if("家装".equals(billtype)) {
					icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("JZ002"));//仓库必填
				}
				
				icheadvo.setBoutretflag(UFBoolean.FALSE);//是否退回 
				icheadvo.setBsalecooppur(UFBoolean.FALSE); // 销售出是否已协同生成采购入 
				icheadvo.setVnote("来源生产总订单");//备注
				icheadvo.setBassetcard(UFBoolean.FALSE);
				icheadvo.setCbilltypecode("4I");
				icheadvo.setFbillflag(2);
				icheadvo.setFreplenishflag(UFBoolean.FALSE);
				icheadvo.setCoperatoridnow(PubEnv.getPk_user());
				//收发类别
				icheadvo.setCdispatcherid(getpkrdcl("07"));
				
				//项目编码 pk_defdoc9
				icheadvo.setAttributeValue("pk_defdoc9", prjcode);
				//项目名称pk_defdoc10
				icheadvo.setAttributeValue("pk_defdoc10", prjcode);
				//加工单号pk_defdoc1
				icheadvo.setAttributeValue("pk_defdoc2", headvo.getDef1());
				aggvo.setParentVO(icheadvo);
				GeneralBillItemVO[] itemvos = new GeneralBillItemVO[outvos.length];
				for(int i = 0;i < outvos.length;i++) {
					OrderOtheroutVO outvo = outvos[i];
					//校验已执行数量等于主数量不让再执行生单操作
					UFDouble exenumvo=outvo.getExecnum()==null?UFDouble.ZERO_DBL: new UFDouble (outvo.getExecnum());//已执行数量
					if(new UFDouble (outvo.getNum()).sub(exenumvo).compareTo(UFDouble.ZERO_DBL)<=0) {
						MessageDialog.showErrorDlg(frameUI, "失败", "已经生成其他入库单，不允许重复生成！");
						return;
					}
					
					GeneralBillItemVO itemvo = new GeneralBillItemVO();
					String cmaterialcode = outvo.getCmaterialcode();
					String pk_invbasdoc = "";//存货pk
					if(cmaterialcode.startsWith("0001")) {
						pk_invbasdoc = cmaterialcode;
					}
					else {
						InvbasdocVO invbasvo  = GetBaseDAOUtil.getInvVO(cmaterialcode);
						pk_invbasdoc = invbasvo.getPrimaryKey();
					}
//					String prjcode = outvo.getPrjcode();
//					String cprojectid = "";
//					if(prjcode.startsWith("1001")) {
//						cprojectid = prjcode;
//					}
//					else {
//						cprojectid = GetBaseDAOUtil.getprojectid(prjcode);
//					}
					
					String cprojectid=prjcode;
					InvmandocVO invmanvo = GetBaseDAOUtil.getInvmanVO(pk_invbasdoc);
					String pk_invmandoc = invmanvo.getPrimaryKey();
					itemvo.setCprojectid(cprojectid);
					itemvo.setBbarcodeclose(UFBoolean.FALSE);
					itemvo.setAttributeValue("bonroadflag", "N");
					itemvo.setBreturnprofit(UFBoolean.FALSE);
					itemvo.setBsafeprice(UFBoolean.FALSE);
					itemvo.setBsourcelargess(UFBoolean.FALSE);
					itemvo.setAttributeValue("btoinzgflag", "N");
					itemvo.setAttributeValue("btoouttoiaflag", "N");
					itemvo.setBtou8rm(UFBoolean.FALSE);
					itemvo.setBtransasset(UFBoolean.FALSE);
					itemvo.setBzgflag(UFBoolean.FALSE);
					itemvo.setCbodybilltypecode("4I");
	//				itemvo.setCbodywarehouseid("1001V5100000000003A1");
					//仓库ID
					if("工装".equals(billtype)) {
						icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("GZ001"));//仓库必填
					}else if("家装".equals(billtype)) {
						icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("JZ002"));//仓库必填
					}
					itemvo.setCfirstbillhid(pk_order);
					itemvo.setCfirstbillbid(outvo.getPrimaryKey());
					itemvo.setCfirsttype("55A2");
					itemvo.setCinvbasid(pk_invbasdoc);//存货基本ID 
					itemvo.setCinventoryid(pk_invmandoc);//存货ID 
	//				icheadvo.setCinventoryid(pk_invmandoc);
					itemvo.setCrowno(Integer.toString((i+1)*10));
					itemvo.setCsourcebillhid(pk_order);
					itemvo.setCsourcebillbid(outvo.getPrimaryKey());
					itemvo.setCsourcetype("55A2");
					itemvo.setDbizdate(PubEnv.getServerDate());
					itemvo.setFassertcardflag(UFBoolean.FALSE);
					itemvo.setFchecked(0);
					itemvo.setFlargess(UFBoolean.FALSE);
					itemvo.setIsok(UFBoolean.FALSE);
					
					itemvo.setNbarcodenum(new UFDouble(0));//条码数量 
					itemvo.setNoutnum(outvo.getNum());//实出数量
					itemvo.setNshouldoutnum(outvo.getNum());//应出数量
					itemvo.setHsl(new UFDouble(outvo.getBdef6()));//换算率	
					itemvo.setNoutassistnum(outvo.getNastnum());//实出辅数量
					itemvo.setNshouldoutassistnum(outvo.getNastnum());//应出辅数量
					
					String castunitid=getpk(outvo.getCastunitid()==null?"":outvo.getCastunitid().toString());
					itemvo.setCastunitid(castunitid);//辅计量单位ID 
					itemvo.setCastunitname(castunitid==null?"":castunitid.toString());//辅计量单位名称
					
					itemvo.setPk_calbody(icheadvo.getPk_calbody());
					itemvo.setVbatchcode(outvo.getVbatchcode()==null?"":outvo.getVbatchcode());
					itemvo.setVfirstbillcode(headvo.getVbillno());
					itemvo.setVfree1(outvo.getColor());//颜色
					itemvo.setVfree2(outvo.getAlloy());//合金
					itemvo.setVfree3(outvo.getSizing());//定尺
					itemvo.setVfree4(outvo.getStandard());//标准
					itemvo.setVsourcebillcode(headvo.getVbillno());
					itemvo.setAttributeValue("pk_defdoc1", outvo.getBdef11());//楼号楼层
					itemvo.setAttributeValue("pk_defdoc2", outvo.getBdef12());//樘数（数量）
					itemvo.setAttributeValue("pk_defdoc3", outvo.getBdef13());//框统计
					itemvo.setAttributeValue("pk_defdoc4", outvo.getBdef14());//扇统计
					itemvo.setAttributeValue("pk_defdoc5", outvo.getBdef15());//半成品分类
					itemvo.setAttributeValue("pk_defdoc6", outvo.getBdef16());//面积
					itemvo.setAttributeValue("pk_defdoc7", outvo.getBdef17());//切割长度
					itemvo.setAttributeValue("pk_defdoc8", outvo.getBdef18());//切割角度左下
					itemvo.setAttributeValue("pk_defdoc9", outvo.getBdef19());//切割角度右上
					itemvo.setAttributeValue("pk_defdoc10", outvo.getBdef2());//备注
					itemvo.setAttributeValue("pk_defdoc11", outvo.getWidth());//宽度
					itemvo.setAttributeValue("pk_defdoc12", outvo.getHeight());//高度
					itemvo.setAttributeValue("pk_defdoc13", outvo.getBdef20());//系列
					itemvo.setAttributeValue("pk_defdoc14", outvo.getBdef3());//玻璃编号
					itemvos[i] = itemvo;
				}
				aggvo.setChildrenVO(itemvos);
				aggvos[0] = aggvo;
				GeneralBillVO[] res = iotherout.insertOtherOuts(aggvos);
				GeneralBillVO resvo = res[0];
				//回写已执行数量
				UpdateExecnum(outvos);
				MessageDialog.showHintDlg(frameUI, "成功", "其他出库单"+resvo.getVBillCode()+"新增成功");
			}
			else {
				MessageDialog.showHintDlg(frameUI, "提示", "该生产订单没有其他出库数据，不能生成其他出库单");
				return;
			}
		}
	}
	
	
	private void UpdateExecnum(OrderOtheroutVO[] outvos) throws Exception {
		for(OrderOtheroutVO outvo : outvos) {
			outvo.setExecnum(outvo.getNum());
			outvo.setExecnastnum(outvo.getNastnum());
		}
			ivo.updateVOArray(outvos);
			
			this.frameUI.getBillCardPanel().getBillModel().setBodyDataVO(outvos);
	}
	

	//获取其他出库数据
	private OrderOtheroutVO[] getOutVOs(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		List<OrderOtheroutVO> outvos = new ArrayList();
		for(CircularlyAccessibleValueObject vo : vos) {
			if(vo instanceof OrderOtheroutVO) {
				outvos.add((OrderOtheroutVO)vo);
			}
		}
		Object[] objArrays = outvos.toArray();
		OrderOtheroutVO[] outArrays = new OrderOtheroutVO[objArrays.length];
		for(int i = 0;i < objArrays.length;i++) {
			outArrays[i] = (OrderOtheroutVO) objArrays[i];
		}
		return outArrays;
	}

	
	//收发类别
	private String getpkrdcl(String rdcode ) throws BusinessException {
	  String sql="select pk_rdcl from bd_rdcl where rdcode='"+rdcode+"'  ";
	  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	  
	  String pk_rdcl = (String) iuap.executeQuery(sql, new ColumnProcessor());
      if (pk_rdcl == null) {
          return "";
      }
      return pk_rdcl;
		
	}
	
	//计量单位 
	private String getpk(String shortname) throws BusinessException {
	  String sql="select pk_measdoc from bd_measdoc where measname='"+shortname+"'  ";
	  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	  
	  String pk_measdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
      if (pk_measdoc == null) {
          return "";
      }
      return pk_measdoc;
		
	}
}
