package u8c.ui.mmpac.action;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JSplitPane;
import javax.swing.border.BevelBorder;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFBusiAction;
import nc.itf.uap.pf.IplatFormEntry;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UISplitPane;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pub.bill.BillEditEvent;
import nc.ui.pub.bill.BillEditListener;
import nc.ui.querytemplate.QueryConditionDLG;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.GeneralBillHeaderVO;
import nc.vo.ic.pub.bill.GeneralBillItemVO;
import nc.vo.ic.pub.bill.GeneralBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.pf.PfUtilWorkFlowVO;
import nc.vo.pub.workflownote.WorkflownoteVO;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
import nc.vo.querytemplate.TemplateInfo;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.itf.mmpac.mmpac.IOrderTotalInfo;
import u8c.pubitf.ic.out.ISaleOutMaintainAPI;
import u8c.vo.OrderInVO;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;

@SuppressWarnings("deprecation")
public class ToSaleOutDialog extends UIDialog implements ActionListener,BillEditListener{

	private static final long serialVersionUID = -2605551888165671266L;
	private int focus=1;
	private UIPanel ivjUIPanel0 = null;
	private UIPanel ivjUIPanel2 = null;
	private UISplitPane mainpanel = null;
	private BillCardPanel jlcardPanel = null;//卡面面板
	private UIPanel jlbtnpanel = null;//存放按钮的panel
	private UIButton saveCardBtn = null ; //保存
	private UIButton cancelBtn = null ; //取消
	private UIButton selectallBtn= null ; //全选按钮
	private UIButton cancelallBtn= null ; //全消按钮
	private UIButton queryBtn= null ;//查询按钮 
	private ClientEnvironment ce = ClientEnvironment.getInstance();
	private HRAggVO aggvo;
	private OrderInVO[] inArrays = null;
	ISaleOutMaintainAPI isaleout = NCLocator.getInstance().lookup(ISaleOutMaintainAPI.class);
	IOrderTotalInfo iorder = NCLocator.getInstance().lookup(IOrderTotalInfo.class);
	IplatFormEntry iIplatFormEntry = NCLocator.getInstance().lookup(IplatFormEntry.class);
	

	public ToSaleOutDialog(HRAggVO aggvo) {
		super();
		initialize(aggvo);
	}

//	private void initialize(HRAggVO aggvo) {
//		Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
//		setName("saleoutdlg");
//		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
//		setTitle("生产总订单入库-销售出库");
//		setSize(1000,360);
//		this.setResizable(true);
//		setLocation((dimension.width-550)/2, (dimension.height-300)/2);
//		setContentPane(getMainPanel());
//		addListenerEvent();
//		this.aggvo = aggvo;
//		//展示数据
//		OrderInVO[] inArrays = getInVOs(aggvo);
//		getJlcardPanel().getBillModel().setBodyDataVO(inArrays);
//	}
	
	private void initialize(HRAggVO aggvo) {
		Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
		setName("saleoutdlg");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setTitle("生产总订单入库-销售出库");
//		setSize(1000,360);
		setSize(dimension.width-100,dimension.height-200);
		this.setResizable(true);
		add(getUIPanel0(), BorderLayout.NORTH);
		add(getUIPanel2(), BorderLayout.CENTER);
//		setLocation((dimension.width-550)/2, (dimension.height-300)/2);
		setLocation(100/2, 200/2);
//		setContentPane(getMainPanel());
		addListenerEvent();
		this.aggvo = aggvo;
		//展示数据
		OrderInVO[] inArrays = getInVOs(aggvo);
		getJlcardPanel().getBillModel().setBodyDataVO(inArrays);
	}
	
	
	
	

	//按钮监听
	private void addListenerEvent() {
		getSaveCardBtn().addActionListener(this);
		getCancelBtn().addActionListener(this);
		getQueryBtn().addActionListener(this);
		getSelectallBtn().addActionListener(this);
		getCancelallBtn().addActionListener(this);
		getJlcardPanel().addEditListener(this);
		
	}
	
	private UIPanel getUIPanel2() {
		if (ivjUIPanel2 == null) {
			ivjUIPanel2 = new UIPanel();
			ivjUIPanel2.setLayout(new BorderLayout());
			ivjUIPanel2.setPreferredSize(new Dimension(0, 500));
			// ivjUIPanel2.add(getTablePanel(), BorderLayout.CENTER);
			ivjUIPanel2.add(getMainPanel(), BorderLayout.CENTER);// ZTH
		}
		return this.ivjUIPanel2;
	}
	
	
	private UIPanel getUIPanel0() {
		if (ivjUIPanel0 == null) {
			try {
				ivjUIPanel0 = new UIPanel();
				ivjUIPanel0.setLayout(new FlowLayout(FlowLayout.LEFT));
				ivjUIPanel0.add(getQueryBtn());
				ivjUIPanel0.add(getSelectallBtn());
				ivjUIPanel0.add(getCancelallBtn());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return this.ivjUIPanel0;
	}
	
	
   private void handleException(Throwable e) {
		
	}
	

	private UISplitPane getMainPanel() {
		if(mainpanel==null){
			mainpanel = new UISplitPane();
			mainpanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
			mainpanel.setTopComponent(getJlcardPanel());
			mainpanel.setBottomComponent(getJlbtnpanel());
			mainpanel.setDividerLocation(750);//分割位置
			mainpanel.setOneTouchExpandable(true);
			mainpanel.setDividerSize(8);
		}
		
		return mainpanel;
	}

	private UIPanel getJlbtnpanel() {
		if(jlbtnpanel==null){
			jlbtnpanel = new UIPanel();
			jlbtnpanel.setName("jlbtnpanel");
			jlbtnpanel.add(getSaveCardBtn());
			jlbtnpanel.add(getCancelBtn());
		}
		return jlbtnpanel;
	}

	private UIButton getCancelBtn() {
		if(cancelBtn == null){
			cancelBtn = new UIButton();
			cancelBtn.setBounds(530,210, 75, 20);
			cancelBtn.setName("cancelBtn");
			cancelBtn.setText("取消");
		}
		return cancelBtn;
	}

	private UIButton getSaveCardBtn() {
		if(saveCardBtn == null){
			saveCardBtn = new UIButton();
			saveCardBtn.setBounds(530,210, 20, 20);
			saveCardBtn.setName("saveCardBtn");
			saveCardBtn.setText("确定");
		}
		return saveCardBtn;
	}
	
	
	private UIButton getQueryBtn() {
		if (queryBtn == null) {
			queryBtn = new UIButton();
			queryBtn.setName("queryBtn");
			queryBtn.setText("  筛选  ");
			Color clrBack = new Color(0XC4C4C4);
			queryBtn.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED,
					Color.white,clrBack, new Color(0X5F5F5F), clrBack));
		
			
		}
		return this.queryBtn;
	}

	
	private UIButton getSelectallBtn() {
		if (selectallBtn == null) {
			selectallBtn = new UIButton();
			selectallBtn.setName("selectallBtn");
			selectallBtn.setText("  全选  ");
			Color clrBack = new Color(0XC4C4C4);
			selectallBtn.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED,
					Color.white,clrBack, new Color(0X5F5F5F), clrBack));
		}
		return this.selectallBtn;
	}

	private UIButton getCancelallBtn() {
		if (cancelallBtn == null) {
			cancelallBtn = new UIButton();
			cancelallBtn.setName("cancelallBtn");
			cancelallBtn.setText("  全消  ");
			Color clrBack = new Color(0XC4C4C4);
			cancelallBtn.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED,
					Color.white,clrBack, new Color(0X5F5F5F), clrBack));
		}
		return this.cancelallBtn;
	}
	

	private BillCardPanel getJlcardPanel() {
		if(jlcardPanel==null){
			jlcardPanel=new BillCardPanel();
			jlcardPanel.setName("jlcardPanel");
			//根据单据模板编码加载模板
//			jlcardPanel.loadTemplet("A224C",null,ce.getUser().getPrimaryKey(),ce.getCorporation().getPrimaryKey());
			jlcardPanel.loadTemplet("QS412",null,ce.getUser().getPrimaryKey(),ce.getCorporation().getPrimaryKey());
		}
		
		return jlcardPanel;
	}
	
	//根据传入的aggvo获取invo数组
	private OrderInVO[] getInVOs(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		//查询最新的数据
		OrderMainVO headvo=(OrderMainVO) aggvo.getParentVO();
		String pk_order=headvo.getPk_order();//主表主键
		IUAPQueryBS iuap=NCLocator.getInstance().lookup(IUAPQueryBS.class);
		String sql="select * from mmpac_order_in where pk_order='"+pk_order+"' and isnull(dr,0)=0  ";
		List<OrderInVO> orderinvos=null;
		try {
			orderinvos=(List<OrderInVO>) iuap.executeQuery(sql, new BeanListProcessor(OrderInVO.class));
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		List<OrderInVO> invos = new ArrayList<OrderInVO>();
//		for(CircularlyAccessibleValueObject vo : vos) {
//			if(vo instanceof OrderInVO) {
//				//本次执行数量不填就默认
//				//执行完的表体在生单界面不展示
//				OrderInVO invo = (OrderInVO) vo;
//				UFDouble num = invo.getNum() == null ? new UFDouble(0) : invo.getNum();
//				UFDouble execnum = invo.getExecnum() == null ? new UFDouble(0) : invo.getExecnum();
////				if(num.equals(execnum) && num.equals(new UFDouble(0))) {
////					continue;
////				}
//				if(num.sub(execnum).compareTo(UFDouble.ZERO_DBL)==0) {
//					continue;
//				}
//				invo.setBdef5(num.sub(execnum).toString());
//				invos.add(invo);
//			}
//		}
//		OrderInVO[] inArrays = new OrderInVO[invos.size()];
//		for(int i = 0;i < invos.size();i++) {
//			inArrays[i] = invos.get(i);
//		}
		
		List<OrderInVO> issuevos = new ArrayList<OrderInVO>();
		if(null!=orderinvos && orderinvos.size()>0) {
			for(OrderInVO invo:orderinvos) {
				UFDouble num = invo.getNum() == null ? new UFDouble(0) : invo.getNum();
				UFDouble bdef8 = invo.getBdef8()== null ? UFDouble.ZERO_DBL :new UFDouble(invo.getBdef8());//销售出库已执行主数量
				if(num.sub(bdef8).compareTo(UFDouble.ZERO_DBL)==0) {
					continue;
				}
				invo.setBdef5(num.sub(bdef8).toString());
				invos.add(invo);
			}
			
		}else {
			
			for(CircularlyAccessibleValueObject vo : vos) {
			if(vo instanceof OrderInVO) {
				//本次执行数量不填就默认
				//执行完的表体在生单界面不展示
				OrderInVO invo = (OrderInVO) vo;
				UFDouble num = invo.getNum() == null ? new UFDouble(0) : invo.getNum();
				UFDouble bdef8 = invo.getBdef8() == null ?UFDouble.ZERO_DBL : new UFDouble(invo.getBdef8());
//				if(num.equals(execnum) && num.equals(new UFDouble(0))) {
//					continue;
//				}
				if(num.sub(bdef8).compareTo(UFDouble.ZERO_DBL)==0) {
					continue;
				}
				invo.setBdef5(num.sub(bdef8).toString());
				invos.add(invo);
			}
		}
		
	}
		
		OrderInVO [] issueArrays =invos.toArray(new OrderInVO[0]);
		
		
		return issueArrays;
	}

	@Override
	public void afterEdit(BillEditEvent var1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void bodyRowChange(BillEditEvent var1) {
		// TODO Auto-generated method stub
		
	}
	
	
	/**
	 * 全选与反选,flag为true时，全选操作，flag为false时，进行反选操作
	 */
	private void onselectall(boolean flag) {
		switch (focus) {
		case 1:
			int jfRowCount = getJlcardPanel().getRowCount();
			if (jfRowCount > 0) {
				for (int row = 0; row < jfRowCount; row++) {
					getJlcardPanel().getBillModel().setValueAt(flag, row, "bdef4");
				}
				
			}
			break;

		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		//保存按钮
		if(e.getSource() == getSaveCardBtn()){
			Vector<Vector<Object>> vectors= getJlcardPanel().getBillModel().getDataVector();
			StringBuffer errmsg = new StringBuffer();
			//数量校验
			try {
				int execsize = 0;//勾选的条数
				for(int i = 0; i < vectors.size(); i++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(i);
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						if(vector.get(1) == null) {
							errmsg.append("第"+(i+1)+"行本次执行数量为空！");
							continue;
						}
						execsize = execsize + 1;
						UFDouble execnum = new UFDouble(vector.get(1).toString());//本次执行数量
						UFDouble nnum = new UFDouble(vector.get(22).toString());//主数量
						UFDouble usednum = vector.get(51) == null?new UFDouble(0):new UFDouble(vector.get(51).toString());//已执行主数量
						if(execnum.compareTo(nnum.sub(usednum)) > 0) {
							errmsg.append("第"+(i+1)+"行本次执行数量超过订单剩余数量！");
						}
					}
				}
				
				if(!errmsg.toString().equals("")) {
					MessageDialog.showErrorDlg(mainpanel, "错误", errmsg.toString());
					return;
				}
				if(execsize == 0) {
					MessageDialog.showHintDlg(mainpanel, "提示", "请勾选要生成销售出库的数据");
					return;
				}
				OrderMainVO headvo = (OrderMainVO) this.aggvo.getParentVO();
				//业务类型
				String billtype=headvo.getBusitype();
				String pk_corp = headvo.getPk_corp();
				String pk_order = headvo.getPk_order();
				String prjcode = headvo.getProjectid();//项目管理主键
				GeneralBillVO[] aggvos = new GeneralBillVO[1];
				GeneralBillVO aggvo = new GeneralBillVO();
				GeneralBillHeaderVO icheadvo = new GeneralBillHeaderVO();
				icheadvo.setPk_corp(pk_corp);
				icheadvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
				icheadvo.setDbilldate(PubEnv.getServerDate());
				icheadvo.setCoperatorid(PubEnv.getPk_user());
				//收发类别
				icheadvo.setCdispatcherid(getpkrdcl("02"));
				//仓库ID
				if("工装".equals(billtype)) {
					icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("GZ001"));//仓库必填
				}else if("家装".equals(billtype)) {
					icheadvo.setCwarehouseid(GetBaseDAOUtil.getstordocpk("JZ002"));//仓库必填
				}
				icheadvo.setBoutretflag(UFBoolean.FALSE);//是否退回 
				icheadvo.setBsalecooppur(UFBoolean.FALSE); // 销售出是否已协同生成采购入 
				icheadvo.setVnote("来源生产总订单");//备注
				icheadvo.setCbilltypecode("4C");
				icheadvo.setBassetcard(UFBoolean.FALSE);
				icheadvo.setCbiztypeid("1001F810000000000015");//业务流程
		//		String def1 = GetBaseDAOUtil.getJobbasfilDef1("prjcode");
				String def1 = GetBaseDAOUtil.getJobbasmngDef1(prjcode);
				icheadvo.setCcustomerid(getpkcumdoc(def1));//客商管理档案
				icheadvo.setPk_cubasdocC(def1);//客商基本
				icheadvo.setCdptid(headvo.getPlandeptid());//部门
				icheadvo.setFreplenishflag(UFBoolean.FALSE);
//				icheadvo.setPk_cubasdocC(def1);//客户基本档案
				icheadvo.setFbillflag(2);
				icheadvo.setCoperatoridnow(PubEnv.getPk_user());//设置当前操作人
	//			icheadvo.setAttributeValue("pk_defdoc1", vectors.get(0).get(2)==null?"":vectors.get(0).get(2).toString());//开票类型
				aggvo.setParentVO(icheadvo);
				GeneralBillItemVO[] itemvos = new GeneralBillItemVO[execsize];
				Map<String, UFDouble> updatemap = new HashMap<>();
				int k = 0;
				for(int j = 0; j < vectors.size(); j++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(j);
					//自定义项4为勾选按钮 ：勾选为Y 没有勾选是null
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						GeneralBillItemVO itemvo = new GeneralBillItemVO();
						String cmaterialcode = vector.get(8).toString();
						String pk_invbasdoc = "";//存货pk
						if(cmaterialcode.startsWith("0001")) {
							pk_invbasdoc = cmaterialcode;
						}
						else {
							InvbasdocVO invbasvo  = GetBaseDAOUtil.getInvVO(cmaterialcode);
							pk_invbasdoc = invbasvo.getPrimaryKey();
						}
//						String prjcode = vector.get(3).toString();
//						String cprojectid = "";
//						if(prjcode.startsWith("1001")) {
//							cprojectid = prjcode;
//						}
//						else {
//							cprojectid = GetBaseDAOUtil.getprojectid(prjcode);
//						}
						String cprojectid=prjcode;
						InvmandocVO invmanvo = GetBaseDAOUtil.getInvmanVO(pk_invbasdoc);
						String pk_invmandoc = invmanvo.getPrimaryKey();
						itemvo.setBbarcodeclose(UFBoolean.FALSE);
						itemvo.setBreturnprofit(UFBoolean.FALSE);
						itemvo.setBsafeprice(UFBoolean.FALSE);
						itemvo.setBsourcelargess(UFBoolean.FALSE);
						itemvo.setBtou8rm(UFBoolean.FALSE);
						itemvo.setBtransasset(UFBoolean.FALSE);
						itemvo.setBzgflag(UFBoolean.FALSE);
						itemvo.setCbodybilltypecode("4C");
						if("工装".equals(billtype)) {
							itemvo.setCbodywarehouseid(GetBaseDAOUtil.getstordocpk("GZ001"));//仓库必填
						}else if("家装".equals(billtype)) {
							itemvo.setCbodywarehouseid(GetBaseDAOUtil.getstordocpk("JZ002"));//仓库必填
						}
						itemvo.setCfirstbillhid(pk_order);
						itemvo.setCfirstbillbid(vector.get(34).toString());
//						itemvo.setCfirsttype("55A2");
						itemvo.setCinvbasid(pk_invbasdoc);
						itemvo.setCinventoryid(pk_invmandoc);
//						icheadvo.setCinventoryid(pk_invmandoc);
						itemvo.setCinventorycode(cmaterialcode);
						itemvo.setCprojectid(cprojectid);
						itemvo.setCreceieveid(def1);//收货单位基本档案
						itemvo.setCrowno(Integer.toString((k+1)*10));
						itemvo.setCsourcebillhid(pk_order);
						itemvo.setCsourcebillbid(vector.get(34).toString());
//						itemvo.setCsourcetype("55A2");
						itemvo.setVsourcerowno("10");
						itemvo.setDbizdate(PubEnv.getServerDate());
						itemvo.setDdeliverdate(PubEnv.getServerDate());
						itemvo.setFassertcardflag(UFBoolean.FALSE);
						itemvo.setFchecked(0);
						itemvo.setFlargess(UFBoolean.FALSE);
						itemvo.setIsok(UFBoolean.FALSE);
						itemvo.setNbarcodenum(new UFDouble(0));//条码数量
						UFDouble ninnum = vector.get(1) == null ? null : new UFDouble(vector.get(1).toString());
						itemvo.setNoutnum(ninnum);//实出数量
						itemvo.setNshouldoutnum(ninnum);//应出数量 
						UFDouble Hsl = vector.get(49) == null ? null : new UFDouble(vector.get(49).toString());
						//换算率						
						itemvo.setHsl(Hsl);
						//没有换算率则辅数量为空
						UFDouble ninassistnum =UFDouble.ZERO_DBL;
						if(Hsl != null) {
							ninassistnum = new UFDouble(ninnum.div(Hsl).toString(),2);
							itemvo.setNoutassistnum(new UFDouble(ninassistnum));//实出辅数量
							itemvo.setNshouldoutassistnum(ninassistnum);//应入辅数量 
						}
						//辅计量单位ID 
						itemvo.setCastunitid(vector.get(28) == null ? null : GetBaseDAOUtil.getMeasidByNames(vector.get(28).toString()));	
						
						itemvo.setPk_bodycalbody(GetBaseDAOUtil.getcalpk(pk_corp));
						itemvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
						itemvo.setAttributeValue("pk_corp", pk_corp);
						itemvo.setVbatchcode(vector.get(7)==null?"":vector.get(7).toString());
						itemvo.setVfirstbillcode(headvo.getVbillno());
						
						itemvo.setVfree1(vector.get(12)==null?null:vector.get(12).toString());//颜色
						itemvo.setVfree2(vector.get(14)==null?null:vector.get(14).toString());//合金
						itemvo.setVfree3(vector.get(13)==null?null:vector.get(13).toString());//定尺
						itemvo.setVfree4(vector.get(15)==null?null:vector.get(15).toString());//标准
						
						itemvo.setAttributeValue("cquoteunitid", GetBaseDAOUtil.getMeasidByName(vector.get(21).toString()));//报价计量单位
						itemvo.setAttributeValue("cquotecurrency", "00010000000000000001");//报价币种
						itemvo.setVsourcebillcode(headvo.getVbillno());
						itemvo.setAttributeValue("pk_defdoc1", vector.get(37)==null?null:vector.get(37).toString());//楼号楼层
						itemvo.setAttributeValue("pk_defdoc2", vector.get(38)==null?null:vector.get(38).toString());//樘数（数量）
						itemvo.setAttributeValue("pk_defdoc3", vector.get(39)==null?null:vector.get(39).toString());//框统计
						itemvo.setAttributeValue("pk_defdoc4", vector.get(40)==null?null:vector.get(40).toString());//扇统计
						itemvo.setAttributeValue("pk_defdoc5", vector.get(41)==null?null:vector.get(41).toString());//半成品分类
						itemvo.setAttributeValue("pk_defdoc6", vector.get(42)==null?null:vector.get(42).toString());//面积
						itemvo.setAttributeValue("pk_defdoc7", vector.get(43)==null?null:vector.get(43).toString());//切割长度
						itemvo.setAttributeValue("pk_defdoc8", vector.get(44)==null?null:vector.get(44).toString());//切割角度左下
						itemvo.setAttributeValue("pk_defdoc9", vector.get(45)==null?null:vector.get(45).toString());//切割角度右上
						itemvo.setAttributeValue("pk_defdoc10",vector.get(46)==null?null:vector.get(46).toString());//备注
						itemvo.setAttributeValue("pk_defdoc11",vector.get(19)==null?null:vector.get(19).toString());//宽度
						itemvo.setAttributeValue("pk_defdoc12",vector.get(20)==null?null:vector.get(20).toString());//高度
						itemvo.setAttributeValue("pk_defdoc13",vector.get(47)==null?null:vector.get(47).toString());//系列
						itemvo.setAttributeValue("pk_defdoc14",vector.get(48)==null?null:vector.get(48).toString());//玻璃编号
						itemvo.setAttributeValue("pk_defdoc20",vector.get(36)==null?null:vector.get(36).toString());//开票类型
						//回写数量
						UFDouble updatenum =  new UFDouble(vector.get(51)==null?"0":vector.get(51).toString())
								.add(new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));
						updatemap.put(vector.get(34).toString(), updatenum);
						itemvos[k]=itemvo;
						k = k + 1;
					}
				}
				aggvo.setChildrenVO(itemvos);
				aggvo.setStatus(VOStatus.NEW);
				aggvos[0] = aggvo;
				GeneralBillVO[] res = isaleout.insertSaleOuts(aggvos);
				GeneralBillVO resvo = res[0];
				Boolean updateres = iorder.UpdateInExecNum(updatemap);
	//			MessageDialog.showHintDlg(mainpanel, "成功", "销售出库单"+resvo.getVBillCode()+"新增成功");
				MessageDialog.showHintDlg(mainpanel, "成功", "销售出库单新增成功!");
				this.closeCancel();
			}  catch (Exception e1) {
				MessageDialog.showErrorDlg(mainpanel, "错误", e1.getMessage());
				return;
			}
		}
		
		//取消按钮
		if(e.getSource() == getCancelBtn()){
			this.closeCancel();
		}
		
		

		// 全选
		if (e.getSource() == getSelectallBtn()) {
			onselectall(true);
		}

		// 全消
		if (e.getSource() == getCancelallBtn()) {
			onselectall(false);
		}
		
		
		// 筛选
		if (e.getSource() == getQueryBtn()) {
			TemplateInfo ti = new TemplateInfo();
			ti.setTemplateId(null);
			ti.setPk_Org(ce.getCorporation().getPrimaryKey());
			ti.setUserid(ce.getUser().getPrimaryKey());
			ti.setCurrentCorpPk(ce.getCorporation().getPrimaryKey());
			// 功能节点默人模板分配后查询SELECT * from pub_systemplate order by ts desc
			ti.setFunNode("40H204");
			ti.setNodekey("qt");
			QueryConditionDLG d = new QueryConditionDLG(this, ti, "销售出库明细");
			Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
			d.setSize(dimension.width - 1000, dimension.height - 650);
			d.setLocation(500, 300);
			if (d.showModal() != UIDialog.ID_OK) {
				return;
			}

			String dlgsql = d.getWhereSQL();
			if (!(null != dlgsql && !"".equals(dlgsql))) {
				getJlcardPanel().getBillModel().setBodyDataVO(inArrays);
				return;
			}
			String quresql = "select * from mmpac_order_in where  " + dlgsql + " and ";
			IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());

			try {
				List<String> pks = new ArrayList<String>();
				if (null != inArrays && inArrays.length > 0) {
					for (OrderInVO vo : inArrays) {
						String pk_order_in = vo.getPk_order_in();
						pks.add(pk_order_in);
					}
					SqlBuilder sqlbuild = new SqlBuilder();
					sqlbuild.append(quresql);
					sqlbuild.append("pk_order_issue", pks.toArray(new String[0]));
					List<OrderInVO> lisorderinvos = (List<OrderInVO>) iuap.executeQuery(sqlbuild.toString(),
							new BeanListProcessor(OrderInVO.class));
					OrderInVO[] invos = lisorderinvos.toArray(new OrderInVO[0]);
					getJlcardPanel().getBillModel().setBodyDataVO(invos);

				} else {
					getJlcardPanel().getBillModel().setBodyDataVO(null);
				}

			} catch (BusinessException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}

		}
	
	}
	
	//客商项目档案
	private String getpkcumdoc(String pk_cubasdoc ) throws BusinessException {
	  String sql="select pk_cumandoc from bd_cumandoc where pk_cubasdoc='"+pk_cubasdoc+"'  ";
	  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	  
	  Object pk_cumandocobj = iuap.executeQuery(sql, new ColumnProcessor());
      if (pk_cumandocobj == null) {
          return "";
      }
      return pk_cumandocobj.toString();
		
	}
	
	//收发类别
	private String getpkrdcl(String rdcode ) throws BusinessException {
	  String sql="select pk_rdcl from bd_rdcl where rdcode='"+rdcode+"'  ";
	  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	  
	  Object pk_rdclobj =  iuap.executeQuery(sql, new ColumnProcessor());
      if (pk_rdclobj == null) {
          return "";
      }
      return pk_rdclobj.toString();
		
	}
	
	
	

}
