package u8c.ui.mmpac.datamodel;

import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.ui.hr.frame.bill.manage.ManageDataModel;
import nc.ui.hr.frame.persistence.PersitenceDelegator;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import u8c.itf.mmpac.mmpac.IOrderTotalInfo;
import u8c.vo.OrderInVO;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import u8c.vo.OrderOtherinVO;
import u8c.vo.OrderOtheroutVO;


public class OrderDataModel extends ManageDataModel{
	public OrderDataModel(){
		super();
		
		
		setHeadPk(new OrderMainVO().getPKFieldName());
		setHeadVOClass(OrderMainVO.class); 
		
		
		this.setBodyVOClassArray(new Class[] {OrderInVO.class, OrderIssueVO.class, OrderOtheroutVO.class,OrderOtherinVO.class});
		
		this.setBodyTableNames(new String[] {new OrderInVO().getTableName(), new OrderIssueVO().getTableName(), new OrderOtheroutVO().getTableName(),new OrderOtherinVO().getTableName()});
		
		this.setBodyTableCodeArray(new String[] { new OrderInVO().getTableName(),new OrderIssueVO().getTableName(),new OrderOtheroutVO().getTableName(),new OrderOtherinVO().getTableName()});
		
		this.setBodyPkArray(new String[] {OrderInVO.PK_ORDER_IN, OrderIssueVO.PK_ORDER_ISSUE, OrderOtheroutVO.PK_ORDER_OTHEROUT,OrderOtherinVO.PK_ORDER_OTHERIN});
		
		this.setBodyFkArray(new String[] {OrderInVO.PK_ORDER, OrderIssueVO.PK_ORDER, OrderOtheroutVO.PK_ORDER,OrderOtherinVO.PK_ORDER});
	}
	
	@Override
	public String getBillTempletBusiType() {
		return null;
	}

	@Override
	public String getBillTempletCode() { 
		return "55A2";
	}

	@Override
	public String getNormalQueryTemplateCode() {
		return null;
	}

	public boolean UpdateStatus(HRAggVO aggvo,int status) throws BusinessException{
		return getIOrderTotalInfo().UpdateStatus(aggvo,status);
	}
	
	public boolean execApprove(HRAggVO aggvo) throws BusinessException{
		return getIOrderTotalInfo().execApprove(aggvo);
	}
	
	static IOrderTotalInfo ipti = null;
	
	public static IOrderTotalInfo getIOrderTotalInfo() {
		if (ipti == null) {
			ipti = (IOrderTotalInfo) NCLocator.getInstance().lookup(IOrderTotalInfo.class);
		}
		return ipti;
	}
	
	public Object onSave(Object data, String checkClassMethodName, String lockClassName) throws Exception
    {
        if (data instanceof HRAggVO)
        {
            return PersitenceDelegator.saveAggVO((HRAggVO) data, checkClassMethodName, lockClassName);
        }
        else if (data instanceof HRAggVO[])
        {
            return PersitenceDelegator.saveAggVOArray((HRAggVO[]) data, checkClassMethodName, lockClassName);
        }
        
        return null;
    }
}
