package u8c.ui.mmpac.panel;

import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.MainPanel;
import nc.ui.hr.frame.TopPanel;
import nc.ui.hr.frame.action.AddLineAction;
import nc.ui.hr.frame.action.CancelAction;
import nc.ui.hr.frame.action.DeleteLineAction;
import nc.ui.hr.frame.action.EditLineAction;
import nc.ui.hr.frame.action.RefreshAction;
import nc.ui.hr.frame.bill.manage.ManageDataModel;
import nc.ui.hr.frame.button.AbstractBtnReg;
import nc.ui.hr.frame.button.BtnStateReg;
import nc.ui.pub.bill.BillCardPanel;
import u8c.ui.mmpac.action.GenOtheroutinAction;
import u8c.ui.mmpac.action.OrderAddAction;
import u8c.ui.mmpac.action.OrderApproveAction;
import u8c.ui.mmpac.action.OrderDeleteAction;
import u8c.ui.mmpac.action.OrderEditAction;
import u8c.ui.mmpac.action.OrderExportAction;
import u8c.ui.mmpac.action.OrderImportAction;
import u8c.ui.mmpac.action.OrderQueryAction;
import u8c.ui.mmpac.action.OrderReturnFromCardToListAction;
import u8c.ui.mmpac.action.OrderSaveAction;
import u8c.ui.mmpac.action.OrderUnApproveAction;
import u8c.ui.mmpac.action.PushMaterialAction;
import u8c.ui.mmpac.action.PushOtherInAction;
import u8c.ui.mmpac.action.PushOtherOutAction;
import u8c.ui.mmpac.action.PushProductAction;
import u8c.ui.mmpac.action.PushSaleOutAction;
import u8c.ui.mmpac.datamodel.OrderDataModel;
import u8c.ui.mytest.button.MyBtnStateReg;


public class OrderTestUI extends FrameUI{

	
	protected void initialize(){
		super.initialize();
	}

	@Override
	protected void initButtons() {
		
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_ADD);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EDIT);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_DELETE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_QUERY);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_REFRESH);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_SAVE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_CANCEL);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_ADD_LINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_DEL_LINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EDIT_LINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_RETURN);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EXAMINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_CANCELEXAMINE);
//		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_IMPORT);
//		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EXPORT);
//		getBtnManager().addButtonByID(AbstractBtnReg.USERBTN_PUSHMATERIAL);
//		getBtnManager().addButtonByID(AbstractBtnReg.USERBTN_PUSHPRODUCT);
		getBtnManager().addButtonByID(AbstractBtnReg.USERBTN_GENOUTIN);//生成出入库页签
		getBtnManager().addButtonByID(AbstractBtnReg.USERBTN_boExportImport); //导出/导入
		getBtnManager().addButtonByID(AbstractBtnReg.USERBTN_ADDPRAYBILL); //生单
		getBtnManager().addChildButtonsByIDs(AbstractBtnReg.USERBTN_ADDPRAYBILL , 
				new int []{AbstractBtnReg.USERBTN_PUSHMATERIAL,AbstractBtnReg.USERBTN_PUSHPRODUCT,
				AbstractBtnReg.USERBTN_PUSHOTHEROUT,AbstractBtnReg.USERBTN_PUSHOTHERIN,AbstractBtnReg.USERBTN_PUSHSALEOUT});
		
		getBtnManager().addChildButtonsByIDs(AbstractBtnReg.USERBTN_boExportImport , 
				new int []{AbstractBtnReg.SYSBTN_EXPORT,AbstractBtnReg.SYSBTN_IMPORT});

		
		
		
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_ADD, new OrderAddAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EDIT, new OrderEditAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_DELETE, new OrderDeleteAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_QUERY, new OrderQueryAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_REFRESH, new RefreshAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_SAVE, new OrderSaveAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_CANCEL, new CancelAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_ADD_LINE, new AddLineAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EDIT_LINE, new EditLineAction(this));		
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_DEL_LINE, new DeleteLineAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_RETURN, new OrderReturnFromCardToListAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EXAMINE, new OrderApproveAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_CANCELEXAMINE, new OrderUnApproveAction(this));
		getBtnManager().regCmd(AbstractBtnReg.USERBTN_GENOUTIN, new GenOtheroutinAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_IMPORT, new OrderImportAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EXPORT, new OrderExportAction(this));
		getBtnManager().regCmd(AbstractBtnReg.USERBTN_PUSHMATERIAL, new PushMaterialAction(this));
		getBtnManager().regCmd(AbstractBtnReg.USERBTN_PUSHPRODUCT, new PushProductAction(this));
		getBtnManager().regCmd(AbstractBtnReg.USERBTN_PUSHOTHEROUT, new PushOtherOutAction(this));
		getBtnManager().regCmd(AbstractBtnReg.USERBTN_PUSHOTHERIN, new PushOtherInAction(this));
		getBtnManager().regCmd(AbstractBtnReg.USERBTN_PUSHSALEOUT, new PushSaleOutAction(this));
		
		getBtnManager().adjustButtonOrder(new int[] {
				AbstractBtnReg.SYSBTN_ADD,
				AbstractBtnReg.SYSBTN_EDIT,
				AbstractBtnReg.SYSBTN_DELETE,
				AbstractBtnReg.SYSBTN_ADD_LINE,
				AbstractBtnReg.SYSBTN_EDIT_LINE,
				AbstractBtnReg.SYSBTN_DEL_LINE,
				AbstractBtnReg.SYSBTN_QUERY,
				AbstractBtnReg.SYSBTN_REFRESH, 
				AbstractBtnReg.SYSBTN_SAVE,
				AbstractBtnReg.SYSBTN_CANCEL,
				AbstractBtnReg.SYSBTN_RETURN,
				AbstractBtnReg.SYSBTN_EXAMINE,
				AbstractBtnReg.SYSBTN_CANCELEXAMINE,
				AbstractBtnReg.USERBTN_GENOUTIN,
				AbstractBtnReg.SYSBTN_IMPORT,
				AbstractBtnReg.SYSBTN_EXPORT,
				AbstractBtnReg.USERBTN_PUSHMATERIAL,
				AbstractBtnReg.USERBTN_PUSHPRODUCT,
				AbstractBtnReg.USERBTN_boExportImport,
				AbstractBtnReg.USERBTN_ADDPRAYBILL,
				AbstractBtnReg.USERBTN_PUSHOTHEROUT,
				AbstractBtnReg.USERBTN_PUSHOTHERIN,
				AbstractBtnReg.USERBTN_PUSHSALEOUT
				}
				);
	}
	
	@Override
	protected MainPanel createMainPanel() { 
		ManageDataModel model = (ManageDataModel) getDataModel();
		return new OrderMainPanel(this,  model.getBillTempletCode(), model.getBillTempletBusiType());
	}

	@Override
	protected TopPanel createTopPanel() { 
		return new OrderTopPanel(this);
	}
	
	@Override
	protected OrderDataModel createDataModel() { 
		return new OrderDataModel();
	}

	@Override
	public boolean needLeftPanel() { 
		return false;
	}

	@Override
	protected BtnStateReg createButtonStateRegister() { // 按钮状态注册类
		return  new MyBtnStateReg(getDataModel().getState());
	}
	
	
	@Override
	public boolean needTopPanel() { 
		return true;
	}
	
	@Override
	public String getQueryNodeKey() {
		return "40H201";
	}
	
	@Override
	public String getModuleCode() { 
		return "40H201";
	}
	
	public BillCardPanel getBillCardPanel() {
		this.getBtnManager().setButtonEnabled(AbstractBtnReg.SYSBTN_RETURN, true);
		return ((OrderMainPanel) (this.getMainPanel())).getBillCardPanel();
	}


}
