package u8c.bs.mmpac.bp;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import nc.bs.dao.BaseDAO;
import nc.bs.pub.billcodemanage.BillcodeGenerater;
import nc.hr.utils.PubEnv;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import u8c.pubitf.rule.ICompareRule;
import u8c.pubitf.rule.IRule;
import u8c.pubitf.rule.IValidate;
import u8c.vo.ExAggOrderMainVO;
import u8c.vo.OrderInVO;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import u8c.bs.mmpac.bp.DefaultValueRule;

public class OrderInsertBP {

	BaseDAO dao = new BaseDAO();
	
	
	public ExAggOrderMainVO[] save(ExAggOrderMainVO[] bills) throws BusinessException {
		if (bills != null && bills.length != 0) {
			ExAggOrderMainVO[] vos = null;
			this.execBeforeRules(bills);
			vos = this.insertBills(bills);
			this.execAfterRules(bills);
			return vos;
		} else {
			return null;
		}
	}
	
	private ExAggOrderMainVO[] insertBills(ExAggOrderMainVO[] bills) throws BusinessException {
		for (int i = 0; i < bills.length; i++) {
			OrderMainVO headvo = (OrderMainVO) bills[i].getParentVO();
			String pk_order = dao.insertVO(headvo);
			CircularlyAccessibleValueObject[] bodyvos = bills[i].getChildrenVO();
			for (int j = 0; j < bodyvos.length; j++) {
				OrderInVO  orderInVO = (OrderInVO) bodyvos[j];
				Object bdef1 = bodyvos[j].getAttributeValue("bdef1");
				if("成品明细".equals(bdef1)) {
					orderInVO.setPk_order(pk_order);
					dao.insertVO(orderInVO);
				}else if("材料明细".equals(bdef1)) {
					OrderIssueVO orderIssueVO = new OrderIssueVO();
					orderIssueVO.setPk_order(pk_order);
					orderIssueVO.setPrjtypecode(orderInVO.getPrjtypecode());
					orderIssueVO.setStandard(orderInVO.getStandard());
					orderIssueVO.setNum(orderInVO.getNum());
					orderIssueVO.setCmaterialname(orderInVO.getCmaterialname());
					orderIssueVO.setConf(orderInVO.getConf());
					orderIssueVO.setExecnum(orderInVO.getExecnum());
					orderIssueVO.setDr(orderInVO.getDr());
					orderIssueVO.setSpec(orderInVO.getSpec());
					orderIssueVO.setNprice(orderInVO.getNprice());
					orderIssueVO.setTaxprice(orderInVO.getTaxprice());
					orderIssueVO.setModel(orderInVO.getModel());
					orderIssueVO.setHeight(orderInVO.getHeight());
					orderIssueVO.setTax(orderInVO.getTax());
					orderIssueVO.setCastunitid(orderInVO.getCastunitid());
					orderIssueVO.setWeight(orderInVO.getWeight());
					orderIssueVO.setPrjtypename(orderInVO.getPrjtypename());
					orderIssueVO.setExecnastnum(orderInVO.getExecnastnum());
					orderIssueVO.setSizing(orderInVO.getSizing());
					orderIssueVO.setAlloy(orderInVO.getAlloy());
					orderIssueVO.setColor(orderInVO.getColor());
					orderIssueVO.setNastnum(orderInVO.getNastnum());
					orderIssueVO.setPrjcode(orderInVO.getPrjcode());
					orderIssueVO.setTaxmny(orderInVO.getTaxmny());
					orderIssueVO.setCmaterialcode(orderInVO.getCmaterialcode());
					orderIssueVO.setRound(orderInVO.getRound());
					orderIssueVO.setPrjname(orderInVO.getPrjname());
					orderIssueVO.setVbatchcode(orderInVO.getVbatchcode());
					orderIssueVO.setWidth(orderInVO.getWidth());
					orderIssueVO.setNmny(orderInVO.getNmny());
					orderIssueVO.setUnitid(orderInVO.getUnitid());
					orderIssueVO.setTs(orderInVO.getTs());
					orderIssueVO.setBdef1(orderInVO.getBdef1());
					orderIssueVO.setBdef2(orderInVO.getBdef2());
					orderIssueVO.setBdef3(orderInVO.getBdef3());
					orderIssueVO.setBdef4(orderInVO.getBdef4());
					orderIssueVO.setBdef5(orderInVO.getBdef5());
					orderIssueVO.setBdef6(orderInVO.getBdef6());
					orderIssueVO.setBdef7(orderInVO.getBdef7());
					orderIssueVO.setBdef8(orderInVO.getBdef8());
					orderIssueVO.setBdef9(orderInVO.getBdef9());
					orderIssueVO.setBdef10(orderInVO.getBdef10());
					orderIssueVO.setBdef11(orderInVO.getBdef11());
					orderIssueVO.setBdef12(orderInVO.getBdef12());
					orderIssueVO.setBdef13(orderInVO.getBdef13());
					orderIssueVO.setBdef14(orderInVO.getBdef14());
					orderIssueVO.setBdef15(orderInVO.getBdef15());
					orderIssueVO.setBdef16(orderInVO.getBdef16());
					orderIssueVO.setBdef17(orderInVO.getBdef17());
					orderIssueVO.setBdef18(orderInVO.getBdef18());
					orderIssueVO.setBdef19(orderInVO.getBdef19());
					orderIssueVO.setBdef20(orderInVO.getBdef20());
					dao.insertVO(orderIssueVO);
				}
			}
		}
		
		
		return bills;

	}
	
	//前规则
	protected void addBeforeRule(List<Object> rules) throws BusinessException {
		// 默认值填充
		rules.add(new DefaultValueRule());
		//数据处理
		rules.add(new SpecialDataRule());
		//数据校验
		rules.add(new ValidateRule());
		
	}

	
	//后规则
	protected void addAfterRule(List<Object> rules) throws BusinessException {
	}

	private void execBeforeRules(ExAggOrderMainVO[] bills) throws BusinessException {
		List<Object> rules = new ArrayList();
		this.addBeforeRule(rules);
		this.execRules(rules, bills);
	}
	
	private void execAfterRules(ExAggOrderMainVO[] bills) throws BusinessException {
		List<Object> rules = new ArrayList();
		this.addAfterRule(rules);
		this.execRules(rules, bills);
	}
	
	private void execRules(List<Object> rules, ExAggOrderMainVO[] bills) throws BusinessException {
		if (null != rules && rules.size() > 0) {
			Iterator var3 = rules.iterator();

			while (var3.hasNext()) {
				Object object = var3.next();
				if (object instanceof IValidate) {
					IValidate<ExAggOrderMainVO> rule = (IValidate) object;
					rule.validate(bills);
				} else if (object instanceof IRule) {
					IRule<ExAggOrderMainVO> rule = (IRule) object;
					rule.process(bills);
				} else if (object instanceof ICompareRule) {
					ICompareRule<ExAggOrderMainVO> rule = (ICompareRule) object;
					rule.process(bills, (ExAggOrderMainVO[]) null);
				}
			}
		}

	}

}
