package u8c.impl.mmpac.mmpac;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IPKLockBS;
import nc.itf.uap.LockableVO;
import nc.itf.uap.bd.cust.ICustBasDocOperate;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.bd.b08.CubasdocVO;
import nc.vo.bd.b08.CustBasVO;
import nc.vo.pub.BusinessException;
import u8c.bs.servlet.service.BaseServlet;
import u8c.log.NcLog;

public class CustdocAddImpl extends BaseServlet implements IHttpServletAdaptor{

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			String js = buildJson(req, resp, this.getClass().getName());
			JSONArray jsdata = JSON.parseArray(js);
			NcLog.info("客商新增开始：" + jsdata);
			String rsmsg = handle(jsdata);
			resp.getWriter().write(formatRSJsonData(STATUS_SUCCESS, "", rsmsg).toString()); // 返回
		} catch (Exception e) {
			e.printStackTrace();
			NcLog.info("客商新增报错：" + e.getMessage());
			resp.getWriter().write(formatRSJsonData(STATUS_FAILURE, "请求服务失败,错误信息:" + e.getMessage(), null).toString()); // 返回
		}
	}

	public String handle(JSONArray array) throws Exception {
		JSONArray res = new JSONArray();
		// 操作员
		String user = "";
		try {
			for (int i = 0; i < array.size(); i++) {
				JSONObject headjs = array.getJSONObject(i);
				user = getStringNotNullException(headjs.get("user"), "user");
				InvocationInfoProxy.getInstance().setUserCode(getUser(user));
				CubasdocVO cuBasDocVo = getCustvo(headjs);
				// 保存方法
				ICustBasDocOperate custOperate = NCLocator.getInstance().lookup(ICustBasDocOperate.class);
				// 生成的主键
				String pk_cubasdoc = custOperate.insertCust(cuBasDocVo, false);
				// 返回关键信息：主键&&编码
				JSONObject resultjs = new JSONObject();
				resultjs.put("pk_cubasdoc", pk_cubasdoc);
				resultjs.put("custcode", cuBasDocVo.getCustBasVO().getAttributeValue("custcode"));
				res.add(resultjs);
			}
			return res.toString();
		} catch (Exception e) {
			// 解pk锁,不报错不用解锁
			IPKLockBS pkbs = NCLocator.getInstance().lookup(IPKLockBS.class);
			LockableVO[] pkvo = pkbs.getUserLockVOs_RequiresNew(user,
					InvocationInfoProxy.getInstance().getUserDataSource());
			if (pkvo != null) {
				for (int j = 0; j < pkvo.length; j++) {
					pkbs.releaseLock_RequiresNew(
							pkvo[j].getLockType() == 1 ? pkvo[j].getLockable() + IPKLockBS.STR_SHARED_LOCK
									: pkvo[j].getLockable(),
							user, InvocationInfoProxy.getInstance().getUserDataSource());
				}
			}
			NcLog.info("客商新增报错：" + e);
			throw new BusinessException("客商新增保存错误：" + e.getMessage());
		}
	}
	

	/**
	 * 拼装客商基本档案vo
	 * 
	 * @param headjs
	 * @return
	 * @throws BusinessException
	 */
	private CubasdocVO getCustvo(JSONObject headjs) throws BusinessException {
		CubasdocVO cuBasDocVo = new CubasdocVO();
		CustBasVO cusVos = new CustBasVO();

		String user = getStringNotNullException(headjs.get("user"), "user");
		String custcode = getStringNotNullException(headjs.get("custcode"), "custcode");
		String custname = getStringNotNullException(headjs.get("custname"), "custname");
		String areacl = getStringNotNullException(headjs.get("areacl"), "areacl");
		String corp = getStringNotNullException(headjs.get("corp"), "corp");
		String custshortname = getStringNotNullException(headjs.get("custshortname"), "custshortname");
		cusVos.setCustcode(custcode);// 客商档案编码
		cusVos.setCustname(custname);// 客商名称
		cusVos.setCustshortname(custshortname);// 客户简称
		cusVos.setCreator(getUser(user));// 制单人
		cusVos.setPk_areacl(areacl);// 区域
		cusVos.setPk_corp(corp);
		cusVos.setCustprop(0);// 客商类型
		cusVos.setDr(0);
		cuBasDocVo.setParentVO(cusVos);
		return cuBasDocVo;
	}


	/**
	 * 用户信息查询
	 * 
	 * @param cuserid
	 * @return
	 * @throws BusinessException
	 */
	public String getUser(String code) throws BusinessException {
		String cuserid = null;

		String sql = " select cuserid from sm_user" + " where user_code  ='" + code + "' and dr =0 ";
		cuserid = (String) new BaseDAO().executeQuery(sql.toString(), new ColumnProcessor());
		if (cuserid == null) {
			throw new BusinessException("U8C不存在当前操作用户:" + code);
		}
		return cuserid;
	}

	public String getStringNotNullException(Object value, String itemname) throws BusinessException {
		if (value == null || value.toString().trim().length() == 0) {
			throw new BusinessException(itemname + "不能为空！");
		}
		return value.toString();
	}

	public String getStringIsNullException(Object value, String itemname) throws BusinessException {
		if (value == null || value.toString().trim().length() == 0) {
			return null;
		}
		return value.toString();
	}
		
}

