package u8c.impl.mmpac.mmpac;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

import org.apache.commons.lang.StringEscapeUtils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IVOPersistence;
import nc.itf.uap.bd.def.IDefdoc;
import nc.itf.uap.bd.inv.IInventoryAssign;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.bd.def.DefdocVO;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import u8c.bs.servlet.service.BaseServlet;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.log.NcLog;
/**
 * http://127.0.0.1/service/invadd?token=07a81a68-c60c-4ee4-83dc-25aa51a51497
 *
 * 物料接口
 * 
 */
public class InvAddImpl extends BaseServlet implements IHttpServletAdaptor{
	BaseDAO dao = new BaseDAO();
	IVOPersistence ivo = NCLocator.getInstance().lookup(IVOPersistence.class);
	IInventoryAssign iassign = NCLocator.getInstance().lookup(IInventoryAssign.class);
	UserTransaction trans;
	String color = "";//颜色
	String colordeflist = "";//颜色对应自定义档案列表主键
	String alloy = "";//合金
	String alloydeflist = "";//合金对应自定义档案列表主键
	String sizing = "";//定尺
	String sizingdeflist = "";//定尺对应自定义档案列表主键
	String standard = "";//标准
	String standarddeflist = "";//标准对应自定义档案列表主键
	IDefdoc idef = NCLocator.getInstance().lookup(IDefdoc.class);
	
	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			trans = NCLocator.getInstance().lookup(UserTransaction.class);
			trans.begin();//开启事务
			color = GetBaseDAOUtil.getdefdef("YS（颜色）").getPk_defdef();
			colordeflist = GetBaseDAOUtil.getdefdef("YS（颜色）").getPk_defdoclist();
			alloy = GetBaseDAOUtil.getdefdef("HI（合金）").getPk_defdef();
			alloydeflist = GetBaseDAOUtil.getdefdef("HI（合金）").getPk_defdoclist();
			sizing = GetBaseDAOUtil.getdefdef("DC（定尺）").getPk_defdef();
			sizingdeflist = GetBaseDAOUtil.getdefdef("DC（定尺）").getPk_defdoclist();
			standard = GetBaseDAOUtil.getdefdef("BZ（标准）").getPk_defdef();
			standarddeflist = GetBaseDAOUtil.getdefdef("BZ（标准）").getPk_defdoclist();
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSON.parseObject(createStr);
			//接口返回结果
			JSONObject returnobj = new JSONObject();
			//正常返回json
			JSONArray result = new JSONArray();
			//报错返回json
			JSONArray errMessage = new JSONArray();
			
			String token =req.getParameter("token");
			if(!(token!=null && !token.equals("")&&("07a81a68-c60c-4ee4-83dc-25aa51a51497").equals(token))){
				errMessage.add(formatRSJsonData("失败",
						"请确认通讯密码是否正确！",""));
				returnobj.put("info", "失败");
				returnobj.put("errMessage", "请确认通讯密码是否正确！");
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			
			
			
			String checkresult = checkJson(json);
			if(checkresult != null){
				errMessage.add(formatRSJsonData("失败",
						checkresult,""));
				returnobj.put("info", "失败");
				returnobj.put("errMessage", checkresult);
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			JSONArray bodyArray = json.getJSONArray("result");
			for (Object Object : bodyArray) {

				JSONObject bodyObject = JSONObject.parseObject(Object.toString());
				//公司
				String pk_corp = bodyObject.getString("pk_corp");
				//存货编码
				String invCode = bodyObject.getString("invCode");
				//存货名称
				String invName = bodyObject.getString("invName");
				//简称
				String invShortName = bodyObject.getString("invShortName");
				//助记码
				String invMnecode = bodyObject.getString("invMnecode");
				//规格
				String invSpec = bodyObject.getString("invSpec");
				//型号
				String invType = bodyObject.getString("invType");
				//存货分类
				String invCl = GetBaseDAOUtil.getInvClid(bodyObject.getString("invCl"));
				//主计量单位
				String invMeas = GetBaseDAOUtil.getMeasidByName(bodyObject.getString("invMeas"));
				//税目
				String invTaxitems = GetBaseDAOUtil.gettaxitemid("4001");
				//图号
				String graphid = bodyObject.getString("graphid");
				//长度
				String length = bodyObject.getString("length");
				//高度
				String height = bodyObject.getString("height");
				//宽度
				String width = bodyObject.getString("width");
				//备注
				String memo = bodyObject.getString("memo");
				//批次管理
				String wholemanaflag = bodyObject.getString("wholemanaflag");
				//颜色
				Object ys = bodyObject.getString("ys");
				//合金
				Object hj = bodyObject.getString("hj");
				//定尺
				Object dc = bodyObject.getString("dc");
				//标准
				Object bz = bodyObject.getString("bz");
				//辅计量管理
				Object assistunit = bodyObject.getString("assistunit");
				
				if(!ys.equals("")&&ys != null) {
					String yspk = GetBaseDAOUtil.getdefdocid(colordeflist, ys.toString());
					if(yspk.equals("")) {
						genDocVO(pk_corp, ys.toString());
					}
				}
				if(!hj.equals("")&&hj != null) {
					String hjpk = GetBaseDAOUtil.getdefdocid(alloydeflist, hj.toString());
					if(hjpk.equals("")) {
						genDocVO(pk_corp, hj.toString());
					}
				}
				if(!dc.equals("")&&dc != null) {
					String dcpk = GetBaseDAOUtil.getdefdocid(sizingdeflist, dc.toString());
					if(dcpk.equals("")) {
						genDocVO(pk_corp, dc.toString());
					}
				}
				if(!bz.equals("")&&bz != null) {
					String bzpk = GetBaseDAOUtil.getdefdocid(standarddeflist, bz.toString());
					if(bzpk.equals("")) {
						genDocVO(pk_corp, bz.toString());
					}
				}
				
				
				String pk_inv = "";
				InvbasdocVO invbasVo = GetBaseDAOUtil.getInvVO(invCode);
				if(invbasVo != null) {
					pk_inv = invbasVo.getPrimaryKey();
					invbasVo.setInvname(invName);
					invbasVo.setInvshortname(invShortName);
					invbasVo.setInvmnecode(invMnecode);
					invbasVo.setInvspec(invSpec);
					invbasVo.setInvtype(invType);
					invbasVo.setPk_invcl(invCl);
					invbasVo.setPk_measdoc(invMeas);
					invbasVo.setPk_taxitems(invTaxitems);
					invbasVo.setGraphid(graphid);
					invbasVo.setLength(length);
					invbasVo.setHeight(height);
					invbasVo.setWidth(width);
					invbasVo.setMemo(memo);
					invbasVo.setCreator("demo");
					invbasVo.setSealflag(UFBoolean.FALSE);
					if(!ys.equals("")) {
						invbasVo.setFree1(color);
					}
					if(!hj.equals("")) {
						invbasVo.setFree2(alloy);
					}
					if(!dc.equals("")) {
						invbasVo.setFree3(sizing);
					}
					if(!bz.equals("")) {
						invbasVo.setFree4(standard);
					}
					if(assistunit.toString().equals("Y")) {
						invbasVo.setAssistunit(UFBoolean.TRUE);
					}
					else {
						invbasVo.setAssistunit(UFBoolean.FALSE);
					}
					ivo.updateVO(invbasVo);
				}
				else {
					invbasVo = new InvbasdocVO();
					invbasVo.setPk_corp(pk_corp);
					invbasVo.setInvcode(invCode);
					invbasVo.setInvname(invName);
					invbasVo.setInvshortname(invShortName);
					invbasVo.setInvmnecode(invMnecode);
					invbasVo.setInvspec(invSpec);
					invbasVo.setInvtype(invType);
					invbasVo.setPk_invcl(invCl);
					invbasVo.setPk_measdoc(invMeas);
					invbasVo.setPk_taxitems(invTaxitems);
					invbasVo.setGraphid(graphid);
					invbasVo.setLength(length);
					invbasVo.setHeight(height);
					invbasVo.setWidth(width);
					invbasVo.setMemo(memo);
					invbasVo.setAsset(UFBoolean.FALSE);
					invbasVo.setAssistunit(UFBoolean.FALSE);
					invbasVo.setAutobalancemeas(UFBoolean.FALSE);
					invbasVo.setDiscountflag(UFBoolean.FALSE);
					invbasVo.setFaset(UFBoolean.FALSE);
					invbasVo.setIselectrans(UFBoolean.FALSE);
					invbasVo.setIsmngstockbygrswt(UFBoolean.FALSE);
					invbasVo.setIsretail(UFBoolean.FALSE);
					invbasVo.setIsstorebyconvert(UFBoolean.FALSE);
					invbasVo.setLaborflag(UFBoolean.FALSE);
					invbasVo.setSetpartsflag(UFBoolean.FALSE);
					invbasVo.setUnitvolume(UFDouble.ZERO_DBL);
					invbasVo.setUnitweight(UFDouble.ZERO_DBL);
					invbasVo.setCreator(InvocationInfoProxy.getInstance().getUserCode());
					invbasVo.setCreatetime(new UFDateTime(System.currentTimeMillis()));
					invbasVo.setDr(0);
					invbasVo.setCreator("demo");
					invbasVo.setSealflag(UFBoolean.FALSE);
					if(!ys.equals("")) {
						invbasVo.setFree1(color);
					}
					if(!hj.equals("")) {
						invbasVo.setFree2(alloy);
					}
					if(!dc.equals("")) {
						invbasVo.setFree3(sizing);
					}
					if(!bz.equals("")) {
						invbasVo.setFree4(standard);
					}
					if(assistunit.toString().equals("Y")) {
						invbasVo.setAssistunit(UFBoolean.TRUE);
					}
					else {
						invbasVo.setAssistunit(UFBoolean.FALSE);
					}
					pk_inv = ivo.insertVO(invbasVo);
					//查看当前存货是否有对应的存货管理档案
					String pk_invman = IsExist(pk_inv);
					if(pk_invman.equals("")) {
						pk_invman = saveInvman(invbasVo,pk_inv,wholemanaflag);
					}
					
//					List<String> listpk = new ArrayList<String>();
//					listpk.add(pk_invman);
//					
//					//分配，这里的主键对应bd_calbody.pk_calbody
//					iassign.assignInvmandocByPkList(new String[] {"1001V51000000000034G"}, listpk, null);
				}
				
				result.add(formatRSJsonData("成功",
					     "",invCode));
			
			}
			trans.commit();//提交事务
			returnobj.put("info", "成功");
			returnobj.put("errMessage", "");
			returnobj.put("result", result);
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
		} catch (Exception e) {
			try {
				trans.rollback();
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}//异常时事务回滚
			JSONArray errMessage = new JSONArray();
			JSONObject returnobj = new JSONObject();
			String emsg = e.getMessage().replace("\"", "\'");
			errMessage.add(formatRSJsonData("失败",
					emsg,""));
			returnobj.put("info", "失败");
			returnobj.put("errMessage", emsg);
			returnobj.put("result", errMessage);	
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
			return;
		}
	}

	//生成自定义档案
	private void genDocVO(String pk_corp, String docname) throws BusinessException {
		DefdocVO docvo = new DefdocVO();
		docvo.setDoccode(docname);
		docvo.setDocname(docname);
		docvo.setDocsystype(1);
		docvo.setPk_corp(pk_corp);
		docvo.setPk_defdoclist(colordeflist);
		String respk = idef.insert(docvo);
	}

	/*
	 * 非空判断
	 */
	private String checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		String body = "result";//表体
		
		if (json.getJSONArray(body)==null) {
			empty = false;
			mags.append("请传入接口数据！ ");
			return mags.toString();
		}
		
		JSONArray oprepObjectBs = json.getJSONArray("result");
		
		String pk_corp = "pk_corp";//组织
		String invCode = "invCode";//存货编码
		String invName = "invName";//存货名称
		String invCl = "invCl";//存货分类
		String invMeas = "invMeas";//主计量单位
		String wholemanaflag = "wholemanaflag";
		String assistunit = "assistunit";//辅计量管理
 
		for(int i = 0; i < oprepObjectBs.size(); i++) {
			JSONObject oprepJsonObjectB = oprepObjectBs.getJSONObject(i);
			String[] HeadKey = {pk_corp,invCode,invName,invCl,invMeas,wholemanaflag,assistunit};
			int num = i+1;
			
			mags.append("第"+num+"块：{");
			for (String as : HeadKey) {

				if (oprepJsonObjectB.getString(as).isEmpty()) {
					empty = false;
					mags.append("'" + as + "' ");
				}
			}
			mags.append("}");
			
		}
		
		
		if (!empty) {
			return "以下字段不可为空："+mags;
		}
		else {
			return null;
		}
	}
	
	private String IsExist(String pk_inv) throws DAOException {
		String qrysql = "select pk_invmandoc from bd_invmandoc where isnull(dr,0) = 0 and pk_corp = '1001' and pk_invbasdoc = '"+pk_inv+"'";
		String pk_invmandoc = (String) dao.executeQuery(qrysql, new ColumnProcessor());
        if (pk_invmandoc == null) {
            return "";
        }
        return pk_invmandoc;
	}
	
	/**
	 * 存货管理档案
	 * @param invbasVo
	 * @param pk_inv
	 * @return
	 * @throws BusinessException
	 */
	private String saveInvman(InvbasdocVO invbasVo, String pk_inv,String wholemanaflag) throws BusinessException {
		InvmandocVO invmanVO = new InvmandocVO();
		
		invmanVO.setPk_invbasdoc(pk_inv);
		invmanVO.setAbctype("A");
		invmanVO.setAccflag(UFBoolean.FALSE);
		invmanVO.setExpaybacktax(UFDouble.ZERO_DBL);
		invmanVO.setInvlifeperiod(0);
		invmanVO.setIsappendant(UFBoolean.TRUE);
		invmanVO.setIsautoatpcheck(UFBoolean.TRUE);
		invmanVO.setIscancalculatedinvcost(UFBoolean.TRUE);
		invmanVO.setIscanpurchased(UFBoolean.TRUE);
		invmanVO.setIscansaleinvoice(UFBoolean.TRUE);
		invmanVO.setIscansold(UFBoolean.TRUE);
		invmanVO.setIsconfigable(UFBoolean.FALSE);
		invmanVO.setIsctlprodplanprice(UFBoolean.FALSE);
		invmanVO.setIsfatherofbom(UFBoolean.FALSE);
		invmanVO.setIsinvretfreeofchk(UFBoolean.TRUE);
		invmanVO.setIsinvretinstobychk(UFBoolean.FALSE);
		invmanVO.setIsinvreturned(UFBoolean.TRUE);
		invmanVO.setIsnoconallowed(UFBoolean.TRUE);
		invmanVO.setIsprimarybarcode(UFBoolean.FALSE);
		invmanVO.setIsrecurrentcheck(UFBoolean.FALSE);
		invmanVO.setIssalable(UFBoolean.FALSE);
		invmanVO.setIssecondarybarcode(UFBoolean.FALSE);
		invmanVO.setIsselfapprsupplier(UFBoolean.TRUE);
		invmanVO.setIsspecialty(UFBoolean.FALSE);
		invmanVO.setIssupplierstock(UFBoolean.FALSE);
		invmanVO.setIsused(UFBoolean.TRUE);
		invmanVO.setIsvirtual(UFBoolean.FALSE);
		invmanVO.setKeepwasterate(UFDouble.ZERO_DBL);
		invmanVO.setLowestprice(UFDouble.ZERO_DBL);
		invmanVO.setMantaxitem("");
		invmanVO.setMaxprice(UFDouble.ZERO_DBL);
		invmanVO.setNegallowed(UFBoolean.FALSE);
		invmanVO.setOutpriority(0);
		invmanVO.setOuttrackin(UFBoolean.FALSE);
		invmanVO.setPk_corp("1001");
		invmanVO.setPurchasestge("0");
		invmanVO.setPurwasterate(UFDouble.ZERO_DBL);
		invmanVO.setQualitymanflag(UFBoolean.FALSE);
		invmanVO.setQualityperiodunit(2);
		invmanVO.setSealflag(UFBoolean.FALSE);
		invmanVO.setSellproxyflag(UFBoolean.FALSE);
		invmanVO.setSerialmanaflag(UFBoolean.FALSE);
		invmanVO.setWholemanaflag(UFBoolean.FALSE);
		invmanVO.setDr(0);
		invmanVO.setConsumesettleflag(UFBoolean.FALSE);
		invmanVO.setCreatetime(new UFDateTime());
		invmanVO.setCreator("demo");
		if(wholemanaflag.equals("Y")) {
			invmanVO.setWholemanaflag(UFBoolean.TRUE);
		}
		else {
			invmanVO.setWholemanaflag(UFBoolean.FALSE);
		}
		//保存管理档案
		String pk_invman = dao.insertVO(invmanVO);
		
		return pk_invman;
	}
}
