package u8c.impl.mmpac.mmpac;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.SystemException;
import javax.transaction.UserTransaction;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import u8c.log.NcLog;
import u8c.vo.ExAggOrderMainVO;
import u8c.vo.OrderInVO;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IPKLockBS;
import nc.itf.uap.IVOPersistence;
import nc.itf.uap.LockableVO;
import nc.jdbc.framework.JdbcSession;
import nc.jdbc.framework.PersistenceManager;
import nc.jdbc.framework.processor.ColumnProcessor;

import java.sql.Connection;
import java.sql.SQLException;

import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.trade.pub.IBillStatus;
import u8c.bs.servlet.service.BaseServlet;
import u8c.bs.servlet.service.GetBaseDAOUtil;


public class OrderAddImpl extends BaseServlet implements IHttpServletAdaptor{
	BaseDAO dao = new BaseDAO();
	UserTransaction trans;


	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			
			
			
			trans = NCLocator.getInstance().lookup(UserTransaction.class);
			trans.begin();//开启事务
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSON.parseObject(createStr);
			//接口返回结果
			JSONObject returnobj = new JSONObject();
			//正常返回json
			JSONArray result = new JSONArray();
			//报错返回json
			JSONArray errMessage = new JSONArray();

			String token =req.getParameter("token");
			if(!(token!=null && !token.equals("")&&("07a81a68-c60c-4ee4-83dc-25aa51a51497").equals(token))){
				errMessage.add(formatRSJsonData("失败",
						"请确认通讯密码是否正确！",""));
				returnobj.put("info", "失败");
				returnobj.put("errMessage", "请确认通讯密码是否正确！");
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			
			String checkresult = checkJson(json);
			
			if(checkresult != null){
				errMessage.add(formatRSJsonData("失败",
						checkresult,""));
				returnobj.put("info", "失败");
				returnobj.put("errMessage", checkresult);
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			JSONArray bodyArray = json.getJSONArray("result");
			
		    String meg="";
		    StringBuffer sbf=new StringBuffer();
			for (Object Object : bodyArray) {

				JSONObject bodyObject = JSONObject.parseObject(Object.toString());
				String pk_corp = bodyObject.getString("pk_corp");
				String vbillno = bodyObject.getString("vbillno");
				Boolean isrepeat = IsRepeat(vbillno);
				if(isrepeat) {
					result.add(formatRSJsonData("失败",
							"单据号"+vbillno+"重复",""));
//				errMessage.add(formatRSJsonData("失败",
//						"单据号"+vbillno+"重复","").toString());
//				returnobj.put("info", "失败");
//				returnobj.put("errMessage", "单据号"+vbillno+"重复");
//				returnobj.put("result", errMessage);
//				resp.getWriter().write(returnobj.toString());
//				NcLog.info(returnobj.toString());
					meg=vbillno;	
					continue;
				}
				String dbilldate = bodyObject.getString("dbilldate");
				String pk_proposer = GetBaseDAOUtil.getUserid(bodyObject.getString("pk_proposer"));
				if(pk_proposer.equals("")) {
					result.add(formatRSJsonData("失败",
							"制单人"+bodyObject.getString("pk_proposer")+"未查到，请检查",""));
//				errMessage.add(formatRSJsonData("失败",
//						"制单人"+bodyObject.getString("pk_proposer")+"未查到，请检查","").toString());
//				returnobj.put("info", "失败");
//				returnobj.put("errMessage", "制单人"+bodyObject.getString("pk_proposer")+"未查到，请检查");
//				returnobj.put("result", errMessage);
//				resp.getWriter().write(returnobj.toString());
//				NcLog.info(returnobj.toString());
					meg=vbillno;	
					continue;
				}
				
				if(!"".equals(meg)) {
					throw new Exception("制单人或者单据号重复！");
				}
				
				String workmanid = GetBaseDAOUtil.getPsndocid(bodyObject.getString("workmanid"));
				String plandeptid = GetBaseDAOUtil.getDeptdocid(bodyObject.getString("plandeptid"));
				String vnote = bodyObject.getString("vnote");
		//		String busitype = GetBaseDAOUtil.getBusitypeid(bodyObject.getString("busitype"),pk_corp);
				OrderMainVO headvo = new OrderMainVO();
				//表头赋值
				headvo.setPk_corp(pk_corp);
				headvo.setVbillno(vbillno);
				headvo.setDbilldate(new UFDate(dbilldate));
				headvo.setPk_proposer(pk_proposer);
				headvo.setWorkmanid(workmanid);
				headvo.setPlandeptid(plandeptid);
				headvo.setVnote(vnote);
				headvo.setBusitype(bodyObject.getString("busitype"));
				headvo.setBillstatus(IBillStatus.FREE);
				String pk_order = dao.insertVO(headvo);
				//入库赋值
				if(bodyObject.getJSONArray("product")!=null) {
					JSONArray inArray = bodyObject.getJSONArray("product");
					for(int i = 0;i < inArray.size();i++) {
						Object inobj = inArray.get(i);
						JSONObject injsobj = JSONObject.parseObject(inobj.toString());
						String prjcode = injsobj.getString("prjcode");
						String prjname = GetBaseDAOUtil.getprojectname(prjcode);
						String prjtypecode = GetBaseDAOUtil.getprjtypecode(prjcode);
						String prjtypename = GetBaseDAOUtil.getprjtypename(prjcode);
						String vbatchcode = injsobj.getString("vbatchcode");
						String cmaterialcode = injsobj.getString("cmaterialcode");
						String invname = GetBaseDAOUtil.getinvname(cmaterialcode);
						//物料不存在
						if("".equals(invname)) {
//							result.add(formatRSJsonData("失败",
//									"物料"+cmaterialcode+"未查到，请检查",""));
							
							sbf.append("【"+cmaterialcode+"】");	
							continue;	
						}
						

						String invspec = GetBaseDAOUtil.getinvspec(cmaterialcode);
						String invtype = GetBaseDAOUtil.getinvtype(cmaterialcode);
						String width = GetBaseDAOUtil.getwidth(cmaterialcode);
						String height = GetBaseDAOUtil.getheight(cmaterialcode);
						String measname = GetBaseDAOUtil.getmeasname(cmaterialcode);
						String bdef11 = injsobj.getString("bdef11");//楼号楼层
						String bdef12 = injsobj.getString("bdef12");//樘数(数量) 
						String bdef13 = injsobj.getString("bdef13");//框统计
						String bdef14 = injsobj.getString("bdef14");//扇统计
						String bdef15 = injsobj.getString("bdef15");//半成品分类
						String bdef16 = injsobj.getString("bdef16");//面积
						String bdef17 = injsobj.getString("bdef17");//切割长度
						String bdef18 = injsobj.getString("bdef18");//切割角度左下
						String bdef19 = injsobj.getString("bdef19");//切割角度右上
						String bdef2 = injsobj.getString("bdef2");//备注
						String bdef20 = injsobj.getString("bdef20");//系列
						String bdef3 = injsobj.getString("bdef3");//玻璃编号
						
						OrderInVO invo = new OrderInVO();
						invo.setPrjcode(prjcode);;
						invo.setPrjname(prjname);
						invo.setPrjtypecode(prjtypecode);
						invo.setPrjtypename(prjtypename);
						invo.setVbatchcode(vbatchcode);
						invo.setCmaterialcode(cmaterialcode);
						invo.setCmaterialname(invname);
						invo.setSpec(invspec);
						invo.setModel(invtype);
						invo.setWidth(width);
						invo.setHeight(height);
						invo.setUnitid(measname);
						invo.setPk_order(pk_order);
						
						invo.setBdef11(bdef11);
						invo.setBdef12(bdef12);
						invo.setBdef13(bdef13);
						invo.setBdef14(bdef14);
						invo.setBdef15(bdef15);
						invo.setBdef16(bdef16);
						invo.setBdef17(bdef17);
						invo.setBdef18(bdef18);
						invo.setBdef19(bdef19);
						invo.setBdef2(bdef2);
						invo.setBdef20(bdef20);
						invo.setBdef3(bdef3);
						
						
						invo.setDr(0);
						if(injsobj.getString("num")!=null) {
							invo.setNum(new UFDouble(injsobj.getString("num")));
						}
						
						dao.insertVO(invo);
					}
				}
				//领料赋值
				if(bodyObject.getJSONArray("issue")!=null) {
					JSONArray issueArray = bodyObject.getJSONArray("issue");
					for(int i = 0;i < issueArray.size();i++) {
						Object issueobj = issueArray.get(i);
						JSONObject issuejsobj = JSONObject.parseObject(issueobj.toString());
						String prjcode = issuejsobj.getString("prjcode");
						String prjname = GetBaseDAOUtil.getprojectname(prjcode);
						String prjtypecode = GetBaseDAOUtil.getprjtypecode(prjcode);
						String prjtypename = GetBaseDAOUtil.getprjtypename(prjcode);
						String vbatchcode = issuejsobj.getString("vbatchcode");
						String cmaterialcode = issuejsobj.getString("cmaterialcode");
						String invname = GetBaseDAOUtil.getinvname(cmaterialcode);
						String invspec = GetBaseDAOUtil.getinvspec(cmaterialcode);
						String invtype = GetBaseDAOUtil.getinvtype(cmaterialcode);
						String width = GetBaseDAOUtil.getwidth(cmaterialcode);
						String height = GetBaseDAOUtil.getheight(cmaterialcode);
						String measname = GetBaseDAOUtil.getmeasname(cmaterialcode);
						String bdef11 = issuejsobj.getString("bdef11");//楼号楼层
						String bdef12 = issuejsobj.getString("bdef12");//樘数(数量) 
						String bdef13 = issuejsobj.getString("bdef13");//框统计
						String bdef14 = issuejsobj.getString("bdef14");//扇统计
						String bdef15 = issuejsobj.getString("bdef15");//半成品分类
						String bdef16 = issuejsobj.getString("bdef16");//面积
						String bdef17 = issuejsobj.getString("bdef17");//切割长度
						String bdef18 = issuejsobj.getString("bdef18");//切割角度左下
						String bdef19 = issuejsobj.getString("bdef19");//切割角度右上
						String bdef2 = issuejsobj.getString("bdef2");//备注
						String bdef20 = issuejsobj.getString("bdef20");//系列
						String bdef3 = issuejsobj.getString("bdef3");//玻璃编号
						
						
						OrderIssueVO issuevo = new OrderIssueVO();
						issuevo.setPrjcode(prjcode);;
						issuevo.setPrjname(prjname);
						issuevo.setPrjtypecode(prjtypecode);
						issuevo.setPrjtypename(prjtypename);
						issuevo.setVbatchcode(vbatchcode);
						issuevo.setCmaterialcode(cmaterialcode);
						issuevo.setCmaterialname(invname);
						issuevo.setSpec(invspec);
						issuevo.setModel(invtype);
						issuevo.setWidth(width);
						issuevo.setHeight(height);
						issuevo.setUnitid(measname);
						issuevo.setPk_order(pk_order);
						issuevo.setBdef11(bdef11);
						issuevo.setBdef12(bdef12);
						issuevo.setBdef13(bdef13);
						issuevo.setBdef14(bdef14);
						issuevo.setBdef15(bdef15);
						issuevo.setBdef16(bdef16);
						issuevo.setBdef17(bdef17);
						issuevo.setBdef18(bdef18);
						issuevo.setBdef19(bdef19);
						issuevo.setBdef2(bdef2);
						issuevo.setBdef20(bdef20);
						issuevo.setBdef3(bdef3);
						issuevo.setDr(0);
						if(issuejsobj.getString("num")!=null) {
							issuevo.setNum(new UFDouble(issuejsobj.getString("num")));
						}
						dao.insertVO(issuevo);
					}
				}
				
			if("".equals(meg)) {
				result.add(formatRSJsonData("成功",
					     "",vbillno));	
			}
			
			}
			
			if (sbf.length() != 0) {
				throw new Exception("存货编码不存在:"+sbf.toString());
			}
			
			trans.commit();//提交事务
			returnobj.put("info", "成功");
			returnobj.put("errMessage", "");
			returnobj.put("result", result);
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
		} catch (Exception e) {
			try {
				trans.rollback();
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}//异常时事务回滚
			JSONArray errMessage = new JSONArray();
			JSONObject returnobj = new JSONObject();
			String emsg = e.getMessage().replace("\"", "\'");
			errMessage.add(formatRSJsonData("失败",
					emsg,""));
			returnobj.put("info", "失败");
			returnobj.put("errMessage", emsg);
			returnobj.put("result", errMessage);	
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
			return;
		}
	}

	
	
	/*
	 * 非空判断
	 */
	private String checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		String body = "result";//表体
		
		if (json.getJSONArray(body)==null) {
			empty = false;
			mags.append("请传入接口数据！ ");
			return mags.toString();
		}
		
		JSONArray oprepObjectBs = json.getJSONArray("result");
		
		String vbillno = "vbillno";//单据号
		String pk_corp = "pk_corp";//组织
		String pk_proposer = "pk_proposer";//制单人
		String dbilldate = "dbilldate";//单据日期
		
		String in = "in";//入库
		String issue = "issue";//领料
		String sc = "sc";//委外
 
		for(int i = 0; i < oprepObjectBs.size(); i++) {
			JSONObject oprepJsonObjectB = oprepObjectBs.getJSONObject(i);
			String[] HeadKey = {vbillno,pk_corp,pk_proposer,dbilldate};
			int num = i+1;
			
			mags.append("第"+num+"块表头：{");
			for (String as : HeadKey) {

				if (oprepJsonObjectB.getString(as).isEmpty()) {
					empty = false;
					mags.append("'" + as + "' ");
				}
			}
			mags.append("}");
			
			if(oprepJsonObjectB.getJSONArray(in)==null&&oprepJsonObjectB.getJSONArray(issue)==null&&oprepJsonObjectB.getJSONArray(sc)==null) {
				mags.append("第"+num+"块表体不能为空");
			}
		}
		
		
		if (!empty) {
			return "以下字段不可为空："+mags;
		}
		else {
			return null;
		}
	}
	
	private Boolean IsRepeat(String vbillno) throws DAOException {
		String qrysql = "select pk_order from mmpac_order_main where isnull(dr,0) = 0 and vbillno = '"+vbillno+"'";
		String pk_order = (String) dao.executeQuery(qrysql, new ColumnProcessor());
        if (pk_order == null) {
            return Boolean.FALSE;
        }
        return Boolean.TRUE;
	}
}
