package u8c.impl.mmpac.mmpac;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.GeneralBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDouble;
import nc.vo.trade.pub.IBillStatus;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.itf.mmpac.mmpac.IOrderTotalInfo;
import u8c.pubitf.ic.in.IProductInMaintainAPI;
import u8c.vo.OrderInVO;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;

public class OrderTotalInfoImpl implements IOrderTotalInfo {

	@Override
	public boolean UpdateStatus(HRAggVO aggvo, int status) throws BusinessException {
		OrderMainVO mainVO = (OrderMainVO) aggvo.getParentVO();
		
		OrderTotalInfoDAO dao = new OrderTotalInfoDAO();
		
		mainVO.setBillstatus(status);
		
		dao.execUpdate(mainVO, new String[]{OrderMainVO.BILLSTATUS});
		
		return true;
	}

	@Override
	public boolean execApprove(HRAggVO aggvo) throws BusinessException {
		OrderMainVO mainVO = (OrderMainVO) aggvo.getParentVO();
		OrderTotalInfoDAO dao = new OrderTotalInfoDAO();
		dao.execUpdate(mainVO, new String[]{OrderMainVO.BILLSTATUS,OrderMainVO.PK_APPROVER});
		return true;
	}

	@Override
	public boolean UpdateIssueExecNum(Map<String, UFDouble> updatemap) throws BusinessException {
		List<OrderIssueVO> updatevos = new ArrayList<>();
		OrderTotalInfoDAO dao = new OrderTotalInfoDAO();
		Boolean res = false;
		Iterator it = updatemap.keySet().iterator();
		try {
			while(it.hasNext()) {
				Object key = it.next();
				Object val = updatemap.get(key);
				OrderIssueVO issuevo = GetBaseDAOUtil.getissuevo(key.toString());
				issuevo.setExecnum(new UFDouble(val.toString()));
				updatevos.add(issuevo);
			}
			for(int i = 0;i < updatevos.size();i++) {
				dao.UpdateIssueExecNum(updatevos.get(i), new String[]{OrderIssueVO.EXECNUM});
			}
			return true;
		} catch (Exception e) {
			MessageDialog.showErrorDlg(null, "错误1", e.getMessage());
		}
		
		return false;
	}
	
	@Override
	public boolean UpdateInExecNum(Map<String, UFDouble> updatemap) throws BusinessException {
		// TODO Auto-generated method stub
		List<OrderInVO> updatevos = new ArrayList<>();
		OrderTotalInfoDAO dao = new OrderTotalInfoDAO();
		Boolean res = false;
		Iterator it = updatemap.keySet().iterator();
		try {
			while(it.hasNext()) {
				Object key = it.next();
				Object val = updatemap.get(key);
				OrderInVO invo = GetBaseDAOUtil.getorderInVO(key.toString());
				invo.setExecnum(new UFDouble(val.toString()));
				updatevos.add(invo);
			}
			for(int i = 0;i < updatevos.size();i++) {
				dao.UpdateInExecNum(updatevos.get(i), new String[]{OrderIssueVO.EXECNUM});
			}
			return true;
		} catch (Exception e) {
			MessageDialog.showErrorDlg(null, "错误2", e.getMessage());
		}
		
		return false;
	}

	@Override
	public void insertProduct(GeneralBillVO[] aggvo,Map<String, UFDouble> updatemap) throws Exception {
		IProductInMaintainAPI productapi=(IProductInMaintainAPI) NCLocator.getInstance().lookup(IProductInMaintainAPI.class.getName());
		productapi.insertProductIns(aggvo);	
		List<OrderInVO> updatevos = new ArrayList<>();
		OrderTotalInfoDAO dao = new OrderTotalInfoDAO();
		Boolean res = false;
		Iterator it = updatemap.keySet().iterator();
		while(it.hasNext()) {
			Object key = it.next();
			Object val = updatemap.get(key);
			OrderInVO issuevo = GetBaseDAOUtil.getorderInVO(key.toString());
			issuevo.setExecnum(new UFDouble(val.toString()));
			updatevos.add(issuevo);
		}
		for(int i = 0;i < updatevos.size();i++) {
			dao.UpdateInExecNum(updatevos.get(i), new String[]{OrderInVO.EXECNUM});
		}
		
	}
}
