package u8c.impl.mmpac.mmpac;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.NCLocator;
import nc.itf.uap.bd.item.IJobbasedoc;
import nc.itf.uap.bd.item.IJobmanagedoc;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.uapbd.itembasedoc.JobbasfilVO;
import nc.vo.uapbd.itemmngdoc.JobmngfilVO;
import u8c.bs.servlet.service.BaseServlet;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.itf.mmpac.mmpac.IUtilMaintain;
import u8c.log.NcLog;

public class ProjectAddImpl  extends BaseServlet implements IHttpServletAdaptor{

	
	
	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSON.parseObject(createStr);
			NcLog.info(json.toString());
			//接口返回结果
			JSONObject returnobj = new JSONObject();
			//返回json
			JSONArray result = new JSONArray();
			JSONArray bodyArray = json.getJSONArray("result");
			if (bodyArray == null) {
				
			}
			String token =req.getParameter("token");
			if(!(token!=null && !token.equals("")&&("07a81a68-c60c-4ee4-83dc-25aa51a51497").equals(token))){
				
				throw new Exception("请确认通讯密码是否正确！");
			}
			for (int i = 0; i < bodyArray.size(); i++) {
				JSONObject jsonObject = bodyArray.getJSONObject(i);
				try {
					checkJson(jsonObject);
					//项目管理档案VO
					JobmngfilVO jobmngfilVO = new JobmngfilVO();
					//项目档案VO
					JobbasfilVO jobbasfilVO = new JobbasfilVO();
					
					//公司
					jobbasfilVO.setPk_corp(jsonObject.getString("pk_corp"));
					//项目类型
					jobbasfilVO.setPk_jobtype(GetBaseDAOUtil.getprjtypePK(jsonObject.getString("pk_jobtype")));
					//项目编码
					jobbasfilVO.setJobcode(jsonObject.getString("jobcode"));
					//项目名称
					jobbasfilVO.setJobname(jsonObject.getString("jobname"));
					//是否完工
					jobbasfilVO.setFinishedflag(UFBoolean.FALSE);
					jobbasfilVO.setIsRef(true);
					//是否封存
					jobbasfilVO.setSealflag(UFBoolean.FALSE);
					//客商
					jobbasfilVO.setDef1(GetBaseDAOUtil.getCubasdocpk(jsonObject.getString("custname")));
					
					IUtilMaintain iUtilMaintain = NCLocator.getInstance().lookup(IUtilMaintain.class);
					iUtilMaintain.project_RequiresNew(jobbasfilVO);
					result.add(formatRSJsonData("成功", "", jsonObject.getString("jobcode")));
				} catch (Exception e) {
					result.add(formatRSJsonData("失败", e.getMessage(), jsonObject.getString("jobcode")));
				}
			}
			returnobj.put("info", "成功");
			returnobj.put("errMessage", "");
			returnobj.put("result", result);
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
		} catch (Exception e) {
			JSONArray errMessage = new JSONArray();
			JSONObject returnobj = new JSONObject();
			errMessage.add(formatRSJsonData("失败",
					e.getMessage(),"").toString());
			returnobj.put("info", "失败");
			returnobj.put("errMessage", e.getMessage() == null ? "" : e.getMessage());
			returnobj.put("result", errMessage);
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
		}
		
	}
	
	private void checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		
		String pk_corp = "pk_corp";//公司
		String pk_jobtype = "pk_jobtype";//项目类型
		String jobcode = "jobcode";//项目编码
		String jobname = "jobname";//项目名称
		String custname = "custname";//客商
 
		String[] HeadKey = {pk_corp,pk_jobtype,jobcode,jobname,custname};
		
		for (String as : HeadKey) {

			if (json.getString(as).isEmpty()) {
				empty = false;
				mags.append("'" + as + "'");
			}
		}		
		if (!empty) {
			throw new Exception("以下字段不可为空："+mags);
		}
	}

}
