package u8c.impl.mmpac.mmpac;

import java.io.IOException;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.thoughtworks.xstream.core.ReferenceByIdMarshaller.IDGenerator;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.NCLocator;
import nc.itf.scm.so.so001.ISaleOrder;
import nc.itf.uap.IVOPersistence;
import nc.jdbc.framework.generator.IdGenerator;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.bd.b09.CumandocVO;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import nc.vo.so.so001.SaleOrderVO;
import nc.vo.so.so001.SaleorderBVO;
import nc.vo.so.so001.SaleorderHVO;
import u8c.bs.servlet.service.BaseServlet;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.log.NcLog;

public class SaleOrderAddImpl extends BaseServlet implements IHttpServletAdaptor{
	BaseDAO dao = new BaseDAO();
	

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSON.parseObject(createStr);
			//接口返回结果
			JSONObject returnobj = new JSONObject();
			//正常返回json
			JSONArray result = new JSONArray();
			//报错返回json
			JSONArray errMessage = new JSONArray();
			String checkresult = checkJson(json);
			if(checkresult != null){
				errMessage.add(formatRSJsonData("失败",
						checkresult,""));
				returnobj.put("info", "失败");
				returnobj.put("errMessage", checkresult);
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			JSONArray bodyArray = json.getJSONArray("result");
			for (Object Object : bodyArray) {
				JSONObject bodyObject = JSONObject.parseObject(Object.toString());
				SaleOrderVO aggvo = new SaleOrderVO();
				SaleorderHVO headvo = new SaleorderHVO();
				aggvo.setParentVO(headvo);
				String pk_corp = bodyObject.getString("pk_corp");
				headvo.setPk_corp(pk_corp);
				//库存组织
				String ccalbodyid = GetBaseDAOUtil.getPkCal(bodyObject.getString("ccalbodyid"));
				if(ccalbodyid.equals("")) {
					result.add(formatRSJsonData("失败",
							"库存组织"+bodyObject.getString("ccalbodyid")+"不存在",""));
					continue;
				}
				headvo.setCcalbodyid(ccalbodyid);
				//销售组织
				String csalecorpid = GetBaseDAOUtil.getPkSale(bodyObject.getString("csalecorpid"));
				if(csalecorpid.equals("")) {
					result.add(formatRSJsonData("失败",
							"销售组织"+bodyObject.getString("csalecorpid")+"不存在",""));
					continue;
				}
				headvo.setCsalecorpid(csalecorpid);
//				String vbillno = bodyObject.getString("vbillno");
//				Boolean isrepeat = IsRepeat(vbillno);
//				if(isrepeat) {
//					result.add(formatRSJsonData("失败",
//							"单据号"+vbillno+"重复",""));
//					continue;
//				}
//				headvo.setVreceiptcode(vbillno);
				//单据类型
				headvo.setCreceipttype("30");
				//状态
				headvo.setFstatus(1);
				String dbilldate = bodyObject.getString("dbilldate");
				headvo.setDbilldate(new UFDate(dbilldate));
				headvo.setDmakedate(new UFDate());
				headvo.setDbilltime(new UFDateTime(dbilldate));
				String cbiztype = GetBaseDAOUtil.getBusitypeid(bodyObject.getString("cbiztype"), pk_corp);
				if(cbiztype.equals("")) {
					result.add(formatRSJsonData("失败",
							"业务流程"+bodyObject.getString("cbiztype")+"不存在",""));
					continue;
				}
				headvo.setCbiztype(cbiztype);
				String coperatorid = GetBaseDAOUtil.getUserid(bodyObject.getString("billmaker"));//制单人
				if(coperatorid.equals("")) {
					result.add(formatRSJsonData("失败",
							"制单人"+bodyObject.getString("billmaker")+"不存在",""));
					continue;
				}
				headvo.setCoperatorid(coperatorid);
				CumandocVO mandocvo = GetBaseDAOUtil.getCumandocVO(bodyObject.getString("ccustomerid"));
				if(mandocvo != null) {
					headvo.setCcustomerid(mandocvo.getPk_cumandoc());//客户
					headvo.setCreceiptcorpid(mandocvo.getPk_cusmandoc2()==null?mandocvo.getPk_cumandoc():mandocvo.getPk_cusmandoc2());//开票单位
					headvo.setCreceiptcustomerid(mandocvo.getPk_cusmandoc3()==null?mandocvo.getPk_cumandoc():mandocvo.getPk_cusmandoc3());//收货单位
					//部门
					String cdeptid = GetBaseDAOUtil.getDeptdocid(bodyObject.getString("cdeptid"));
					if(!cdeptid.equals("")) {
						headvo.setCdeptid(cdeptid);
					}
					else {
						result.add(formatRSJsonData("失败",
								"部门"+bodyObject.getString("cdeptid")+"不存在",""));
						continue;
					}
					//业务员
					headvo.setCemployeeid(GetBaseDAOUtil.getPsndocid(bodyObject.getString("cemployeeid")));
					//整单折扣
					headvo.setNdiscountrate(new UFDouble(100));
					//运输方式
					headvo.setCtransmodeid(mandocvo.getPk_sendtype());
					//币种
					if(mandocvo.getPk_currtype1()==null) {
						result.add(formatRSJsonData("失败",
								"该客商"+bodyObject.getString("ccustomerid")+"没有设置默认交易币种",""));
						continue;
					}
					else {
						headvo.setCcurrencytypeid(mandocvo.getPk_currtype1());
					}
					
					//收款协议
					headvo.setCtermprotocolid(mandocvo.getPk_payterm());
					//备注
					headvo.setVnote(bodyObject.getString("vnote"));
					//已收入确认金额
					headvo.setAlrconfincomny(new UFDouble(0));
					//是否已协同生产采购订单
					headvo.setBcodechanged(Boolean.FALSE);
					//是否散户
					headvo.setBfreecustflag(UFBoolean.FALSE);
					//是否期初
					headvo.setBinitflag(UFBoolean.FALSE);
					//开票关闭标记
					headvo.setBinvoicendflag(UFBoolean.FALSE);
					//出库关闭标记
					headvo.setBoutendflag(UFBoolean.FALSE);
					//是否超账期
					headvo.setBoverdate(UFBoolean.FALSE);
					//发货关闭标记
					headvo.setBreceiptendflag(UFBoolean.FALSE);
					//退货标记
					headvo.setBretinvflag(UFBoolean.FALSE);
					//运输关闭标记
					headvo.setBtransendflag(UFBoolean.FALSE);
					
					//数量合计
					UFDouble nototalnum = new UFDouble(0);
					//整单价税合计
					UFDouble nheadsummny = new UFDouble(0);
					//表体
					JSONArray tableArr = bodyObject.getJSONArray("table");
					SaleorderBVO[] bodyvos = new SaleorderBVO[tableArr.size()];
					aggvo.setChildrenVO(bodyvos);
					for(Object bodyobject : tableArr) {
						JSONObject bodyObj = JSONObject.parseObject(bodyobject.toString());
						SaleorderBVO bodyvo = new SaleorderBVO();
						//行号
						bodyvo.setCrowno(bodyObj.getString("rowno"));
						if(bodyObj.getString("cinventorycode").equals("")||bodyObj.getString("cinventorycode")==null) {
							result.add(formatRSJsonData("失败",
									"第"+(tableArr.indexOf(bodyobject)+1)+"行存货为空",""));
							continue;
						}
						InvbasdocVO invbasvo = GetBaseDAOUtil.getInvVO(bodyObj.getString("cinventorycode"));
						if(invbasvo==null) {
							result.add(formatRSJsonData("失败",
									"存货"+bodyObj.getString("cinventorycode")+"不存在",""));
							continue;
						}
						InvmandocVO invmanvo = GetBaseDAOUtil.getInvmanVO(invbasvo.getPrimaryKey());
						if(invmanvo==null) {
							result.add(formatRSJsonData("失败",
									"找不到该存货"+bodyObj.getString("cinventorycode")+"对应的存货档案",""));
							continue;
						}
						if(bodyObj.getString("num")==null) {
							result.add(formatRSJsonData("失败",
									"第"+(tableArr.indexOf(bodyobject)+1)+"行主数量为空",""));
							continue;
						}
						if(bodyObj.getString("nprice")==null) {
							result.add(formatRSJsonData("失败",
									"第"+(tableArr.indexOf(bodyobject)+1)+"行无税单价为空",""));
							continue;
						}
						if(bodyObj.getString("taxprice")==null) {
							result.add(formatRSJsonData("失败",
									"第"+(tableArr.indexOf(bodyobject)+1)+"行含税单价为空",""));
							continue;
						}
						nototalnum = nototalnum.add(new UFDouble(bodyObj.getString("num")));
						
						//存货管理id
						bodyvo.setCinventoryid(invmanvo.getPrimaryKey());
						bodyvo.setCinventoryid1(invmanvo.getPrimaryKey());
						//存货档案主键
						bodyvo.setCinvbasdocid(invbasvo.getPrimaryKey());
						//单位
						bodyvo.setCunitid(invbasvo.getPk_measdoc());
						//报价单位
						bodyvo.setCquoteunitid(invbasvo.getPk_measdoc());
						//收货单位
						bodyvo.setCreceiptcorpid(mandocvo.getPk_cusmandoc2()==null?mandocvo.getPk_cumandoc():mandocvo.getPk_cusmandoc2());
						//行状态
						bodyvo.setFrowstatus(1);
						//是否收入关闭
						bodyvo.setIncoconfclose("N");
						//公司
						bodyvo.setPk_corp(pk_corp);
						//仅退款
						bodyvo.setRefundflag(UFBoolean.FALSE);
						//税率
						bodyvo.setNtaxrate(new UFDouble(GetBaseDAOUtil.getTaxRate(invbasvo.getPk_taxitems()).toString()));
						//辅单位
						bodyvo.setCpackunitid(invbasvo.getPk_measdoc1());
						//整单折扣
						bodyvo.setNdiscountrate(new UFDouble(100));
						//单品折扣率
						bodyvo.setNitemdiscountrate(new UFDouble(100));
						//主数量
						bodyvo.setNnumber(new UFDouble(bodyObj.getString("num")));
						//报价数量
						bodyvo.setNquoteunitnum(new UFDouble(bodyObj.getString("num")));
						//报价计量单位换算率
						bodyvo.setNquoteunitrate(new UFDouble(1));
						String nprice = bodyObj.getString("nprice");
						if(nprice.equals("")||nprice==null) {
							result.add(formatRSJsonData("失败",
									"第"+(tableArr.indexOf(bodyobject)+1)+"行无税单价为空",""));
							continue;
						}
						String taxprice = bodyObj.getString("taxprice");
						if(taxprice.equals("")||taxprice==null) {
							result.add(formatRSJsonData("失败",
									"第"+(tableArr.indexOf(bodyobject)+1)+"行含税税单价为空",""));
							continue;
						}
						UFDouble nmny = new UFDouble(bodyObj.getString("num")).multiply(new UFDouble(nprice));
						UFDouble nsummny = new UFDouble(bodyObj.getString("num")).multiply(new UFDouble(taxprice));
						nheadsummny = nheadsummny.add(nsummny);
						//本币无税金额
						bodyvo.setNmny(nmny);
						//本币无税净价
						bodyvo.setNnetprice(new UFDouble(nprice));
						//报价单位无税净价
						bodyvo.setNorgqtnetprc(new UFDouble(nprice));
						//报价单位无税单价
						bodyvo.setNorgqtprc(new UFDouble(nprice));
						//报价单位含税净价
						bodyvo.setNorgqttaxnetprc(new UFDouble(taxprice));
						//报价单位含税单价
						bodyvo.setNorgqttaxprc(new UFDouble(taxprice));
						//原币无税金额
						bodyvo.setNoriginalcurmny(nmny);
						//原币无税净价
						bodyvo.setNoriginalcurnetprice(new UFDouble(nprice));
						//原币无税单价
						bodyvo.setNoriginalcurprice(new UFDouble(nprice));
						//原币价税合计
						bodyvo.setNoriginalcursummny(nsummny);
						//原币税额
						bodyvo.setNoriginalcurtaxmny(nsummny.sub(nmny));
						//原币含税净价
						bodyvo.setNoriginalcurtaxnetprice(new UFDouble(taxprice));
						//原币含税单价
						bodyvo.setNoriginalcurtaxprice(new UFDouble(taxprice));
						//本币无税单价
						bodyvo.setNprice(new UFDouble(nprice));
						//报价单位本币无税净价
						bodyvo.setNqtnetprc(new UFDouble(nprice));
						//报价单位本币含税净价
						bodyvo.setNqttaxnetprc(new UFDouble(taxprice));
						//报价单位本币含税单价
						bodyvo.setNqttaxprc(new UFDouble(taxprice));
						//本币价税合计
						bodyvo.setNsummny(nsummny);
						//本币税额
						bodyvo.setNtaxmny(nsummny.sub(nmny));
						//本币含税净价
						bodyvo.setNtaxnetprice(new UFDouble(taxprice));
						//本币含税单价
						bodyvo.setNtaxprice(new UFDouble(taxprice));
						
						//是否捆绑存货
						bodyvo.setBbindflag(UFBoolean.FALSE);
						//是否直运
						bodyvo.setBdericttrans(UFBoolean.FALSE);
						//是否赠品
						bodyvo.setBlargessflag(UFBoolean.FALSE);
						//缺货标记
						bodyvo.setBoosflag(UFBoolean.FALSE);
						//是否参与返利
						bodyvo.setBreturnprofit(UFBoolean.FALSE);
						//是否参与价保
						bodyvo.setBsafeprice(UFBoolean.FALSE);
						//补货标志
						bodyvo.setBsupplyflag(UFBoolean.FALSE);
						//建议发货库存组织
						bodyvo.setCadvisecalbodyid(ccalbodyid);
						//折本汇率
						bodyvo.setNexchangeotobrate(new UFDouble(1));
						//币种
						bodyvo.setCcurrencytypeid(mandocvo.getPk_currtype1());
						nc.jdbc.framework.generator.IdGenerator idGenerator = new nc.jdbc.framework.generator.SequenceGenerator();
						bodyvo.setCorder_bid(idGenerator.generate(pk_corp));
						bodyvos[tableArr.indexOf(bodyobject)] = bodyvo;
					}
					headvo.setNtotalnum(nototalnum);
					headvo.setNheadsummny(nheadsummny);
					ISaleOrder service = NCLocator.getInstance().lookup(ISaleOrder.class);
					
					List<Object> res = service.insert(aggvo);
					result.add(formatRSJsonData("成功",
							"销售订单"+res.get(1).toString()+"新增成功",""));
				}
				else {
					result.add(formatRSJsonData("失败",
							"客户"+bodyObject.getString("ccustomerid")+"不存在",""));
					continue;
				}
			
			}
			returnobj.put("info", "成功");
			returnobj.put("errMessage", "");
			returnobj.put("result", result);
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
		} catch (Exception e) {
			JSONArray errMessage = new JSONArray();
			JSONObject returnobj = new JSONObject();
			String emsg = e.getMessage().replace("\"", "\'");
			errMessage.add(formatRSJsonData("失败",
					emsg,""));
			returnobj.put("info", "失败");
			returnobj.put("errMessage", emsg);
			returnobj.put("result", errMessage);	
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
			return;
		}
		
	}
	
	/*
	 * 非空判断
	 */
	private String checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		String body = "result";//表体
		
		if (json.getJSONArray(body)==null) {
			empty = false;
			mags.append("请传入接口数据！ ");
			return mags.toString();
		}
		
		JSONArray oprepObjectBs = json.getJSONArray("result");
		
		String pk_corp = "pk_corp";//组织
		String ccalbodyid = "ccalbodyid";//库存组织
		String csalecorpid = "csalecorpid";//销售组织
		String cbiztype = "cbiztype";//业务流程
		String dbilldate = "dbilldate";//单据日期
		String billmaker = "billmaker";//制单人
		String ccustomerid = "ccustomerid";//客户
		
		String table = "table";//表体
 
		for(int i = 0; i < oprepObjectBs.size(); i++) {
			JSONObject oprepJsonObjectB = oprepObjectBs.getJSONObject(i);
			String[] HeadKey = {pk_corp,ccalbodyid,csalecorpid,cbiztype,dbilldate,billmaker,ccustomerid};
			int num = i+1;
			
			mags.append("第"+num+"块表头：{");
			for (String as : HeadKey) {

				if (oprepJsonObjectB.getString(as).isEmpty()) {
					empty = false;
					mags.append("'" + as + "' ");
				}
			}
			mags.append("}");
			
			if(oprepJsonObjectB.getJSONArray(table)==null) {
				mags.append("第"+num+"块表体不能为空");
			}
		}
		
		
		if (!empty) {
			return "以下字段不可为空："+mags;
		}
		else {
			return null;
		}
	}
	
	private Boolean IsRepeat(String vbillno) throws DAOException {
		String qrysql = "select csaleid from so_sale where isnull(dr,0) = 0 and vreceiptcode = '"+vbillno+"'";
		String csaleid = (String) dao.executeQuery(qrysql, new ColumnProcessor());
        if (csaleid == null) {
            return Boolean.FALSE;
        }
        return Boolean.TRUE;
	}

}
