package u8c.bs.servlet.service;

import java.util.List;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.md.data.criterion.db.ListMapProcessor;
import nc.vo.bd.b09.CumandocVO;
import nc.vo.bd.def.DefdefVO;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.pub.BusinessException;
import u8c.vo.OrderInVO;
import u8c.vo.OrderIssueVO;

public class GetBaseDAOUtil {
	private static IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	
	// 用户主键
    public static String getUserid(String usercode) throws Exception {
        String sql = "select cuserid from sm_user where user_code ='"+usercode+"' and isnull(dr,0) = 0";
        String cuserid = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (cuserid == null) {
            return "";
        }
        return cuserid;
    }
    
    //人员基本档案主键
    public static String getPsndocid(String psncode) throws Exception {
        String sql = "select pk_psndoc from bd_psndoc where psncode ='"+psncode+"' and isnull(dr,0) = 0";
        String pk_psndoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_psndoc == null) {
            return "";
        }
        return pk_psndoc;
    }
    
    //部门档案主键
    public static String getDeptdocid(String deptcode) throws Exception {
        String sql = "select pk_deptdoc from bd_deptdoc where deptcode ='"+deptcode+"' and isnull(dr,0) = 0";
        String pk_deptdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_deptdoc == null) {
            return "";
        }
        return pk_deptdoc;
    }
    
    //业务流程主键
    public static String getBusitypeid(String busicode,String pk_corp) throws Exception {
        String sql = "select pk_busitype from bd_busitype where busicode ='"+busicode+"' and isnull(dr,0) = 0 and pk_corp = '"+pk_corp+"'";
        String pk_busitype = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_busitype == null) {
            return "";
        }
        return pk_busitype;
    }
    
    //项目名称
    public static String getprojectname(String prjcode) throws Exception {
        String sql = "select jobname from bd_jobbasfil where jobcode ='"+prjcode+"' and isnull(dr,0) = 0";
        String jobname = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (jobname == null) {
            return "";
        }
        return jobname;
    }
    
    //项目id
    public static String getprojectid(String prjcode) throws Exception {
        String sql = "select pk_jobbasfil from bd_jobbasfil where jobcode ='"+prjcode+"' and isnull(dr,0) = 0";
        String pk_jobbasfil = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_jobbasfil == null) {
            return "";
        }
        return pk_jobbasfil;
    }
    
    //项目分类编码
    public static String getprjtypecode(String prjcode) throws Exception {
        String sql = "select jobtypecode from bd_jobtype where pk_jobtype = (select pk_jobtype from bd_jobbasfil where isnull(dr,0) = 0 and jobcode = '"+prjcode+"')";
        String jobtypecode = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (jobtypecode == null) {
            return "";
        }
        return jobtypecode;
    }
    
    //项目分类名称
    public static String getprjtypename(String prjcode) throws Exception {
        String sql = "select jobtypename from bd_jobtype where pk_jobtype = (select pk_jobtype from bd_jobbasfil where isnull(dr,0) = 0 and jobcode = '"+prjcode+"')";
        String jobtypename = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (jobtypename == null) {
            return "";
        }
        return jobtypename;
    }
    
    //存货名称
    public static String getinvname(String cmaterialcode) throws Exception {
        String sql = "select invname from bd_invbasdoc where invcode = '"+cmaterialcode+"' ";
        String invname = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (invname == null) {
            return "";
        }
        return invname;
    }
    
    //规格
    public static String getinvspec(String cmaterialcode) throws Exception {
        String sql = "select invspec from bd_invbasdoc where invcode = '"+cmaterialcode+"' ";
        String invspec = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (invspec == null) {
            return "";
        }
        return invspec;
    }
    
    //型号
    public static String getinvtype(String cmaterialcode) throws Exception {
        String sql = "select invtype from bd_invbasdoc where invcode = '"+cmaterialcode+"'";
        String invtype = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (invtype == null) {
            return "";
        }
        return invtype;
    }
    
    //宽度
    public static String getwidth(String cmaterialcode) throws Exception {
        String sql = "select width from bd_invbasdoc where invcode = '"+cmaterialcode+"' ";
        String width = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (width == null) {
            return "";
        }
        return width;
    }
    
    //高度
    public static String getheight(String cmaterialcode) throws Exception {
        String sql = "select height from bd_invbasdoc where invcode = '"+cmaterialcode+"' ";
        String height = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (height == null) {
            return "";
        }
        return height;
    }
    
    //计量单位
    public static String getmeasname(String cmaterialcode) throws Exception {
        String sql = "select measname from bd_measdoc where isnull(dr,0) = 0 and pk_measdoc = (select pk_measdoc from bd_invbasdoc where invcode = '"+cmaterialcode+"')";
        String measname = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (measname == null) {
            return "";
        }
        return measname;
    }
    
    //存货分类主键
    public static String getInvClid(String invCl) throws Exception {
        String sql = "select pk_invcl from bd_invcl where isnull(dr,0) = 0 and invclasscode = '"+invCl+"'";
        String pk_invcl = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_invcl == null) {
            return "";
        }
        return pk_invcl;
    }
    
    //税目主键
    public static String gettaxitemid(String invTaxitems) throws Exception {
        String sql = "select pk_taxitems from bd_taxitems where isnull(dr,0) = 0 and taxcode = '"+invTaxitems+"'";
        String pk_taxitems = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_taxitems == null) {
            return "";
        }
        return pk_taxitems;
    }
    
    //根据编码获取计量单位主键
    public static String getMeasid(String invMeas) throws Exception {
        String sql = "select pk_measdoc from bd_measdoc where isnull(dr,0) = 0 and shortname = '"+invMeas+"'";
        String pk_measdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_measdoc == null) {
            return "";
        }
        return pk_measdoc;
    }
    
    //根据计量单位名称获取主键
    public static String getMeasidByName(String measname) throws Exception {
        String sql = "select pk_measdoc from bd_measdoc where isnull(dr,0) = 0 and measname = '"+measname+"'";
        String pk_measdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_measdoc == null) {
            return "";
        }
        return pk_measdoc;
    }
    //根据计量单位名称获取主键
    public static String getMeasidByNames(String measname) throws Exception {
        String sql = "select pk_measdoc from bd_measdoc where isnull(dr,0) = 0 and measname = '"+measname+"'";
        return (String) iuap.executeQuery(sql, new ColumnProcessor());
    }
    
    //税率
    public static Object getTaxRate(String ctaxitemid) throws BusinessException {
    	String sql = "select taxratio from bd_taxitems where isnull(dr,0) = 0 and pk_taxitems = '"+ctaxitemid+"'";
    	Object taxratio = (Object) iuap.executeQuery(sql, new ColumnProcessor());
        if (taxratio == null) {
            return "";
        }
        return taxratio;
    }
    
    //根据存货编码去查询存货vo
    public static InvbasdocVO getInvVO(String invCode) throws Exception {
        String sql = "select * from bd_invbasdoc where invcode = '"+invCode+"'";
        Object obj = iuap.executeQuery(sql, new BeanProcessor(InvbasdocVO.class));
        if (obj == null) {
            return null;
        }
        else {
        	return (InvbasdocVO)obj;
        }
    }
    
    //获取客商管理主键
    public static CumandocVO getCumandocVO(String custcode) throws Exception {
        String sql = "select *  from bd_cumandoc where pk_cubasdoc = (select pk_cubasdoc from bd_cubasdoc where isnull(dr,0) = 0 and custcode = '"+custcode+"' ) and custflag != 4 and custflag is not null";
        Object obj = iuap.executeQuery(sql, new BeanProcessor(CumandocVO.class));
        if (obj == null) {
            return null;
        }
        else {
        	return (CumandocVO)obj;
        }
    }
    
    //获取库存组织主键
    public static String getPkCal(String code) throws Exception {
        String sql = "select pk_calbody from bd_calbody where isnull(dr,0) = 0 and bodycode = '"+code+"'";
        String pk_calbody = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_calbody == null) {
            return "";
        }
        return pk_calbody;
    }
    
    //获取销售组织主键
    public static String getPkSale(String code) throws Exception {
        String sql = "select csalestruid from bd_salestru where isnull(dr,0) = 0 and vsalestrucode = '"+code+"'";
        String csalestruid = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (csalestruid == null) {
            return "";
        }
        return csalestruid;
    }
    
    //公司
    public static String getCorpPK(String code) throws Exception {
    	String sql = "select pk_corp from bd_corp where unitcode = '"+code+"' and dr = 0";
    	String pk_corp = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_corp == null) {
    		throw new Exception("公司"+code+"未查到，请检查");
        }
        return pk_corp;
    }
    
    //项目类型
    public static String getprjtypePK(String code)throws Exception {
    	String sql = "select pk_jobtype from bd_jobtype where jobtypecode= '"+code+"' and dr = 0";
    	String pk_jobtype = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_jobtype == null) {
    		throw new Exception("项目类型"+code+"未查到，请检查");
        }
        return pk_jobtype;
    }
    
    //获取存货管理VO
    public static InvmandocVO getInvmanVO(String pk_invbas) throws BusinessException {
    	String qrysql = "select * from bd_invmandoc where isnull(dr,0) = 0 and pk_invbasdoc = '"+pk_invbas+"'";
    	Object obj = iuap.executeQuery(qrysql, new BeanProcessor(InvmandocVO.class));
    	if (obj == null) {
            return null;
        }
        else {
        	return (InvmandocVO)obj;
        }
    }
    
    //根据公司获取库存组织
    public static String getcalpk(String pk_corp) throws Exception {
    	String qrysql = "select pk_calbody from bd_calbody where isnull(dr,0) = 0 and pk_corp = '"+pk_corp+"'";
    	String pk_calbody = (String) iuap.executeQuery(qrysql, new ColumnProcessor());
    	if (pk_calbody == null) {
    		throw new Exception(pk_corp+"对应的库存组织未查到，请检查");
        }
        return pk_calbody;
    }
    
    //根据主键获取领料vo
    public static OrderIssueVO getissuevo(String pk_order_issue) throws Exception {
    	String qrysql = "select * from mmpac_order_issue where isnull(dr,0) = 0 and pk_order_issue = '"+pk_order_issue+"'";
    	Object obj = iuap.executeQuery(qrysql, new BeanProcessor(OrderIssueVO.class));
    	if (obj == null) {
    		return null;
        }
        return (OrderIssueVO) obj;
    }
    
    //根据主键获取入库vo
    public static OrderInVO getorderInVO(String pk_order_in) throws Exception {
    	String qrysql = "select * from mmpac_order_in where isnull(dr,0) = 0 and pk_order_in = '"+pk_order_in+"'";
    	OrderInVO orderInVO = (OrderInVO) iuap.executeQuery(qrysql, new BeanProcessor(OrderInVO.class));
    	if (orderInVO == null) {
    		return null;
        }
        return orderInVO;
    }
    
    //查询用户定义项
    public static DefdefVO getdefdef(String defname) throws Exception {
    	String qrysql = "select * from bd_defdef where defname = '"+defname+"'";
    	DefdefVO res = (DefdefVO) iuap.executeQuery(qrysql, new BeanProcessor(DefdefVO.class));
    	if(res == null) {
    		return null;
    	}
    	return res;
    }
    
    //查询自定义档案主键
    public static String getdefdocid(String pk_defdoclist,String docname) throws Exception{
    	String qrysql = "select pk_defdoc from bd_defdoc where pk_defdoclist = '"+pk_defdoclist+"' and docname = '"+docname+"'";
    	String res = (String) iuap.executeQuery(qrysql, new ColumnProcessor());
    	if(res == null) {
    		return "";
    	}
    	return res;
    }
    
    //查询所有公司
    public static List<Map<String,String>> getCorpList()throws Exception{
    	String sql = "select pk_corp from bd_corp where dr = 0";
		return (List<Map<String, String>>) iuap.executeQuery(sql, new MapListProcessor());
    }
    
    public static String getstordocpk(String storcode)throws Exception{
    	String sql = "select pk_stordoc from bd_stordoc where storcode = '"+storcode+"'";
    	String pk_stordoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if(pk_stordoc == null) {
    		throw new Exception("仓库"+storcode+"未查到，请检查");
    	}
    	return pk_stordoc;
    }
    
    //收发类别
  	public static String getpkrdcl(String rdcode) throws Exception {
  	  String sql="select pk_rdcl from bd_rdcl where rdcode='"+rdcode+"'  ";
  	  IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
  	  
  	  String pk_rdcl = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_rdcl == null) {
            return null;
        }
        return pk_rdcl;
  	}
  	
  	//查询项目对应的客户 pk_jobbasfil项目基本档案主键
  	public static String getJobbasfilDef1(String pk_jobbasfil) throws Exception {
  		String sql = "select def1 from bd_jobbasfil where pk_jobbasfil = '"+pk_jobbasfil+"'";
  		return (String) iuap.executeQuery(sql, new ColumnProcessor());
  	}
  	
	//查询项目对应的客户 pk_jobbasfil项目管理档案主键
  	public static String getJobbasmngDef1(String pk_jobmngfil) throws Exception {
  		String sql = "select def1 from bd_jobbasfil where pk_jobbasfil =(select pk_jobbasfil from bd_jobmngfil where pk_jobmngfil ='" + pk_jobmngfil + "') ";
  		return (String) iuap.executeQuery(sql, new ColumnProcessor());
  	}	
  	
  	
 
   	public static String getCubasdocpk(String custname)throws Exception {
   		String sql = "select pk_cubasdoc from bd_cubasdoc where custname = '"+custname+"' and dr = 0";
   		String pk_cubasdoc  = (String) iuap.executeQuery(sql, new ColumnProcessor());
   		if(pk_cubasdoc == null) {
    		throw new Exception("客商"+custname+"未查到，请检查");
    	}
    	return pk_cubasdoc;
   	}
  	
  	
  	
}
