package u8c.ui.mytest.panel;

import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.MainPanel;
import nc.ui.hr.frame.TopPanel;
import nc.ui.hr.frame.action.AddLineAction;
import nc.ui.hr.frame.action.CancelAction;
import nc.ui.hr.frame.action.DeleteLineAction;
import nc.ui.hr.frame.action.EditLineAction;
import nc.ui.hr.frame.action.RefreshAction;
import nc.ui.hr.frame.action.ReturnFromCardToListAction;
import nc.ui.hr.frame.bill.manage.ManageDataModel;
import nc.ui.hr.frame.button.AbstractBtnReg;
import nc.ui.hr.frame.button.BtnStateReg;
import nc.ui.pub.bill.BillCardPanel;
import u8c.ui.mytest.action.AddPraybillAction;
import u8c.ui.mytest.action.DemandAddAction;
import u8c.ui.mytest.action.DemandApproveAction;
import u8c.ui.mytest.action.DemandCloseAction;
import u8c.ui.mytest.action.DemandDeleteAction;
import u8c.ui.mytest.action.DemandEditAction;
import u8c.ui.mytest.action.DemandExportAction;
import u8c.ui.mytest.action.DemandImportAction;
import u8c.ui.mytest.action.DemandQueryAction;
import u8c.ui.mytest.action.DemandReturnFromCardToListAction;
import u8c.ui.mytest.action.DemandSaveAction;
import u8c.ui.mytest.action.DemandUnApproveAction;
import u8c.ui.mytest.button.DemandBtnStateReg;
import u8c.ui.mytest.datamodel.DemandDataModel;

public class DemandTestUI extends FrameUI{
	
	protected void initialize(){
		super.initialize();
	}

	@Override
	protected void initButtons() {
		// 初始化按钮
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_ADD);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EDIT);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_DELETE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_QUERY);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_REFRESH);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_SAVE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_CANCEL);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_ADD_LINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_DEL_LINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EDIT_LINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_RETURN);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EXAMINE);
		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_CANCELEXAMINE);
//		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_EXPORT);
//		getBtnManager().addButtonByID(AbstractBtnReg.SYSBTN_IMPORT);
//		getBtnManager().addButtonByID(AbstractBtnReg.USERBTN_ADDPRAYBILL);
		getBtnManager().addButtonByID(AbstractBtnReg.USERBTN_boExportImport); //导入/导出
		getBtnManager().addChildButtonsByIDs(AbstractBtnReg.USERBTN_boExportImport , 
				new int []{AbstractBtnReg.SYSBTN_EXPORT,AbstractBtnReg.SYSBTN_IMPORT});
		getBtnManager().addButtonByID(AbstractBtnReg.USERBTN_ClOSE);

		// 配置按钮动作类
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_ADD, new DemandAddAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EDIT, new DemandEditAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_DELETE, new DemandDeleteAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_QUERY, new DemandQueryAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_REFRESH, new RefreshAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_SAVE, new DemandSaveAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_CANCEL, new CancelAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_ADD_LINE, new AddLineAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EDIT_LINE, new EditLineAction(this));		
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_DEL_LINE, new DeleteLineAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_RETURN, new DemandReturnFromCardToListAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EXAMINE, new DemandApproveAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_CANCELEXAMINE, new DemandUnApproveAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_EXPORT, new DemandExportAction(this));
		getBtnManager().regCmd(AbstractBtnReg.SYSBTN_IMPORT, new DemandImportAction(this));
//		getBtnManager().regCmd(AbstractBtnReg.USERBTN_ADDPRAYBILL, new AddPraybillAction(this));
		getBtnManager().regCmd(AbstractBtnReg.USERBTN_ClOSE, new DemandCloseAction(this));

		

		// 按钮排序
		getBtnManager().adjustButtonOrder(new int[] {
				AbstractBtnReg.SYSBTN_ADD,
				AbstractBtnReg.SYSBTN_EDIT,
				AbstractBtnReg.SYSBTN_DELETE,
				AbstractBtnReg.SYSBTN_ADD_LINE,
				AbstractBtnReg.SYSBTN_EDIT_LINE,
				AbstractBtnReg.SYSBTN_DEL_LINE,
				AbstractBtnReg.SYSBTN_QUERY,
				AbstractBtnReg.SYSBTN_REFRESH, 
				AbstractBtnReg.SYSBTN_SAVE,
				AbstractBtnReg.SYSBTN_CANCEL,
				AbstractBtnReg.SYSBTN_RETURN,
				AbstractBtnReg.SYSBTN_EXAMINE,
				AbstractBtnReg.SYSBTN_CANCELEXAMINE,
				AbstractBtnReg.SYSBTN_EXPORT,
				AbstractBtnReg.SYSBTN_IMPORT,
				AbstractBtnReg.USERBTN_boExportImport,
//				AbstractBtnReg.USERBTN_ADDPRAYBILL
				AbstractBtnReg.USERBTN_ClOSE
				});
	}
	
	@Override
	protected MainPanel createMainPanel() { 
		ManageDataModel model = (ManageDataModel) getDataModel();
		return new DemandMainPanel(this,  model.getBillTempletCode(), model.getBillTempletBusiType());
	}

	@Override
	protected TopPanel createTopPanel() { 
		return new DemandTopPanel(this);
	}
	
	@Override
	protected BtnStateReg createButtonStateRegister() {
		return  new DemandBtnStateReg(getDataModel().getState());
	}
	
	@Override
	protected DemandDataModel createDataModel() {
		return new DemandDataModel();
	}

	@Override
	public boolean needLeftPanel() {
		return false;
	}

	@Override
	public boolean needTopPanel() {
		return true;
	}
	
	@Override
	public String getQueryNodeKey() { 
		return "400303";
	}
	
	@Override
	public String getModuleCode() { 
		return "400303";
	}
	
	public BillCardPanel getBillCardPanel() {
		this.getBtnManager().setButtonEnabled(AbstractBtnReg.SYSBTN_RETURN, true);
		return ((DemandMainPanel) (this.getMainPanel())).getBillCardPanel();
	}
	
}
