package u8c.bs.mytest.bp;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import nc.bs.dao.BaseDAO;
import nc.vo.pub.BusinessException;
import u8c.pubitf.rule.IValidate;
import u8c.pubitf.rule.ICompareRule;
import u8c.pubitf.rule.IRule;
import u8c.vo.AggDemandVO;
import u8c.vo.DemandBVO;
import u8c.vo.DemandVO;



public class DemanImportInsertBP{
	BaseDAO dao = new BaseDAO();
	
	
	public AggDemandVO[] save(AggDemandVO[] bills) throws BusinessException {
		if (bills != null && bills.length != 0) {
			AggDemandVO[] vos = null;
			this.execBeforeRules(bills);
			vos = this.insertBills(bills);
			this.execAfterRules(bills);
			return vos;
		} else {
			return null;
		}
	}
	
	private AggDemandVO[] insertBills(AggDemandVO[] bills) throws BusinessException {
		for (int i = 0; i < bills.length; i++) {
			DemandVO demandVO = (DemandVO) bills[i].getParentVO();
			String pk_demand = dao.insertVO(demandVO);
			DemandBVO[] demandBVOs = (DemandBVO[]) bills[i].getChildrenVO();
			for (int j = 0; j < demandBVOs.length; j++) {
				demandBVOs[j].setPk_demand(pk_demand);
				dao.insertVO(demandBVOs[j]);
			}
			
			
		}
		
		
		return bills;

	}
	
	
	//ǰ
	protected void addBeforeRule(List<Object> rules) throws BusinessException {
		// Ĭֵ
		rules.add(new DefaultValueRule());
		//ݴ
		rules.add(new SpecialDataRule());
		//У
		rules.add(new ValidateRule());	
	}

	
	//
	protected void addAfterRule(List<Object> rules) throws BusinessException {
	}

	private void execBeforeRules(AggDemandVO[] bills) throws BusinessException {
		List<Object> rules = new ArrayList();
		this.addBeforeRule(rules);
		this.execRules(rules, bills);
	}
	
	private void execAfterRules(AggDemandVO[] bills) throws BusinessException {
		List<Object> rules = new ArrayList();
		this.addAfterRule(rules);
		this.execRules(rules, bills);
	}
	
	private void execRules(List<Object> rules, AggDemandVO[] bills) throws BusinessException {
		if (null != rules && rules.size() > 0) {
			Iterator var3 = rules.iterator();

			while (var3.hasNext()) {
				Object object = var3.next();
				if (object instanceof IValidate) {
					IValidate<AggDemandVO> rule = (IValidate) object;
					rule.validate(bills);
				} else if (object instanceof IRule) {
					IRule<AggDemandVO> rule = (IRule) object;
					rule.process(bills);
				} else if (object instanceof ICompareRule) {
					ICompareRule<AggDemandVO> rule = (ICompareRule) object;
					rule.process(bills, (AggDemandVO[]) null);
				}
			}
		}

	}
}
