package u8c.bs.mytest.bp;

import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.bd.def.IDefdoc;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.bd.def.DefdocVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFDouble;
import u8c.pubitf.rule.IRule;
import u8c.vo.AggDemandVO;
import u8c.vo.DemandBVO;
import u8c.vo.DemandVO;

public class SpecialDataRule implements IRule<AggDemandVO> {

	private  IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	@Override
	public void process(AggDemandVO[] vos) throws BusinessException {
		for(int i = 0; i < vos.length; i++) {
			DemandVO headvo = (DemandVO) vos[i].getParentVO();
			Map<String,String> JobbasfilMap = getJobbasfil(headvo.getProjectid());
			CircularlyAccessibleValueObject[] bodyvos = vos[i].getChildrenVO();
			for (int j = 0; j < bodyvos.length; j++) {
				DemandBVO  demandBVO = (DemandBVO) bodyvos[j];
				//Ŀ
				demandBVO.setPrjcode(JobbasfilMap.get("jobcode"));
				//Ŀ
				demandBVO.setPrjname(JobbasfilMap.get("jobname"));
				//Ŀ
				demandBVO.setPrjtypecode(JobbasfilMap.get("jobtypecode"));
				//Ŀ
				demandBVO.setPrjtypename(JobbasfilMap.get("jobtypename"));
				//
				demandBVO.setVbatchcode(JobbasfilMap.get("jobcode"));
				Map<String,String> invbasdocMap = getInvbasdoc(demandBVO.getCmaterialcode());
				//
				demandBVO.setCmaterialname(invbasdocMap.get("invname"));
				//
				demandBVO.setSpec(invbasdocMap.get("invspec"));
				//ͺ
				demandBVO.setModel(invbasdocMap.get("invtype"));
				//
				demandBVO.setWeight(invbasdocMap.get("def1"));
				//װܳ
				demandBVO.setRound(invbasdocMap.get("def2"));
				//λ
				demandBVO.setUnitid(invbasdocMap.get("measname"));
				if(invbasdocMap.get("measnames") != null) {
					//λ
					demandBVO.setCastunitid(invbasdocMap.get("measnames"));
					//
					UFDouble number = demandBVO.getNum();
					//
					UFDouble nastnum = new UFDouble(demandBVO.getNastnum());
					if(demandBVO.getNastnum() == null) {
						throw new BusinessException(":"+demandBVO.getCmaterialcode()+"иλΪ");
					}
					//
					UFDouble result = new UFDouble(number.div(nastnum).toString(),2);
					demandBVO.setVdef13(result.toString());
				}else {
					if(demandBVO.getNastnum() != null) {
						throw new BusinessException(":"+demandBVO.getCmaterialcode()+"ûиλ");
					}
				}
				disposeDefdoc("YSɫ", demandBVO.getColor());
				disposeDefdoc("DCߣ", demandBVO.getSizing());
			}
		}
	}
	
	//ѯĿ
    public Map<String,String> getJobbasfil(String pk_jobmngfil)throws BusinessException {
    	StringBuffer sql = new StringBuffer();
    	sql.append("select");
    	sql.append(" bd_jobbasfil.jobcode as jobcode,bd_jobbasfil.jobname as jobname,bd_jobtype.jobtypecode as jobtypecode,bd_jobtype.jobtypename as jobtypename");
    	sql.append(" from");
    	sql.append(" bd_jobbasfil bd_jobbasfil");
    	sql.append(" left join bd_jobmngfil bd_jobmngfil on bd_jobbasfil.pk_jobbasfil = bd_jobmngfil.pk_jobbasfil");
    	sql.append(" left join bd_jobtype bd_jobtype on bd_jobbasfil.pk_jobtype = bd_jobtype.pk_jobtype");
    	sql.append(" WHERE");
    	sql.append(" bd_jobmngfil.pk_jobmngfil = '"+pk_jobmngfil+"'"); 
		return (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
    }
    
    //ѯ
    public Map<String,String> getInvbasdoc(String code)throws BusinessException {
    	StringBuffer sql = new StringBuffer();
    	sql.append("select");
    	sql.append(" bd_invbasdoc.invname as invname,");
    	sql.append(" bd_invbasdoc.invspec as invspec,");
    	sql.append(" bd_invbasdoc.invtype as invtype,");
    	sql.append(" bd_invbasdoc.def1 as def1,");
    	sql.append(" bd_invbasdoc.def2 as def2,");
    	sql.append(" bd_invbasdoc.def3 as def3,");
    	sql.append(" bd_measdoc.measname as measname,");
    	sql.append(" bd_measdocs.measname as measnames");
    	sql.append(" from");
    	sql.append(" bd_invbasdoc bd_invbasdoc");
    	sql.append(" left join bd_measdoc bd_measdoc  on bd_invbasdoc.pk_measdoc = bd_measdoc.pk_measdoc");
    	sql.append(" left join bd_convert bd_convert on bd_invbasdoc.pk_invbasdoc = bd_convert.pk_invbasdoc");
    	sql.append(" left join bd_measdoc bd_measdocs on bd_convert.pk_measdoc = bd_measdocs.pk_measdoc");
    	sql.append(" where");
    	sql.append(" bd_invbasdoc.invcode = '"+code+"'");
    	sql.append(" and bd_invbasdoc.dr = 0");
    	Map<String,String> map =  (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
    	if (map == null) {
        	throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1ͣ룺"+code);
        }
		return map;
    }
    
	//Զ嵵ݴ
    public  void disposeDefdoc(String doclistcode,String docname) throws BusinessException {
    	if(docname == null) {
    		return ;
    	}
    	
    	//ȡԶ嵵б
    	String sql = "select pk_defdoclist from bd_defdoclist where doclistcode = '"+doclistcode+"'";
    	String pk_defdoclist = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if(pk_defdoclist == null) {
    		throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1ͣԶ嵵б룺"+doclistcode);
    	}
        String sql1 = "select pk_defdoc,pk_defdoclist from bd_defdoc where pk_defdoclist = '"+pk_defdoclist+"' and docname ='"+docname+"'";
        String pk_defdoc = (String) iuap.executeQuery(sql1, new ColumnProcessor());
        //
        if (pk_defdoc == null) {
        	DefdocVO defdocVO = new DefdocVO();
        	//˾
        	defdocVO.setPk_corp("0001");
        	//
        	defdocVO.setDoccode(docname);
        	//
        	defdocVO.setDocname(docname);
        	//ϵͳ
        	defdocVO.setDocsystype(1);
        	defdocVO.setStatus(2);
        	IDefdoc iDefdoc = NCLocator.getInstance().lookup(IDefdoc.class);
        	iDefdoc.saveVOs(pk_defdoclist, new DefdocVO[] {defdocVO});
        }
    }

}
