package u8c.impl;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.microsoft.sqlserver.jdbc.StringUtils;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.trade.pub.IBillStatus;
import u8c.bs.servlet.service.BaseServlet;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.log.NcLog;
import u8c.vo.DemandBVO;
import u8c.vo.DemandVO;

public class DemandAddImpl extends BaseServlet implements IHttpServletAdaptor{
	private  IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	BaseDAO dao = new BaseDAO();
	UserTransaction trans;

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSON.parseObject(createStr);
			//ӿڷؽ
			JSONObject returnobj = new JSONObject();
			//json
			JSONArray result = new JSONArray();
			//json
			JSONArray errMessage = new JSONArray();
			
			String token =req.getParameter("token");
			if(!(token!=null && !token.equals("")&&("07a81a68-c60c-4ee4-83dc-25aa51a51497").equals(token))){
				errMessage.add(formatRSJsonData("ʧ","ȷͨѶǷȷ",""));
				returnobj.put("info", "ʧ");
				returnobj.put("errMessage", "ȷͨѶǷȷ");
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			trans = NCLocator.getInstance().lookup(UserTransaction.class);
			trans.begin(); //
		
			String checkresult = checkJson(json);
			if(checkresult != null){
				errMessage.add(formatRSJsonData("ʧ",checkresult,""));
				returnobj.put("info", "ʧ");
				returnobj.put("errMessage", checkresult);
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			JSONArray bodyArray = json.getJSONArray("result");
			for (Object Object : bodyArray) {
				JSONObject bodyObject = JSONObject.parseObject(Object.toString());
				String pk_corp = bodyObject.getString("pk_corp");//ƻ֯
				String vbillcode = bodyObject.getString("vbillcode");//ݺ
				String pk_demandOld = getVbillcode(vbillcode);
				if(!StringUtils.isEmpty(pk_demandOld)) {
					errMessage.add(formatRSJsonData("ʧ","ݺ"+ vbillcode +"Ѵ",""));
					returnobj.put("info", "ʧ");
					returnobj.put("errMessage", "ݺ"+ vbillcode +"Ѵ");
					returnobj.put("result", errMessage);
					resp.getWriter().write(returnobj.toString());
					NcLog.info(returnobj.toString());
					return;
				}
				String dbilldate = bodyObject.getString("dbilldate");//
				String billmaker = GetBaseDAOUtil.getUserid(bodyObject.getString("billmaker"));//Ƶ
				if(billmaker.equals("")) {
					errMessage.add(formatRSJsonData("ʧ","Ƶ"+bodyObject.getString("billmaker")+"δ鵽",""));
					returnobj.put("info", "ʧ");
					returnobj.put("errMessage", "Ƶ"+bodyObject.getString("billmaker")+"δ鵽");
					returnobj.put("result", errMessage);
					resp.getWriter().write(returnobj.toString());
					NcLog.info(returnobj.toString());
					return;
				}
				String workmanid = GetBaseDAOUtil.getPsndocid(bodyObject.getString("workmanid"));//ҵԱ
				String plandeptid = GetBaseDAOUtil.getDeptdocid(bodyObject.getString("plandeptid"));//ƻ
				String vnote = bodyObject.getString("vnote");//ע
				DemandVO headvo = new DemandVO();
				//ͷֵ
				headvo.setPk_corp(pk_corp);
				headvo.setVbillcode(vbillcode);
				headvo.setDbilldate(new UFDate(dbilldate));//
				headvo.setMakedate(new UFDate(dbilldate));//Ƶ
				headvo.setBillmaker(billmaker);
				headvo.setWorkmanid(workmanid);//ҵԱ
				headvo.setPlandeptid(plandeptid);
				headvo.setVnote(vnote);//ע
				headvo.setVdef30(bodyObject.getString("vdef30"));//ҵ
				headvo.setBillstatus(IBillStatus.FREE);
				String pk_demand = dao.insertVO(headvo);
				//帳ֵ
				if(bodyObject.getJSONArray("po")!=null) {
					JSONArray inArray = bodyObject.getJSONArray("po");
					for(int i = 0;i < inArray.size();i++) {
						Object inobj = inArray.get(i);
						JSONObject injsobj = JSONObject.parseObject(inobj.toString());
						String prjcode = injsobj.getString("prjcode");//Ŀ
						String prjname = GetBaseDAOUtil.getprojectname(prjcode);//Ŀ
						String prjtypecode = GetBaseDAOUtil.getprjtypecode(prjcode);//Ŀ
						String prjtypename = GetBaseDAOUtil.getprjtypename(prjcode);//Ŀ
						String vbatchcode = injsobj.getString("vbatchcode");//
						String cmaterialcode = SqlexecuteQuery("invcode","bd_invbasdoc","invcode",injsobj.getString("cmaterialcode"));//
						String cmaterialname = GetBaseDAOUtil.getinvname(cmaterialcode);//
						String spec = GetBaseDAOUtil.getinvspec(cmaterialcode);//
						String model = GetBaseDAOUtil.getinvtype(cmaterialcode);//ͺ
						String width = GetBaseDAOUtil.getwidth(cmaterialcode);//
						String height = GetBaseDAOUtil.getheight(cmaterialcode);//߶
						String unitid = GetBaseDAOUtil.getmeasname(cmaterialcode);//λ
						String vdef1 = injsobj.getString("vdef1");//¥¥
						String vdef2 = injsobj.getString("vdef2");//() 
						String vdef3 = injsobj.getString("vdef3");//ͳ
						String vdef4 = injsobj.getString("vdef4");//ͳ
						String vdef5 = injsobj.getString("vdef5");//Ʒ
						String vdef6 = injsobj.getString("vdef6");//
						String vdef7 = injsobj.getString("vdef7");//и
						String vdef8 = injsobj.getString("vdef8");//иǶ
						String vdef9 = injsobj.getString("vdef9");//иǶ
						String vdef10 = injsobj.getString("vdef10");//ע
						String vdef11 = injsobj.getString("vdef11");//ϵ
						String vdef12 = injsobj.getString("vdef12");//
						DemandBVO bodyvo = new DemandBVO();
						bodyvo.setPrjcode(prjcode);;
						bodyvo.setPrjname(prjname);
						bodyvo.setPrjtypecode(prjtypecode);
						bodyvo.setPrjtypename(prjtypename);
						bodyvo.setVbatchcode(vbatchcode);
						bodyvo.setCmaterialcode(cmaterialcode);
						bodyvo.setCmaterialname(cmaterialname);
						bodyvo.setSpec(spec);
						bodyvo.setModel(model);
						bodyvo.setWidth(width);
						bodyvo.setHeight(height);
						bodyvo.setUnitid(unitid);
						bodyvo.setNum(new UFDouble(injsobj.getString("num")));//
						bodyvo.setPk_demand(pk_demand);
						bodyvo.setVdef1(vdef1);
						bodyvo.setVdef2(vdef2);
						bodyvo.setVdef3(vdef3);
						bodyvo.setVdef4(vdef4);
						bodyvo.setVdef5(vdef5);
						bodyvo.setVdef6(vdef6);
						bodyvo.setVdef7(vdef7);
						bodyvo.setVdef8(vdef8);
						bodyvo.setVdef9(vdef9);
						bodyvo.setVdef10(vdef10);
						bodyvo.setVdef11(vdef11);
						bodyvo.setVdef12(vdef12);
						dao.insertVO(bodyvo);
					}
				}
				result.add(formatRSJsonData("ɹ","",vbillcode));
			}
			returnobj.put("info", "ɹ");
			returnobj.put("errMessage", "");
			returnobj.put("result", result);
			trans.commit();//ύ
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
		} catch (Exception e) {
			try {
				trans.rollback();//
			} catch (Exception e1) {
				e1.printStackTrace();
			} 
			JSONArray errMessage = new JSONArray();
			JSONObject returnobj = new JSONObject();
			errMessage.add(formatRSJsonData("ʧ",e.getMessage(),""));
			returnobj.put("info", "ʧ");
			returnobj.put("errMessage", e.getMessage());
			returnobj.put("result", errMessage);
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
			return;
		}
	}

	
	// ѯݺ
    public  String getVbillcode(String vbillcode) throws Exception {
        String sql = "select pk_demand from po_demand where vbillcode ='"+vbillcode+"' and isnull(dr,0) = 0";
        String pk_demand = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_demand == null) {
            return "";
        }
        return pk_demand;
    }
    
    
	/*
	 * ݿѯ
	 */
	private String SqlexecuteQuery(String out,String table,String key,String value) throws Exception {
		String sql = "select "+out+" from "+table+" where "+key+" = '"+value+"' and isnull(dr,0) = 0";	
		Object object;
		try {
			object =  new BaseDAO().executeQuery(sql, new ColumnProcessor());
			if (object==null) {
				throw new Exception("δѯݣ"+value+"Ƿȷ");
			}	
			return object.toString();
		} catch (BusinessException e) {
			e.printStackTrace();
			return e.getMessage();
		}
	}
	
	
	/*
	 * ǿж
	 */
	private String checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		String body = "result";//
		
		if (json.getJSONArray(body)==null) {
			empty = false;
			mags.append("봫ӿݣ ");
			return mags.toString();
		}
		
		JSONArray oprepObjectBs = json.getJSONArray("result");
		
		String vbillcode = "vbillcode";//ݺ
		String pk_corp = "pk_corp";//֯
		String billmaker = "billmaker";//Ƶ
		String dbilldate = "dbilldate";//
		
		String po = "po";//
 
		for(int i = 0; i < oprepObjectBs.size(); i++) {
			JSONObject oprepJsonObjectB = oprepObjectBs.getJSONObject(i);
			String[] HeadKey = {vbillcode,pk_corp,billmaker,dbilldate};
			int num = i+1;
			
			mags.append(""+num+"ͷ{");
			for (String as : HeadKey) {

				if (oprepJsonObjectB.getString(as).isEmpty()) {
					empty = false;
					mags.append("'" + as + "' ");
				}
			}
			mags.append("}");
			
			if(oprepJsonObjectB.getJSONArray(po)==null) {
				mags.append(""+num+"岻Ϊ");
			}
		}
		
		if (!empty) {
			return "ֶβΪգ"+mags;
		}
		else {
			return null;
		}
	}

}
