package u8c.bs.stock.bp;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import nc.bs.dao.BaseDAO;
import nc.vo.SafetystockVO;
import nc.vo.pub.BusinessException;
import u8c.pubitf.rule.ICompareRule;
import u8c.pubitf.rule.IRule;
import u8c.pubitf.rule.IValidate;

public class SafetystockImportInsetBP {
	BaseDAO dao = new BaseDAO();

	public SafetystockVO[] save(SafetystockVO[] bills) throws BusinessException {
		if (bills != null && bills.length != 0) {
			SafetystockVO[] vos = null;
			this.execBeforeRules(bills);
			vos = this.insertBills(bills);
			this.execAfterRules(bills);
			return vos;
		} else {
			return null;
		}
	}

	private SafetystockVO[] insertBills(SafetystockVO[] bills) throws BusinessException {
		for (int i = 0; i < bills.length; i++) {
			SafetystockVO safetystockVO = bills[i];
			String pk_demand = dao.insertVO(safetystockVO);
		}
		return bills;
	}

	protected void addBeforeRule(List<Object> rules) throws BusinessException {
		// Ĭֵ
		rules.add(new DefaultValueRule());
		//ݴ
		rules.add(new SpecialDataRule());
		//У
		rules.add(new ValidateRule());
	}

	protected void addAfterRule(List<Object> rules) throws BusinessException {
	}

	private void execBeforeRules(SafetystockVO[] bills) throws BusinessException {
		List<Object> rules = new ArrayList();
		this.addBeforeRule(rules);
		this.execRules(rules, bills);
	}

	private void execAfterRules(SafetystockVO[] bills) throws BusinessException {
		List<Object> rules = new ArrayList();
		this.addAfterRule(rules);
		this.execRules(rules, bills);
	}

	private void execRules(List<Object> rules, SafetystockVO[] bills) throws BusinessException {
		if (null != rules && rules.size() > 0) {
			Iterator var3 = rules.iterator();

			while (var3.hasNext()) {
				Object object = var3.next();
				if (object instanceof IValidate) {
					IValidate<SafetystockVO> rule = (IValidate) object;
					rule.validate(bills);
				} else if (object instanceof IRule) {
					IRule<SafetystockVO> rule = (IRule) object;
					rule.process(bills);
				} else if (object instanceof ICompareRule) {
					ICompareRule<SafetystockVO> rule = (ICompareRule) object;
					rule.process(bills, (SafetystockVO[]) null);
				}
			}
		}

	}

}
