package u8c.bs.stock.bp;

import java.util.Map;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.bd.def.IDefdoc;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.SafetystockVO;
import nc.vo.bd.def.DefdocVO;
import nc.vo.pub.BusinessException;
import u8c.pubitf.rule.IRule;


/**
 *	ݴ
 * @author 
 *
 */
public class SpecialDataRule implements IRule<SafetystockVO>{
	private  IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	@Override
	public void process(SafetystockVO[] vos) throws BusinessException {
		String w = InvocationInfoProxy.getInstance().getLangCode();
		for(int i = 0; i < vos.length; i++) {
			SafetystockVO headvo =  vos[i];
			Map<String,String> invbasdocMap = getInvbasdoc(headvo.getCmaterialcode());
			//
			headvo.setCmaterialname(invbasdocMap.get("invname"));
			//
			headvo.setCmaterialcode(invbasdocMap.get("pk_invmandoc"));
			//
			headvo.setSpec(invbasdocMap.get("invspec"));
			//ͺ
			headvo.setModel(invbasdocMap.get("invtype"));
			//ܴ
			disposeDefdoc("YSɫ", headvo.getColor());
			disposeDefdoc("DCߣ", headvo.getSizing());
			//Ӧpk
			headvo.setColor(getDefdocPK("YSɫ", headvo.getColor()));
			headvo.setSizing(getDefdocPK("DCߣ", headvo.getSizing()));
			headvo.setAlloy(getDefdocPK("HJϽ", headvo.getAlloy()));
			headvo.setStandard(getDefdocPK("BZ׼", headvo.getStandard()));
			
		}
	}
	
    
    //ѯ
    public Map<String,String> getInvbasdoc(String code)throws BusinessException {
    	StringBuffer sql = new StringBuffer();
    	sql.append("SELECT");
    	sql.append(" bd_invbasdoc.invname as invname,");
    	sql.append(" bd_invbasdoc.invspec as invspec,");
    	sql.append(" bd_invbasdoc.invtype as invtype,");
    	sql.append(" bd_invbasdoc.def1 as def1,");
    	sql.append(" bd_invbasdoc.def2 as def2,");
    	sql.append(" bd_invbasdoc.def3 as def3,");
    	sql.append(" bd_measdoc.measname as measname,");
    	sql.append(" bd_measdocs.measname as measnames,");
    	sql.append(" bd_invmandoc.pk_invmandoc as pk_invmandoc");
    	sql.append(" FROM");
    	sql.append(" bd_invbasdoc bd_invbasdoc");
    	sql.append(" left join bd_measdoc bd_measdoc  on bd_invbasdoc.pk_measdoc = bd_measdoc.pk_measdoc");
    	sql.append(" left join bd_convert bd_convert on bd_invbasdoc.pk_invbasdoc = bd_convert.pk_invbasdoc");
    	sql.append(" left join bd_measdoc bd_measdocs on bd_convert.pk_measdoc = bd_measdocs.pk_measdoc");
    	sql.append(" left join bd_invmandoc bd_invmandoc on bd_invbasdoc.pk_invbasdoc = bd_invmandoc.pk_invbasdoc");
    	sql.append(" WHERE");
    	sql.append(" bd_invbasdoc.invcode = '"+code+"'");
    	sql.append(" and bd_invbasdoc.dr = 0");
    	Map<String,String> map =  (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
    	if (map == null) {
        	throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1ͣ룺"+code);
        }
		return map;
    }
    
    
	//Զ嵵ݴ
    public  void disposeDefdoc(String doclistcode,String docname) throws BusinessException {
    	if(docname == null) {
    		return ;
    	}
    	//ȡԶ嵵б
    	String sql = "select pk_defdoclist from bd_defdoclist where doclistcode = '"+doclistcode+"'";
    	String pk_defdoclist = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if(pk_defdoclist == null) {
    		throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1ͣԶ嵵б룺"+doclistcode);
    	}
        String sql1 = "select pk_defdoc,pk_defdoclist from bd_defdoc where pk_defdoclist = '"+pk_defdoclist+"' and docname ='"+docname+"'";
        String pk_defdoc = (String) iuap.executeQuery(sql1, new ColumnProcessor());
        //
        if (pk_defdoc == null) {
        	DefdocVO defdocVO = new DefdocVO();
        	//˾                  
        	defdocVO.setPk_corp("0001");
        	//
        	defdocVO.setDoccode(docname);
        	//
        	defdocVO.setDocname(docname);
        	//ϵͳ
        	defdocVO.setDocsystype(1);
        	defdocVO.setStatus(2);
        	IDefdoc iDefdoc = NCLocator.getInstance().lookup(IDefdoc.class);
        	iDefdoc.saveVOs(pk_defdoclist, new DefdocVO[] {defdocVO});
        }
    }
    
	// ѯԶ嵵ȡӦpk
	public String getDefdocPK(String doclistcode, String docname) throws BusinessException {
		if (docname == null) {
			return null;
		}
		String sql = "select pk_defdoc from bd_defdoc where pk_defdoclist = (select pk_defdoclist from bd_defdoclist where doclistcode = '"
				+ doclistcode + "') and docname ='" + docname + "'";
		String pk_defdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (pk_defdoc == null) {
			throw new BusinessException("µU8cloudϵͳиݹ˾˲ϢҲ飡ϸϢ1 Զ嵵ƣ" + docname + "");
		}
		return pk_defdoc;
	}
}
