package u8c.bs.stock.bp;

import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.SafetystockVO;
import nc.vo.pub.BusinessException;
import u8c.pubitf.rule.IRule;

/**
 * У
 * 
 * @author
 *
 */
public class ValidateRule implements IRule<SafetystockVO> {

	private IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);

	@Override
	public void process(SafetystockVO[] vos) throws BusinessException {
		for (int i = 0; i < vos.length; i++) {
			SafetystockVO safetystockVO = vos[i];
			Map<String, String> map = getInvbasdoc(safetystockVO.getCmaterialcode());
			// ɫ
			String free1 = map.get("free1");
			if (free1 == null) {
				if (safetystockVO.getColor() != null) {
					throw new BusinessException("" + safetystockVO.getCmaterialcode() + "ûɫ,ɫ");
				}
			} else {
				if (safetystockVO.getColor() == null) {
					throw new BusinessException("" + safetystockVO.getCmaterialcode() + "ɫ,ɫΪ");
				}
			}
			// 
			String free3 = map.get("free3");
			if (free3 == null) {
				if (safetystockVO.getSizing() != null) {
					throw new BusinessException("" + safetystockVO.getCmaterialcode() + "ûö,߲");
				}
			} else {
				if (safetystockVO.getSizing() == null) {
					throw new BusinessException("" + safetystockVO.getCmaterialcode() + "˶,߲Ϊ");
				}
			}
			// Ͻ
			String free2 = map.get("free2");
			if (free2 == null) {
				if (safetystockVO.getAlloy() != null) {
					throw new BusinessException("" + safetystockVO.getCmaterialcode() + "ûúϽ,Ͻ");
				}
			} else {
				if (safetystockVO.getAlloy() == null) {
					throw new BusinessException("" + safetystockVO.getCmaterialcode() + "˺Ͻ,ϽΪ");
				}
			}
			// ׼
			String free4 = map.get("free4");
			if (free4 == null) {
				if (safetystockVO.getStandard() != null) {
					throw new BusinessException("" + safetystockVO.getCmaterialcode() + "ûñ׼,׼");
				}
			} else {
				if (safetystockVO.getStandard() == null) {
					throw new BusinessException("" + safetystockVO.getCmaterialcode() + "˱׼,׼Ϊ");
				}
			}
		}
	}



	public Map<String, String> getInvbasdoc(String cmaterialcode) throws BusinessException {
		String sql = "select free1,free2,free3,free4 from bd_invbasdoc where pk_invbasdoc  = (select pk_invbasdoc from bd_invmandoc where pk_invmandoc='"+cmaterialcode+"') and dr = 0";
		return (Map<String, String>) iuap.executeQuery(sql.toString(), new MapProcessor());
	}

}
